/*

  Structs.h: generated by VRMLC.pm. DO NOT MODIFY, MODIFY VRMLC.pm INSTEAD.

  Code here comes almost verbatim from VRMLC.pm

*/

/****************************************************************************
    This file is part of the FreeWRL/FreeX3D Distribution.

    Copyright 2009 CRC Canada. (http://www.crc.gc.ca)

    FreeWRL/FreeX3D is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    FreeWRL/FreeX3D is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FreeWRL/FreeX3D.  If not, see <http://www.gnu.org/licenses/>.
****************************************************************************/



#ifndef __FREEWRL_STRUCTS_H__
#define __FREEWRL_STRUCTS_H__

#include <system_threads.h>
struct point_XYZ {GLDOUBLE x,y,z;};
struct orient_XYZA {GLDOUBLE x,y,z,a;};

struct X3D_Virt {
	void (*prep)(void *);
	void (*rend)(void *);
	void (*children)(void *);
	void (*fin)(void *);
	void (*rendray)(void *);
	void (*mkpolyrep)(void *);
	void (*proximity)(void *);
	void (*other)(void *);
	void (*collision)(void *);
	void (*compile)(void *, void *, void *, void *, void *, void *);
};

/* a string is stored as a pointer, and a length of that mallocd pointer */
struct Uni_String {
	int len;
	char * strptr;
	int touched;
};


/* Internal representation of IndexedFaceSet, Text, Extrusion & ElevationGrid:
 * set of triangles.
 * done so that we get rid of concave polygons etc.
 */
struct X3D_PolyRep { /* Currently a bit wasteful, because copying */
	int irep_change;
	int ccw;	/* ccw field for single faced structures */
	int ntri; /* number of triangles */
	int streamed;	/* is this done the streaming pass? */

	/* indicies for arrays. OpenGL ES 2.0 - unsigned short for the DrawArrays call */
	GLuint *cindex;   /* triples (per triangle) */
	GLuint *colindex;   /* triples (per triangle) */
	GLuint *norindex;
	GLuint *tcindex; /* triples or null */
	ushort *tri_indices;
	ushort *wire_indices;

	float *actualCoord; /* triples (per point) */
	float *actualFog; /* float (per point) */
	float *color; /* triples or null */
	float *normal; /* triples or null */
	float *flat_normal; /*triples or null*/
	int last_normal_type; /* 0=regular 1=flat last normal type we put in the vbo normal buffer */
	int last_index_type; /* 0=regular 1=wire last vertex index type we put in the vbo index buffer */
	float *GeneratedTexCoords[4];	/* triples (per triangle) of texture coords if there is no texCoord node */
	int ntexdim[4];  /* number of texture coordinate dimensions, normally 2 xy, 3 xyz, 4 xyzw */
	int ntcoord;		/* number of multitextureCoordinates */
	int tcoordtype; /* type of texture coord node - is this a NODE_TextureCoordGenerator... */
	int texgentype; /* if we do have a TextureCoordinateGenerator, what "TCGT_XXX" type is it? */
	GLfloat minVals[3];		/* for collision and default texture coord generation */
	GLfloat maxVals[3];		/* for collision and default texture coord generation */
	GLfloat transparency;		/* what the transparency value was during compile, put in color array if RGBA colors */
	int isRGBAcolorNode;		/* color was originally an RGBA, DO NOT re-write if transparency changes */
	GLuint VBO_buffers[VBO_COUNT];		/* VBO indexen */
};

/* viewer dimentions (for collision detection) */
struct sNaviInfo {
        double width;
        double height;
        double step;
};

/* definitions to help scanning values in from a string */ 
#define SCANTONUMBER(value) while (isspace(*value) || (*value==',')) value++; 
#define SCANTOSTRING(value) while (isspace(*value) || (*value==',')) value++; 
#define OLDSCANTOSTRING(value) while ((*value==' ') || (*value==',')) value++; 
#define ISSTARTNUMBER(value) (isdigit(*value) \
		|| (*value == '+') || (*value == '-')) 
#define SCANPASTFLOATNUMBER(value) while (isdigit(*value) \
		|| (*value == '.') || \
		(*value == 'E') || (*value == 'e') || (*value == '+') || (*value == '-')) value++; 
#define SCANPASTINTNUMBER(value) if (isdigit(*value) || (*value == '-') || (*value == '+')) value++; \
		while (isdigit(*value) || \
		(*value == 'x') || (*value == 'X') ||\
		((*value >='a') && (*value <='f')) || \
		((*value >='A') && (*value <='F')) || \
		(*value == '-') || (*value == '+')) value++; 
/* Data type for index into ID-table. */
typedef int indexT;

#define NODE_Anchor	0
#define NODE_Appearance	1
#define NODE_Arc2D	2
#define NODE_ArcClose2D	3
#define NODE_AudioClip	4
#define NODE_BackdropBackground	5
#define NODE_Background	6
#define NODE_BallJoint	7
#define NODE_Billboard	8
#define NODE_BlendedVolumeStyle	9
#define NODE_BooleanFilter	10
#define NODE_BooleanSequencer	11
#define NODE_BooleanToggle	12
#define NODE_BooleanTrigger	13
#define NODE_BoundaryEnhancementVolumeStyle	14
#define NODE_BoundedPhysicsModel	15
#define NODE_Box	16
#define NODE_CADAssembly	17
#define NODE_CADFace	18
#define NODE_CADLayer	19
#define NODE_CADPart	20
#define NODE_CalibratedCameraSensor	21
#define NODE_CartoonVolumeStyle	22
#define NODE_Circle2D	23
#define NODE_ClipPlane	24
#define NODE_CollidableOffset	25
#define NODE_CollidableShape	26
#define NODE_Collision	27
#define NODE_CollisionCollection	28
#define NODE_CollisionSensor	29
#define NODE_CollisionSpace	30
#define NODE_Color	31
#define NODE_ColorChaser	32
#define NODE_ColorDamper	33
#define NODE_ColorInterpolator	34
#define NODE_ColorRGBA	35
#define NODE_ComposedCubeMapTexture	36
#define NODE_ComposedShader	37
#define NODE_ComposedTexture3D	38
#define NODE_ComposedVolumeStyle	39
#define NODE_CompositeVolumeStyle	40
#define NODE_Cone	41
#define NODE_ConeEmitter	42
#define NODE_Contact	43
#define NODE_Contour2D	44
#define NODE_ContourPolyline2D	45
#define NODE_Coordinate	46
#define NODE_CoordinateChaser	47
#define NODE_CoordinateDamper	48
#define NODE_CoordinateDouble	49
#define NODE_CoordinateInterpolator	50
#define NODE_CoordinateInterpolator2D	51
#define NODE_Cylinder	52
#define NODE_CylinderSensor	53
#define NODE_DISEntityManager	54
#define NODE_DISEntityTypeMapping	55
#define NODE_DirectionalLight	56
#define NODE_Disk2D	57
#define NODE_DoubleAxisHingeJoint	58
#define NODE_EaseInEaseOut	59
#define NODE_EdgeEnhancementVolumeStyle	60
#define NODE_Effect	61
#define NODE_EffectPart	62
#define NODE_ElevationGrid	63
#define NODE_EspduTransform	64
#define NODE_ExplosionEmitter	65
#define NODE_Extrusion	66
#define NODE_FillProperties	67
#define NODE_FloatVertexAttribute	68
#define NODE_Fog	69
#define NODE_FogCoordinate	70
#define NODE_FontStyle	71
#define NODE_ForcePhysicsModel	72
#define NODE_GeneratedCubeMapTexture	73
#define NODE_GeoCoordinate	74
#define NODE_GeoElevationGrid	75
#define NODE_GeoLOD	76
#define NODE_GeoLocation	77
#define NODE_GeoMetadata	78
#define NODE_GeoOrigin	79
#define NODE_GeoPositionInterpolator	80
#define NODE_GeoProximitySensor	81
#define NODE_GeoTouchSensor	82
#define NODE_GeoTransform	83
#define NODE_GeoViewpoint	84
#define NODE_Group	85
#define NODE_HAnimDisplacer	86
#define NODE_HAnimHumanoid	87
#define NODE_HAnimJoint	88
#define NODE_HAnimSegment	89
#define NODE_HAnimSite	90
#define NODE_ImageBackdropBackground	91
#define NODE_ImageCubeMapTexture	92
#define NODE_ImageTexture	93
#define NODE_ImageTexture3D	94
#define NODE_IndexedFaceSet	95
#define NODE_IndexedLineSet	96
#define NODE_IndexedQuadSet	97
#define NODE_IndexedTriangleFanSet	98
#define NODE_IndexedTriangleSet	99
#define NODE_IndexedTriangleStripSet	100
#define NODE_Inline	101
#define NODE_IntegerSequencer	102
#define NODE_IntegerTrigger	103
#define NODE_IsoSurfaceVolumeData	104
#define NODE_KeySensor	105
#define NODE_LOD	106
#define NODE_Layer	107
#define NODE_LayerSet	108
#define NODE_Layout	109
#define NODE_LayoutGroup	110
#define NODE_LayoutLayer	111
#define NODE_LinePickSensor	112
#define NODE_LineProperties	113
#define NODE_LineSensor	114
#define NODE_LineSet	115
#define NODE_LoadSensor	116
#define NODE_LocalFog	117
#define NODE_Material	118
#define NODE_Matrix3VertexAttribute	119
#define NODE_Matrix4VertexAttribute	120
#define NODE_MetadataBoolean	121
#define NODE_MetadataDouble	122
#define NODE_MetadataFloat	123
#define NODE_MetadataInteger	124
#define NODE_MetadataMFBool	125
#define NODE_MetadataMFColor	126
#define NODE_MetadataMFColorRGBA	127
#define NODE_MetadataMFDouble	128
#define NODE_MetadataMFFloat	129
#define NODE_MetadataMFInt32	130
#define NODE_MetadataMFMatrix3d	131
#define NODE_MetadataMFMatrix3f	132
#define NODE_MetadataMFMatrix4d	133
#define NODE_MetadataMFMatrix4f	134
#define NODE_MetadataMFNode	135
#define NODE_MetadataMFRotation	136
#define NODE_MetadataMFString	137
#define NODE_MetadataMFTime	138
#define NODE_MetadataMFVec2d	139
#define NODE_MetadataMFVec2f	140
#define NODE_MetadataMFVec3d	141
#define NODE_MetadataMFVec3f	142
#define NODE_MetadataMFVec4d	143
#define NODE_MetadataMFVec4f	144
#define NODE_MetadataSFBool	145
#define NODE_MetadataSFColor	146
#define NODE_MetadataSFColorRGBA	147
#define NODE_MetadataSFDouble	148
#define NODE_MetadataSFFloat	149
#define NODE_MetadataSFImage	150
#define NODE_MetadataSFInt32	151
#define NODE_MetadataSFMatrix3d	152
#define NODE_MetadataSFMatrix3f	153
#define NODE_MetadataSFMatrix4d	154
#define NODE_MetadataSFMatrix4f	155
#define NODE_MetadataSFNode	156
#define NODE_MetadataSFRotation	157
#define NODE_MetadataSFString	158
#define NODE_MetadataSFTime	159
#define NODE_MetadataSFVec2d	160
#define NODE_MetadataSFVec2f	161
#define NODE_MetadataSFVec3d	162
#define NODE_MetadataSFVec3f	163
#define NODE_MetadataSFVec4d	164
#define NODE_MetadataSFVec4f	165
#define NODE_MetadataSet	166
#define NODE_MetadataString	167
#define NODE_MotorJoint	168
#define NODE_MovieTexture	169
#define NODE_MultiTexture	170
#define NODE_MultiTextureCoordinate	171
#define NODE_MultiTextureTransform	172
#define NODE_NavigationInfo	173
#define NODE_Normal	174
#define NODE_NormalInterpolator	175
#define NODE_NurbsCurve	176
#define NODE_NurbsCurve2D	177
#define NODE_NurbsOrientationInterpolator	178
#define NODE_NurbsPatchSurface	179
#define NODE_NurbsPositionInterpolator	180
#define NODE_NurbsSet	181
#define NODE_NurbsSurfaceInterpolator	182
#define NODE_NurbsSweptSurface	183
#define NODE_NurbsSwungSurface	184
#define NODE_NurbsTextureCoordinate	185
#define NODE_NurbsTrimmedSurface	186
#define NODE_OSC_Sensor	187
#define NODE_OpacityMapVolumeStyle	188
#define NODE_OrientationChaser	189
#define NODE_OrientationDamper	190
#define NODE_OrientationInterpolator	191
#define NODE_OrthoViewpoint	192
#define NODE_PackagedShader	193
#define NODE_ParticleSystem	194
#define NODE_PickableGroup	195
#define NODE_PixelTexture	196
#define NODE_PixelTexture3D	197
#define NODE_PlaneSensor	198
#define NODE_PointEmitter	199
#define NODE_PointLight	200
#define NODE_PointPickSensor	201
#define NODE_PointSet	202
#define NODE_Polyline2D	203
#define NODE_PolylineEmitter	204
#define NODE_Polypoint2D	205
#define NODE_PositionChaser	206
#define NODE_PositionChaser2D	207
#define NODE_PositionDamper	208
#define NODE_PositionDamper2D	209
#define NODE_PositionInterpolator	210
#define NODE_PositionInterpolator2D	211
#define NODE_PrimitivePickSensor	212
#define NODE_ProgramShader	213
#define NODE_ProjectionVolumeStyle	214
#define NODE_Proto	215
#define NODE_ProximitySensor	216
#define NODE_QuadSet	217
#define NODE_ReceiverPdu	218
#define NODE_Rectangle2D	219
#define NODE_RigidBody	220
#define NODE_RigidBodyCollection	221
#define NODE_ScalarChaser	222
#define NODE_ScalarDamper	223
#define NODE_ScalarInterpolator	224
#define NODE_ScreenFontStyle	225
#define NODE_ScreenGroup	226
#define NODE_Script	227
#define NODE_SegmentedVolumeData	228
#define NODE_ShadedVolumeStyle	229
#define NODE_ShaderPart	230
#define NODE_ShaderProgram	231
#define NODE_Shape	232
#define NODE_SignalPdu	233
#define NODE_SilhouetteEnhancementVolumeStyle	234
#define NODE_SingleAxisHingeJoint	235
#define NODE_SliderJoint	236
#define NODE_Sound	237
#define NODE_Sphere	238
#define NODE_SphereSensor	239
#define NODE_SplinePositionInterpolator	240
#define NODE_SplinePositionInterpolator2D	241
#define NODE_SplineScalarInterpolator	242
#define NODE_SpotLight	243
#define NODE_SquadOrientationInterpolator	244
#define NODE_StaticGroup	245
#define NODE_StringSensor	246
#define NODE_SurfaceEmitter	247
#define NODE_Switch	248
#define NODE_Teapot	249
#define NODE_TexCoordChaser2D	250
#define NODE_TexCoordDamper2D	251
#define NODE_Text	252
#define NODE_TextureBackground	253
#define NODE_TextureCoordinate	254
#define NODE_TextureCoordinate3D	255
#define NODE_TextureCoordinate4D	256
#define NODE_TextureCoordinateGenerator	257
#define NODE_TextureProperties	258
#define NODE_TextureTransform	259
#define NODE_TextureTransform3D	260
#define NODE_TextureTransformMatrix3D	261
#define NODE_TimeSensor	262
#define NODE_TimeTrigger	263
#define NODE_ToneMappedVolumeStyle	264
#define NODE_TouchSensor	265
#define NODE_TrackingSensor	266
#define NODE_Transform	267
#define NODE_TransformSensor	268
#define NODE_TransmitterPdu	269
#define NODE_TriangleFanSet	270
#define NODE_TriangleSet	271
#define NODE_TriangleSet2D	272
#define NODE_TriangleStripSet	273
#define NODE_TwoSidedMaterial	274
#define NODE_UniversalJoint	275
#define NODE_Viewpoint	276
#define NODE_ViewpointGroup	277
#define NODE_Viewport	278
#define NODE_VisibilitySensor	279
#define NODE_VolumeData	280
#define NODE_VolumeEmitter	281
#define NODE_VolumePickSensor	282
#define NODE_WindPhysicsModel	283
#define NODE_WorldInfo	284


/* Table of built-in fieldIds */
extern const char *FIELDNAMES[];
extern const int FIELDNAMES_COUNT;
#define FIELDNAMES_FIFOsize	0
#define FIELDNAMES__CPU_Routes_out	1
#define FIELDNAMES__GPU_Routes_out	2
#define FIELDNAMES__JT	3
#define FIELDNAMES__NV	4
#define FIELDNAMES__OK	5
#define FIELDNAMES__PVI	6
#define FIELDNAMES__PVW	7
#define FIELDNAMES__T0	8
#define FIELDNAMES__T1	9
#define FIELDNAMES___DEFnames	10
#define FIELDNAMES___EXPORTS	11
#define FIELDNAMES___GC	12
#define FIELDNAMES___IMPORTS	13
#define FIELDNAMES___IS	14
#define FIELDNAMES___ROUTES	15
#define FIELDNAMES___Samples	16
#define FIELDNAMES___SphereIndxVBO	17
#define FIELDNAMES___StartLoadTime	18
#define FIELDNAMES___VBO	19
#define FIELDNAMES___afterPound	20
#define FIELDNAMES___backTexture	21
#define FIELDNAMES___botpoints	22
#define FIELDNAMES___bottomTexture	23
#define FIELDNAMES___child1Node	24
#define FIELDNAMES___child2Node	25
#define FIELDNAMES___child3Node	26
#define FIELDNAMES___child4Node	27
#define FIELDNAMES___childloadstatus	28
#define FIELDNAMES___children	29
#define FIELDNAMES___colours	30
#define FIELDNAMES___coneTriangles	31
#define FIELDNAMES___coneVBO	32
#define FIELDNAMES___ctex	33
#define FIELDNAMES___ctflag	34
#define FIELDNAMES___cylinderTriangles	35
#define FIELDNAMES___cylinderVBO	36
#define FIELDNAMES___do_anything	37
#define FIELDNAMES___do_center	38
#define FIELDNAMES___do_rotation	39
#define FIELDNAMES___do_scale	40
#define FIELDNAMES___do_scaleO	41
#define FIELDNAMES___do_trans	42
#define FIELDNAMES___externProtoDeclares	43
#define FIELDNAMES___finishedloading	44
#define FIELDNAMES___fogScale	45
#define FIELDNAMES___fogType	46
#define FIELDNAMES___frac	47
#define FIELDNAMES___frontTexture	48
#define FIELDNAMES___fw_movie	49
#define FIELDNAMES___geoSystem	50
#define FIELDNAMES___highest	51
#define FIELDNAMES___hit	52
#define FIELDNAMES___ifsnode	53
#define FIELDNAMES___inRange	54
#define FIELDNAMES___inittime	55
#define FIELDNAMES___isX3D	56
#define FIELDNAMES___lastlocation	57
#define FIELDNAMES___lasttime	58
#define FIELDNAMES___leftTexture	59
#define FIELDNAMES___level	60
#define FIELDNAMES___loadResource	61
#define FIELDNAMES___loading	62
#define FIELDNAMES___loadstatus	63
#define FIELDNAMES___localOrient	64
#define FIELDNAMES___lowest	65
#define FIELDNAMES___movedCoords	66
#define FIELDNAMES___movedOrientation	67
#define FIELDNAMES___movedPosition	68
#define FIELDNAMES___movedValue	69
#define FIELDNAMES___nodes	70
#define FIELDNAMES___normals	71
#define FIELDNAMES___numPoints	72
#define FIELDNAMES___occludeCheckCount	73
#define FIELDNAMES___oldChildren	74
#define FIELDNAMES___oldEnabled	75
#define FIELDNAMES___oldFieldOfView	76
#define FIELDNAMES___oldGeoCenter	77
#define FIELDNAMES___oldHeadlight	78
#define FIELDNAMES___oldJump	79
#define FIELDNAMES___oldKeyPtr	80
#define FIELDNAMES___oldKeyValuePtr	81
#define FIELDNAMES___oldMFString	82
#define FIELDNAMES___oldSFString	83
#define FIELDNAMES___oldSize	84
#define FIELDNAMES___old_anchorPoint	85
#define FIELDNAMES___old_angularVelocity	86
#define FIELDNAMES___old_axis	87
#define FIELDNAMES___old_axis1	88
#define FIELDNAMES___old_axis1Angle	89
#define FIELDNAMES___old_axis2	90
#define FIELDNAMES___old_axis2Angle	91
#define FIELDNAMES___old_axis3Angle	92
#define FIELDNAMES___old_body1	93
#define FIELDNAMES___old_body2	94
#define FIELDNAMES___old_centerOfMass	95
#define FIELDNAMES___old_finiteRotationAxis	96
#define FIELDNAMES___old_linearVelocity	97
#define FIELDNAMES___old_motor1Axis	98
#define FIELDNAMES___old_motor2Axis	99
#define FIELDNAMES___old_motor3Axis	100
#define FIELDNAMES___old_orientation	101
#define FIELDNAMES___old_position	102
#define FIELDNAMES___oldgeoCoords	103
#define FIELDNAMES___oldload	104
#define FIELDNAMES___oldmetadata	105
#define FIELDNAMES___oldurl	106
#define FIELDNAMES___parentProto	107
#define FIELDNAMES___pindices	108
#define FIELDNAMES___points	109
#define FIELDNAMES___protoDeclares	110
#define FIELDNAMES___protoDef	111
#define FIELDNAMES___protoFlags	112
#define FIELDNAMES___prototype	113
#define FIELDNAMES___proxNode	114
#define FIELDNAMES___quadcount	115
#define FIELDNAMES___regenSubTextures	116
#define FIELDNAMES___rightTexture	117
#define FIELDNAMES___rootUrl	118
#define FIELDNAMES___rooturlloadstatus	119
#define FIELDNAMES___rotyup	120
#define FIELDNAMES___scriptObj	121
#define FIELDNAMES___scripts	122
#define FIELDNAMES___segCount	123
#define FIELDNAMES___sibAffectors	124
#define FIELDNAMES___sidepoints	125
#define FIELDNAMES___simpleDisk	126
#define FIELDNAMES___solid	127
#define FIELDNAMES___sourceNumber	128
#define FIELDNAMES___subTextures	129
#define FIELDNAMES___subcontexts	130
#define FIELDNAMES___t1	131
#define FIELDNAMES___t2	132
#define FIELDNAMES___texCoords	133
#define FIELDNAMES___texture	134
#define FIELDNAMES___textureTableIndex	135
#define FIELDNAMES___textureright	136
#define FIELDNAMES___topTexture	137
#define FIELDNAMES___transparency	138
#define FIELDNAMES___typename	139
#define FIELDNAMES___vertArr	140
#define FIELDNAMES___vertIndx	141
#define FIELDNAMES___vertexCount	142
#define FIELDNAMES___vertices	143
#define FIELDNAMES___visible	144
#define FIELDNAMES___wireindices	145
#define FIELDNAMES___wireindicesVBO	146
#define FIELDNAMES___xcolours	147
#define FIELDNAMES___xparams	148
#define FIELDNAMES__align	149
#define FIELDNAMES__amb	150
#define FIELDNAMES__appliedParameters	151
#define FIELDNAMES__appliedParametersMask	152
#define FIELDNAMES__bboxCenter	153
#define FIELDNAMES__bboxSize	154
#define FIELDNAMES__body	155
#define FIELDNAMES__boxtris	156
#define FIELDNAMES__buffer	157
#define FIELDNAMES__bufferendtime	158
#define FIELDNAMES__class	159
#define FIELDNAMES__col	160
#define FIELDNAMES__colourSize	161
#define FIELDNAMES__coloursVBO	162
#define FIELDNAMES__controlPoint	163
#define FIELDNAMES__coordIndex	164
#define FIELDNAMES__csensor	165
#define FIELDNAMES__destination	166
#define FIELDNAMES__dir	167
#define FIELDNAMES__dlchange	168
#define FIELDNAMES__donethispass	169
#define FIELDNAMES__enabled	170
#define FIELDNAMES__fbohandles	171
#define FIELDNAMES__floatInpFIFO	172
#define FIELDNAMES__floatOutFIFO	173
#define FIELDNAMES__forceout	174
#define FIELDNAMES__frameSpeed	175
#define FIELDNAMES__geom	176
#define FIELDNAMES__geomIdentityTransform	177
#define FIELDNAMES__geometryType	178
#define FIELDNAMES__group	179
#define FIELDNAMES__hatchScale	180
#define FIELDNAMES__ifs	181
#define FIELDNAMES__initialRotation	182
#define FIELDNAMES__initialTranslation	183
#define FIELDNAMES__initialized	184
#define FIELDNAMES__input	185
#define FIELDNAMES__int32InpFIFO	186
#define FIELDNAMES__int32OutFIFO	187
#define FIELDNAMES__isScreen	188
#define FIELDNAMES__joint	189
#define FIELDNAMES__keyVBO	190
#define FIELDNAMES__keyValueVBO	191
#define FIELDNAMES__knot	192
#define FIELDNAMES__knotrange	193
#define FIELDNAMES__lasttick	194
#define FIELDNAMES__lasttime	195
#define FIELDNAMES__layerId	196
#define FIELDNAMES__loc	197
#define FIELDNAMES__ltex	198
#define FIELDNAMES__method	199
#define FIELDNAMES__motor1	200
#define FIELDNAMES__motor2	201
#define FIELDNAMES__needs_gradient	202
#define FIELDNAMES__normkey	203
#define FIELDNAMES__normkeyValue	204
#define FIELDNAMES__npoints	205
#define FIELDNAMES__nseg	206
#define FIELDNAMES__offsetUnits	207
#define FIELDNAMES__oldhitNormal	208
#define FIELDNAMES__oldhitPoint	209
#define FIELDNAMES__oldhitTexCoord	210
#define FIELDNAMES__oldisActive	211
#define FIELDNAMES__oldpickTarget	212
#define FIELDNAMES__oldpickedGeometry	213
#define FIELDNAMES__oldpickedPoint	214
#define FIELDNAMES__oldrotation	215
#define FIELDNAMES__oldtrackPoint	216
#define FIELDNAMES__oldtranslation	217
#define FIELDNAMES__origCoords	218
#define FIELDNAMES__origNormalizedPoint	219
#define FIELDNAMES__origNorms	220
#define FIELDNAMES__origPoint	221
#define FIELDNAMES__p	222
#define FIELDNAMES__parentResource	223
#define FIELDNAMES__particles	224
#define FIELDNAMES__patch	225
#define FIELDNAMES__phaseFunction	226
#define FIELDNAMES__pointsVBO	227
#define FIELDNAMES__portions	228
#define FIELDNAMES__previousvalue	229
#define FIELDNAMES__radius	230
#define FIELDNAMES__remainder	231
#define FIELDNAMES__retrievedURLData	232
#define FIELDNAMES__rotationAngle	233
#define FIELDNAMES__scale	234
#define FIELDNAMES__scaleMode	235
#define FIELDNAMES__screendata	236
#define FIELDNAMES__segs	237
#define FIELDNAMES__selected	238
#define FIELDNAMES__shaderLoadThread	239
#define FIELDNAMES__shaderUserDefinedFields	240
#define FIELDNAMES__shaderUserNumber	241
#define FIELDNAMES__shaderflags_base	242
#define FIELDNAMES__shaderflags_effects	243
#define FIELDNAMES__shaderflags_usershaders	244
#define FIELDNAMES__sideVBO	245
#define FIELDNAMES__sizeUnits	246
#define FIELDNAMES__sortedChildren	247
#define FIELDNAMES__space	248
#define FIELDNAMES__status	249
#define FIELDNAMES__steptime	250
#define FIELDNAMES__stringInpFIFO	251
#define FIELDNAMES__stringOutFIFO	252
#define FIELDNAMES__t	253
#define FIELDNAMES__takefirstinput	254
#define FIELDNAMES__talkToNodes	255
#define FIELDNAMES__tau	256
#define FIELDNAMES__tris	257
#define FIELDNAMES__tscale	258
#define FIELDNAMES__ttex	259
#define FIELDNAMES__type	260
#define FIELDNAMES__uKnot	261
#define FIELDNAMES__vKnot	262
#define FIELDNAMES__values	263
#define FIELDNAMES__verifiedBackColor	264
#define FIELDNAMES__verifiedColor	265
#define FIELDNAMES__verifiedFrontColor	266
#define FIELDNAMES__weightFunction1	267
#define FIELDNAMES__weightFunction2	268
#define FIELDNAMES__world	269
#define FIELDNAMES__xyzw	270
#define FIELDNAMES_actionKeyPress	271
#define FIELDNAMES_actionKeyRelease	272
#define FIELDNAMES_activate	273
#define FIELDNAMES_activeLayer	274
#define FIELDNAMES_addChildren	275
#define FIELDNAMES_addGeometry	276
#define FIELDNAMES_addTrimmingContour	277
#define FIELDNAMES_addedEntities	278
#define FIELDNAMES_address	279
#define FIELDNAMES_align	280
#define FIELDNAMES_alpha	281
#define FIELDNAMES_altKey	282
#define FIELDNAMES_ambientIntensity	283
#define FIELDNAMES_anchorPoint	284
#define FIELDNAMES_angle	285
#define FIELDNAMES_angleRate	286
#define FIELDNAMES_angularDampingFactor	287
#define FIELDNAMES_angularVelocity	288
#define FIELDNAMES_anisotropicDegree	289
#define FIELDNAMES_antennaLocation	290
#define FIELDNAMES_antennaPatternLength	291
#define FIELDNAMES_antennaPatternType	292
#define FIELDNAMES_appearance	293
#define FIELDNAMES_applicationID	294
#define FIELDNAMES_applied	295
#define FIELDNAMES_appliedParameters	296
#define FIELDNAMES_articulationParameterArray	297
#define FIELDNAMES_articulationParameterChangeIndicatorArr	298
#define FIELDNAMES_articulationParameterCount	299
#define FIELDNAMES_articulationParameterDesignatorArray	300
#define FIELDNAMES_articulationParameterIdPartAttachedToAr	301
#define FIELDNAMES_articulationParameterTypeArray	302
#define FIELDNAMES_articulationParameterValue0_changed	303
#define FIELDNAMES_articulationParameterValue1_changed	304
#define FIELDNAMES_articulationParameterValue2_changed	305
#define FIELDNAMES_articulationParameterValue3_changed	306
#define FIELDNAMES_articulationParameterValue4_changed	307
#define FIELDNAMES_articulationParameterValue5_changed	308
#define FIELDNAMES_articulationParameterValue6_changed	309
#define FIELDNAMES_articulationParameterValue7_changed	310
#define FIELDNAMES_aspectRatio	311
#define FIELDNAMES_attenuation	312
#define FIELDNAMES_attrib	313
#define FIELDNAMES_autoCalc	314
#define FIELDNAMES_autoDamp	315
#define FIELDNAMES_autoDisable	316
#define FIELDNAMES_autoOffset	317
#define FIELDNAMES_avatarSize	318
#define FIELDNAMES_axis	319
#define FIELDNAMES_axis1	320
#define FIELDNAMES_axis1Angle	321
#define FIELDNAMES_axis1Torque	322
#define FIELDNAMES_axis2	323
#define FIELDNAMES_axis2Angle	324
#define FIELDNAMES_axis2Torque	325
#define FIELDNAMES_axis3Angle	326
#define FIELDNAMES_axis3Torque	327
#define FIELDNAMES_axisOfRotation	328
#define FIELDNAMES_axisRotation	329
#define FIELDNAMES_back	330
#define FIELDNAMES_backAmbientIntensity	331
#define FIELDNAMES_backDiffuseColor	332
#define FIELDNAMES_backEmissiveColor	333
#define FIELDNAMES_backShininess	334
#define FIELDNAMES_backSpecularColor	335
#define FIELDNAMES_backTexture	336
#define FIELDNAMES_backTransparency	337
#define FIELDNAMES_backUrl	338
#define FIELDNAMES_bboxCenter	339
#define FIELDNAMES_bboxSize	340
#define FIELDNAMES_beamWidth	341
#define FIELDNAMES_beginCap	342
#define FIELDNAMES_bindTime	343
#define FIELDNAMES_bodies	344
#define FIELDNAMES_body1	345
#define FIELDNAMES_body1AnchorPoint	346
#define FIELDNAMES_body1Axis	347
#define FIELDNAMES_body2	348
#define FIELDNAMES_body2AnchorPoint	349
#define FIELDNAMES_body2Axis	350
#define FIELDNAMES_borderColor	351
#define FIELDNAMES_borderWidth	352
#define FIELDNAMES_bottom	353
#define FIELDNAMES_bottomRadius	354
#define FIELDNAMES_bottomTexture	355
#define FIELDNAMES_bottomUrl	356
#define FIELDNAMES_bounce	357
#define FIELDNAMES_boundaryModeR	358
#define FIELDNAMES_boundaryModeS	359
#define FIELDNAMES_boundaryModeT	360
#define FIELDNAMES_boundaryOpacity	361
#define FIELDNAMES_category	362
#define FIELDNAMES_ccw	363
#define FIELDNAMES_center	364
#define FIELDNAMES_centerOfMass	365
#define FIELDNAMES_centerOfRotation	366
#define FIELDNAMES_centerOfRotation_changed	367
#define FIELDNAMES_child1Url	368
#define FIELDNAMES_child2Url	369
#define FIELDNAMES_child3Url	370
#define FIELDNAMES_child4Url	371
#define FIELDNAMES_children	372
#define FIELDNAMES_choice	373
#define FIELDNAMES_clipBoundary	374
#define FIELDNAMES_closed	375
#define FIELDNAMES_closureType	376
#define FIELDNAMES_collidable	377
#define FIELDNAMES_collidables	378
#define FIELDNAMES_collide	379
#define FIELDNAMES_collideTime	380
#define FIELDNAMES_collider	381
#define FIELDNAMES_collisionType	382
#define FIELDNAMES_color	383
#define FIELDNAMES_colorIndex	384
#define FIELDNAMES_colorKey	385
#define FIELDNAMES_colorPerVertex	386
#define FIELDNAMES_colorRamp	387
#define FIELDNAMES_colorSteps	388
#define FIELDNAMES_constantForceMix	389
#define FIELDNAMES_contactNormal	390
#define FIELDNAMES_contactSurfaceThickness	391
#define FIELDNAMES_contacts	392
#define FIELDNAMES_contourStepSize	393
#define FIELDNAMES_controlKey	394
#define FIELDNAMES_controlPoint	395
#define FIELDNAMES_convex	396
#define FIELDNAMES_coolColor	397
#define FIELDNAMES_coord	398
#define FIELDNAMES_coordIndex	399
#define FIELDNAMES_country	400
#define FIELDNAMES_creaseAngle	401
#define FIELDNAMES_createParticles	402
#define FIELDNAMES_crossSection	403
#define FIELDNAMES_crossSectionCurve	404
#define FIELDNAMES_cryptoKeyID	405
#define FIELDNAMES_cryptoSystem	406
#define FIELDNAMES_cutOffAngle	407
#define FIELDNAMES_cycleInterval	408
#define FIELDNAMES_cycleTime	409
#define FIELDNAMES_data	410
#define FIELDNAMES_dataLength	411
#define FIELDNAMES_deadReckoning	412
#define FIELDNAMES_deletionAllowed	413
#define FIELDNAMES_depth	414
#define FIELDNAMES_description	415
#define FIELDNAMES_desiredAngularVelocity1	416
#define FIELDNAMES_desiredAngularVelocity2	417
#define FIELDNAMES_detonateTime	418
#define FIELDNAMES_detonationLocation	419
#define FIELDNAMES_detonationRelativeLocation	420
#define FIELDNAMES_detonationResult	421
#define FIELDNAMES_diffuseColor	422
#define FIELDNAMES_dimensions	423
#define FIELDNAMES_directOutput	424
#define FIELDNAMES_direction	425
#define FIELDNAMES_disableAngularSpeed	426
#define FIELDNAMES_disableLinearSpeed	427
#define FIELDNAMES_disableTime	428
#define FIELDNAMES_diskAngle	429
#define FIELDNAMES_displacements	430
#define FIELDNAMES_displacers	431
#define FIELDNAMES_displayed	432
#define FIELDNAMES_domain	433
#define FIELDNAMES_duration	434
#define FIELDNAMES_duration_changed	435
#define FIELDNAMES_easeInEaseOut	436
#define FIELDNAMES_edgeColor	437
#define FIELDNAMES_effects	438
#define FIELDNAMES_elapsedTime	439
#define FIELDNAMES_emissiveColor	440
#define FIELDNAMES_emitter	441
#define FIELDNAMES_enabled	442
#define FIELDNAMES_enabledAxes	443
#define FIELDNAMES_encodingScheme	444
#define FIELDNAMES_endAngle	445
#define FIELDNAMES_endCap	446
#define FIELDNAMES_enterTime	447
#define FIELDNAMES_enteredText	448
#define FIELDNAMES_entityCategory	449
#define FIELDNAMES_entityCountry	450
#define FIELDNAMES_entityDomain	451
#define FIELDNAMES_entityExtra	452
#define FIELDNAMES_entityID	453
#define FIELDNAMES_entityKind	454
#define FIELDNAMES_entitySpecific	455
#define FIELDNAMES_entitySubCategory	456
#define FIELDNAMES_errorCorrection	457
#define FIELDNAMES_eventApplicationID	458
#define FIELDNAMES_eventEntityID	459
#define FIELDNAMES_eventNumber	460
#define FIELDNAMES_eventSiteID	461
#define FIELDNAMES_exitTime	462
#define FIELDNAMES_extra	463
#define FIELDNAMES_family	464
#define FIELDNAMES_fanCount	465
#define FIELDNAMES_fieldOfView	466
#define FIELDNAMES_fillProperties	467
#define FIELDNAMES_filled	468
#define FIELDNAMES_filter	469
#define FIELDNAMES_finalText	470
#define FIELDNAMES_finiteRotationAxis	471
#define FIELDNAMES_fireMissionIndex	472
#define FIELDNAMES_fired1	473
#define FIELDNAMES_fired2	474
#define FIELDNAMES_firedTime	475
#define FIELDNAMES_firingRange	476
#define FIELDNAMES_firingRate	477
#define FIELDNAMES_fixed	478
#define FIELDNAMES_floatInp	479
#define FIELDNAMES_focalPoint	480
#define FIELDNAMES_fogCoord	481
#define FIELDNAMES_fogType	482
#define FIELDNAMES_fontStyle	483
#define FIELDNAMES_force	484
#define FIELDNAMES_forceID	485
#define FIELDNAMES_forceOutput	486
#define FIELDNAMES_forceTransitions	487
#define FIELDNAMES_forces	488
#define FIELDNAMES_fovMode	489
#define FIELDNAMES_fraction_changed	490
#define FIELDNAMES_frequency	491
#define FIELDNAMES_frictionCoefficients	492
#define FIELDNAMES_frictionDirection	493
#define FIELDNAMES_front	494
#define FIELDNAMES_frontTexture	495
#define FIELDNAMES_frontUrl	496
#define FIELDNAMES_function	497
#define FIELDNAMES_fuse	498
#define FIELDNAMES_generateMipMaps	499
#define FIELDNAMES_geoCenter	500
#define FIELDNAMES_geoCoord_changed	501
#define FIELDNAMES_geoCoords	502
#define FIELDNAMES_geoGridOrigin	503
#define FIELDNAMES_geoOrigin	504
#define FIELDNAMES_geoSystem	505
#define FIELDNAMES_geometry	506
#define FIELDNAMES_geometry1	507
#define FIELDNAMES_geometry2	508
#define FIELDNAMES_geometryType	509
#define FIELDNAMES_geovalue_changed	510
#define FIELDNAMES_global	511
#define FIELDNAMES_gotEvents	512
#define FIELDNAMES_gradientThreshold	513
#define FIELDNAMES_gradients	514
#define FIELDNAMES_gravity	515
#define FIELDNAMES_groundAngle	516
#define FIELDNAMES_groundColor	517
#define FIELDNAMES_gustiness	518
#define FIELDNAMES_handler	519
#define FIELDNAMES_hatchColor	520
#define FIELDNAMES_hatchStyle	521
#define FIELDNAMES_hatched	522
#define FIELDNAMES_headlight	523
#define FIELDNAMES_height	524
#define FIELDNAMES_hinge1Angle	525
#define FIELDNAMES_hinge1AngleRate	526
#define FIELDNAMES_hinge2Angle	527
#define FIELDNAMES_hinge2AngleRate	528
#define FIELDNAMES_hitGeoCoord_changed	529
#define FIELDNAMES_hitNormal_changed	530
#define FIELDNAMES_hitPoint_changed	531
#define FIELDNAMES_hitTexCoord_changed	532
#define FIELDNAMES_horizontal	533
#define FIELDNAMES_image	534
#define FIELDNAMES_index	535
#define FIELDNAMES_inertia	536
#define FIELDNAMES_info	537
#define FIELDNAMES_initialDestination	538
#define FIELDNAMES_initialValue	539
#define FIELDNAMES_innerRadius	540
#define FIELDNAMES_inputFalse	541
#define FIELDNAMES_inputNegate	542
#define FIELDNAMES_inputSource	543
#define FIELDNAMES_inputTrue	544
#define FIELDNAMES_int32Inp	545
#define FIELDNAMES_integerKey	546
#define FIELDNAMES_intensity	547
#define FIELDNAMES_intensityThreshold	548
#define FIELDNAMES_internal	549
#define FIELDNAMES_intersectionType	550
#define FIELDNAMES_intersections	551
#define FIELDNAMES_isActive	552
#define FIELDNAMES_isBound	553
#define FIELDNAMES_isCollided	554
#define FIELDNAMES_isDetonated	555
#define FIELDNAMES_isLoaded	556
#define FIELDNAMES_isNetworkReader	557
#define FIELDNAMES_isNetworkWriter	558
#define FIELDNAMES_isOver	559
#define FIELDNAMES_isPaused	560
#define FIELDNAMES_isPickable	561
#define FIELDNAMES_isPositionAvailable	562
#define FIELDNAMES_isRotationAvailable	563
#define FIELDNAMES_isRtpHeaderHeard	564
#define FIELDNAMES_isSelected	565
#define FIELDNAMES_isStandAlone	566
#define FIELDNAMES_isValid	567
#define FIELDNAMES_iterations	568
#define FIELDNAMES_joints	569
#define FIELDNAMES_jump	570
#define FIELDNAMES_justify	571
#define FIELDNAMES_key	572
#define FIELDNAMES_keyPress	573
#define FIELDNAMES_keyRelease	574
#define FIELDNAMES_keyValue	575
#define FIELDNAMES_keyVelocity	576
#define FIELDNAMES_kind	577
#define FIELDNAMES_knot	578
#define FIELDNAMES_language	579
#define FIELDNAMES_layers	580
#define FIELDNAMES_layout	581
#define FIELDNAMES_left	582
#define FIELDNAMES_leftTexture	583
#define FIELDNAMES_leftToRight	584
#define FIELDNAMES_leftUrl	585
#define FIELDNAMES_length	586
#define FIELDNAMES_lengthOfModulationParameters	587
#define FIELDNAMES_level	588
#define FIELDNAMES_levelChanged	589
#define FIELDNAMES_level_changed	590
#define FIELDNAMES_lifetimeVariation	591
#define FIELDNAMES_lighting	592
#define FIELDNAMES_limitOrientation	593
#define FIELDNAMES_lineBounds	594
#define FIELDNAMES_lineProperties	595
#define FIELDNAMES_lineSegments	596
#define FIELDNAMES_linearAcceleration	597
#define FIELDNAMES_linearDampingFactor	598
#define FIELDNAMES_linearVelocity	599
#define FIELDNAMES_linetype	600
#define FIELDNAMES_linewidthScaleFactor	601
#define FIELDNAMES_listenfor	602
#define FIELDNAMES_llimit	603
#define FIELDNAMES_load	604
#define FIELDNAMES_loadTime	605
#define FIELDNAMES_location	606
#define FIELDNAMES_loop	607
#define FIELDNAMES_magnificationFilter	608
#define FIELDNAMES_mapping	609
#define FIELDNAMES_marking	610
#define FIELDNAMES_mass	611
#define FIELDNAMES_massDensityModel	612
#define FIELDNAMES_matchCriterion	613
#define FIELDNAMES_material	614
#define FIELDNAMES_matrix	615
#define FIELDNAMES_maxAngle	616
#define FIELDNAMES_maxAngle1	617
#define FIELDNAMES_maxBack	618
#define FIELDNAMES_maxCorrectionSpeed	619
#define FIELDNAMES_maxExtent	620
#define FIELDNAMES_maxFront	621
#define FIELDNAMES_maxParticles	622
#define FIELDNAMES_maxPosition	623
#define FIELDNAMES_maxSeparation	624
#define FIELDNAMES_maxTorque1	625
#define FIELDNAMES_maxTorque2	626
#define FIELDNAMES_metadata	627
#define FIELDNAMES_method	628
#define FIELDNAMES_minAngle	629
#define FIELDNAMES_minAngle1	630
#define FIELDNAMES_minBack	631
#define FIELDNAMES_minBounceSpeed	632
#define FIELDNAMES_minFront	633
#define FIELDNAMES_minPosition	634
#define FIELDNAMES_minSeparation	635
#define FIELDNAMES_minificationFilter	636
#define FIELDNAMES_mode	637
#define FIELDNAMES_modifiedFraction_changed	638
#define FIELDNAMES_modulationTypeDetail	639
#define FIELDNAMES_modulationTypeMajor	640
#define FIELDNAMES_modulationTypeSpreadSpectrum	641
#define FIELDNAMES_modulationTypeSystem	642
#define FIELDNAMES_momentsOfInertia	643
#define FIELDNAMES_motor1Angle	644
#define FIELDNAMES_motor1AngleRate	645
#define FIELDNAMES_motor1Axis	646
#define FIELDNAMES_motor2Angle	647
#define FIELDNAMES_motor2AngleRate	648
#define FIELDNAMES_motor2Axis	649
#define FIELDNAMES_motor3Angle	650
#define FIELDNAMES_motor3AngleRate	651
#define FIELDNAMES_motor3Axis	652
#define FIELDNAMES_multicastRelayHost	653
#define FIELDNAMES_multicastRelayPort	654
#define FIELDNAMES_munitionApplicationID	655
#define FIELDNAMES_munitionEndPoint	656
#define FIELDNAMES_munitionEntityID	657
#define FIELDNAMES_munitionQuantity	658
#define FIELDNAMES_munitionSiteID	659
#define FIELDNAMES_munitionStartPoint	660
#define FIELDNAMES_mustEvaluate	661
#define FIELDNAMES_name	662
#define FIELDNAMES_navType	663
#define FIELDNAMES_networkMode	664
#define FIELDNAMES_next	665
#define FIELDNAMES_normal	666
#define FIELDNAMES_normalIndex	667
#define FIELDNAMES_normalPerVertex	668
#define FIELDNAMES_normal_changed	669
#define FIELDNAMES_normalizeVelocity	670
#define FIELDNAMES_numComponents	671
#define FIELDNAMES_objectType	672
#define FIELDNAMES_offset	673
#define FIELDNAMES_offsetUnits	674
#define FIELDNAMES_on	675
#define FIELDNAMES_opacityFactor	676
#define FIELDNAMES_order	677
#define FIELDNAMES_orientation	678
#define FIELDNAMES_orientation_changed	679
#define FIELDNAMES_origin	680
#define FIELDNAMES_orthogonalColor	681
#define FIELDNAMES_outerRadius	682
#define FIELDNAMES_parallelColor	683
#define FIELDNAMES_parameter	684
#define FIELDNAMES_particleLifetime	685
#define FIELDNAMES_particleSize	686
#define FIELDNAMES_parts	687
#define FIELDNAMES_pauseTime	688
#define FIELDNAMES_phaseFunction	689
#define FIELDNAMES_physics	690
#define FIELDNAMES_pickTarget	691
#define FIELDNAMES_pickable	692
#define FIELDNAMES_pickedGeometry	693
#define FIELDNAMES_pickedNormal	694
#define FIELDNAMES_pickedPoint	695
#define FIELDNAMES_pickedTextureCoordinate	696
#define FIELDNAMES_pickingGeometry	697
#define FIELDNAMES_pitch	698
#define FIELDNAMES_plane	699
#define FIELDNAMES_point	700
#define FIELDNAMES_pointSize	701
#define FIELDNAMES_port	702
#define FIELDNAMES_position	703
#define FIELDNAMES_position_changed	704
#define FIELDNAMES_power	705
#define FIELDNAMES_preferAccuracy	706
#define FIELDNAMES_previous	707
#define FIELDNAMES_priority	708
#define FIELDNAMES_profileCurve	709
#define FIELDNAMES_programs	710
#define FIELDNAMES_progress	711
#define FIELDNAMES_protocol	712
#define FIELDNAMES_proxy	713
#define FIELDNAMES_radioEntityTypeCategory	714
#define FIELDNAMES_radioEntityTypeCountry	715
#define FIELDNAMES_radioEntityTypeDomain	716
#define FIELDNAMES_radioEntityTypeKind	717
#define FIELDNAMES_radioEntityTypeNomenclature	718
#define FIELDNAMES_radioEntityTypeNomenclatureVersion	719
#define FIELDNAMES_radioID	720
#define FIELDNAMES_radius	721
#define FIELDNAMES_range	722
#define FIELDNAMES_readInterval	723
#define FIELDNAMES_receivedPower	724
#define FIELDNAMES_receiverState	725
#define FIELDNAMES_reference	726
#define FIELDNAMES_relativeAntennaLocation	727
#define FIELDNAMES_removeChildren	728
#define FIELDNAMES_removeGeometry	729
#define FIELDNAMES_removeTrimmingContour	730
#define FIELDNAMES_removedEntities	731
#define FIELDNAMES_renderStyle	732
#define FIELDNAMES_repeatR	733
#define FIELDNAMES_repeatS	734
#define FIELDNAMES_repeatT	735
#define FIELDNAMES_resumeTime	736
#define FIELDNAMES_retainUserOffsets	737
#define FIELDNAMES_retainedOpacity	738
#define FIELDNAMES_right	739
#define FIELDNAMES_rightTexture	740
#define FIELDNAMES_rightUrl	741
#define FIELDNAMES_rootNode	742
#define FIELDNAMES_rootUrl	743
#define FIELDNAMES_rotateYUp	744
#define FIELDNAMES_rotation	745
#define FIELDNAMES_rotation_changed	746
#define FIELDNAMES_rtpHeaderExpected	747
#define FIELDNAMES_sampleRate	748
#define FIELDNAMES_samples	749
#define FIELDNAMES_scale	750
#define FIELDNAMES_scaleMode	751
#define FIELDNAMES_scaleOrientation	752
#define FIELDNAMES_segmentEnabled	753
#define FIELDNAMES_segmentIdentifiers	754
#define FIELDNAMES_segments	755
#define FIELDNAMES_separateBackColor	756
#define FIELDNAMES_separation	757
#define FIELDNAMES_separationRate	758
#define FIELDNAMES_setValue	759
#define FIELDNAMES_set_articulationParameterValue0	760
#define FIELDNAMES_set_articulationParameterValue1	761
#define FIELDNAMES_set_articulationParameterValue2	762
#define FIELDNAMES_set_articulationParameterValue3	763
#define FIELDNAMES_set_articulationParameterValue4	764
#define FIELDNAMES_set_articulationParameterValue5	765
#define FIELDNAMES_set_articulationParameterValue6	766
#define FIELDNAMES_set_articulationParameterValue7	767
#define FIELDNAMES_set_bind	768
#define FIELDNAMES_set_boolean	769
#define FIELDNAMES_set_colorIndex	770
#define FIELDNAMES_set_contacts	771
#define FIELDNAMES_set_coordIndex	772
#define FIELDNAMES_set_crossSection	773
#define FIELDNAMES_set_destination	774
#define FIELDNAMES_set_fraction	775
#define FIELDNAMES_set_height	776
#define FIELDNAMES_set_index	777
#define FIELDNAMES_set_intersectionType	778
#define FIELDNAMES_set_normalIndex	779
#define FIELDNAMES_set_orientation	780
#define FIELDNAMES_set_position	781
#define FIELDNAMES_set_scale	782
#define FIELDNAMES_set_sortOrder	783
#define FIELDNAMES_set_spine	784
#define FIELDNAMES_set_texCoordIndex	785
#define FIELDNAMES_set_triggerTime	786
#define FIELDNAMES_set_value	787
#define FIELDNAMES_shaders	788
#define FIELDNAMES_shadows	789
#define FIELDNAMES_shape	790
#define FIELDNAMES_shiftKey	791
#define FIELDNAMES_shininess	792
#define FIELDNAMES_side	793
#define FIELDNAMES_silhouetteBoundaryOpacity	794
#define FIELDNAMES_silhouetteRetainedOpacity	795
#define FIELDNAMES_silhouetteSharpness	796
#define FIELDNAMES_siteID	797
#define FIELDNAMES_sites	798
#define FIELDNAMES_size	799
#define FIELDNAMES_sizeUnits	800
#define FIELDNAMES_skeleton	801
#define FIELDNAMES_skin	802
#define FIELDNAMES_skinCoord	803
#define FIELDNAMES_skinCoordIndex	804
#define FIELDNAMES_skinCoordWeight	805
#define FIELDNAMES_skinNormal	806
#define FIELDNAMES_skyAngle	807
#define FIELDNAMES_skyColor	808
#define FIELDNAMES_sliderForce	809
#define FIELDNAMES_slipCoefficients	810
#define FIELDNAMES_slipFactors	811
#define FIELDNAMES_softnessConstantForceMix	812
#define FIELDNAMES_softnessErrorCorrection	813
#define FIELDNAMES_solid	814
#define FIELDNAMES_sortOrder	815
#define FIELDNAMES_source	816
#define FIELDNAMES_spacing	817
#define FIELDNAMES_spatialize	818
#define FIELDNAMES_specific	819
#define FIELDNAMES_specularColor	820
#define FIELDNAMES_speed	821
#define FIELDNAMES_speedFactor	822
#define FIELDNAMES_spine	823
#define FIELDNAMES_startAngle	824
#define FIELDNAMES_startTime	825
#define FIELDNAMES_stiffness	826
#define FIELDNAMES_stop1Bounce	827
#define FIELDNAMES_stop1ErrorCorrection	828
#define FIELDNAMES_stop2Bounce	829
#define FIELDNAMES_stop2ErrorCorrection	830
#define FIELDNAMES_stop3Bounce	831
#define FIELDNAMES_stop3ErrorCorrection	832
#define FIELDNAMES_stopBounce	833
#define FIELDNAMES_stopBounce1	834
#define FIELDNAMES_stopConstantForceMix1	835
#define FIELDNAMES_stopErrorCorrection	836
#define FIELDNAMES_stopErrorCorrection1	837
#define FIELDNAMES_stopTime	838
#define FIELDNAMES_string	839
#define FIELDNAMES_stringInp	840
#define FIELDNAMES_stripCount	841
#define FIELDNAMES_style	842
#define FIELDNAMES_subcategory	843
#define FIELDNAMES_summary	844
#define FIELDNAMES_surface	845
#define FIELDNAMES_surfaceArea	846
#define FIELDNAMES_surfaceNormals	847
#define FIELDNAMES_surfaceSpeed	848
#define FIELDNAMES_surfaceTolerance	849
#define FIELDNAMES_surfaceValues	850
#define FIELDNAMES_suspensionErrorCorrection	851
#define FIELDNAMES_suspensionForce	852
#define FIELDNAMES_talksTo	853
#define FIELDNAMES_targetObject	854
#define FIELDNAMES_tau	855
#define FIELDNAMES_tdlType	856
#define FIELDNAMES_tessellation	857
#define FIELDNAMES_tessellationScale	858
#define FIELDNAMES_texCoord	859
#define FIELDNAMES_texCoordIndex	860
#define FIELDNAMES_texCoordKey	861
#define FIELDNAMES_texCoordRamp	862
#define FIELDNAMES_textBounds	863
#define FIELDNAMES_texture	864
#define FIELDNAMES_textureCompression	865
#define FIELDNAMES_texturePriority	866
#define FIELDNAMES_textureProperties	867
#define FIELDNAMES_textureTransform	868
#define FIELDNAMES_tickTime	869
#define FIELDNAMES_time	870
#define FIELDNAMES_timeOut	871
#define FIELDNAMES_timestamp	872
#define FIELDNAMES_title	873
#define FIELDNAMES_toggle	874
#define FIELDNAMES_tolerance	875
#define FIELDNAMES_top	876
#define FIELDNAMES_topTexture	877
#define FIELDNAMES_topToBottom	878
#define FIELDNAMES_topUrl	879
#define FIELDNAMES_torques	880
#define FIELDNAMES_touchTime	881
#define FIELDNAMES_trackPoint_changed	882
#define FIELDNAMES_trajectoryCurve	883
#define FIELDNAMES_transferFunction	884
#define FIELDNAMES_transitionComplete	885
#define FIELDNAMES_transitionTime	886
#define FIELDNAMES_transitionType	887
#define FIELDNAMES_translation	888
#define FIELDNAMES_translation_changed	889
#define FIELDNAMES_transmitFrequencyBandwidth	890
#define FIELDNAMES_transmitState	891
#define FIELDNAMES_transmitterApplicationID	892
#define FIELDNAMES_transmitterEntityID	893
#define FIELDNAMES_transmitterRadioID	894
#define FIELDNAMES_transmitterSiteID	895
#define FIELDNAMES_transparency	896
#define FIELDNAMES_triggerTime	897
#define FIELDNAMES_triggerTrue	898
#define FIELDNAMES_triggerValue	899
#define FIELDNAMES_trimmingContour	900
#define FIELDNAMES_turbulence	901
#define FIELDNAMES_type	902
#define FIELDNAMES_uClosed	903
#define FIELDNAMES_uDimension	904
#define FIELDNAMES_uKnot	905
#define FIELDNAMES_uOrder	906
#define FIELDNAMES_uTessellation	907
#define FIELDNAMES_ulimit	908
#define FIELDNAMES_update	909
#define FIELDNAMES_url	910
#define FIELDNAMES_useFiniteRotation	911
#define FIELDNAMES_useGeometry	912
#define FIELDNAMES_useGlobalGravity	913
#define FIELDNAMES_vClosed	914
#define FIELDNAMES_vDimension	915
#define FIELDNAMES_vKnot	916
#define FIELDNAMES_vOrder	917
#define FIELDNAMES_vTessellation	918
#define FIELDNAMES_value	919
#define FIELDNAMES_valueChanged	920
#define FIELDNAMES_value_changed	921
#define FIELDNAMES_variation	922
#define FIELDNAMES_vector	923
#define FIELDNAMES_version	924
#define FIELDNAMES_vertexCount	925
#define FIELDNAMES_vertices	926
#define FIELDNAMES_viewpoints	927
#define FIELDNAMES_viewport	928
#define FIELDNAMES_visibilityLimit	929
#define FIELDNAMES_visibilityRange	930
#define FIELDNAMES_visible	931
#define FIELDNAMES_voxels	932
#define FIELDNAMES_warhead	933
#define FIELDNAMES_warmColor	934
#define FIELDNAMES_watchList	935
#define FIELDNAMES_weight	936
#define FIELDNAMES_weightConstant1	937
#define FIELDNAMES_weightConstant2	938
#define FIELDNAMES_weightFunction1	939
#define FIELDNAMES_weightFunction2	940
#define FIELDNAMES_weightTransferFunction1	941
#define FIELDNAMES_weightTransferFunction2	942
#define FIELDNAMES_whichChoice	943
#define FIELDNAMES_whichGeometry	944
#define FIELDNAMES_writeInterval	945
#define FIELDNAMES_xDimension	946
#define FIELDNAMES_xSpacing	947
#define FIELDNAMES_yScale	948
#define FIELDNAMES_zDimension	949
#define FIELDNAMES_zSpacing	950

const char *stringFieldType(int st);

/* Table of built-in fieldIds */
extern const char *EVENT_OUT[];
extern const int EVENT_OUT_COUNT;
#define EVENT_OUT_actionKeyPress	0
#define EVENT_OUT_actionKeyRelease	1
#define EVENT_OUT_addedEntities	2
#define EVENT_OUT_altKey	3
#define EVENT_OUT_angle	4
#define EVENT_OUT_angleRate	5
#define EVENT_OUT_articulationParameterValue0_changed	6
#define EVENT_OUT_articulationParameterValue1_changed	7
#define EVENT_OUT_articulationParameterValue2_changed	8
#define EVENT_OUT_articulationParameterValue3_changed	9
#define EVENT_OUT_articulationParameterValue4_changed	10
#define EVENT_OUT_articulationParameterValue5_changed	11
#define EVENT_OUT_articulationParameterValue6_changed	12
#define EVENT_OUT_articulationParameterValue7_changed	13
#define EVENT_OUT_aspectRatio	14
#define EVENT_OUT_bindTime	15
#define EVENT_OUT_body1AnchorPoint	16
#define EVENT_OUT_body1Axis	17
#define EVENT_OUT_body2AnchorPoint	18
#define EVENT_OUT_body2Axis	19
#define EVENT_OUT_centerOfRotation_changed	20
#define EVENT_OUT_children	21
#define EVENT_OUT_collideTime	22
#define EVENT_OUT_contacts	23
#define EVENT_OUT_controlKey	24
#define EVENT_OUT_cycleTime	25
#define EVENT_OUT_detonateTime	26
#define EVENT_OUT_duration_changed	27
#define EVENT_OUT_elapsedTime	28
#define EVENT_OUT_enterTime	29
#define EVENT_OUT_enteredText	30
#define EVENT_OUT_exitTime	31
#define EVENT_OUT_fieldOfView	32
#define EVENT_OUT_finalText	33
#define EVENT_OUT_firedTime	34
#define EVENT_OUT_focalPoint	35
#define EVENT_OUT_fovMode	36
#define EVENT_OUT_fraction_changed	37
#define EVENT_OUT_geoCoord_changed	38
#define EVENT_OUT_geovalue_changed	39
#define EVENT_OUT_hinge1Angle	40
#define EVENT_OUT_hinge1AngleRate	41
#define EVENT_OUT_hinge2Angle	42
#define EVENT_OUT_hinge2AngleRate	43
#define EVENT_OUT_hitGeoCoord_changed	44
#define EVENT_OUT_hitNormal_changed	45
#define EVENT_OUT_hitPoint_changed	46
#define EVENT_OUT_hitTexCoord_changed	47
#define EVENT_OUT_image	48
#define EVENT_OUT_inputFalse	49
#define EVENT_OUT_inputNegate	50
#define EVENT_OUT_inputTrue	51
#define EVENT_OUT_intersections	52
#define EVENT_OUT_isActive	53
#define EVENT_OUT_isBound	54
#define EVENT_OUT_isCollided	55
#define EVENT_OUT_isDetonated	56
#define EVENT_OUT_isLoaded	57
#define EVENT_OUT_isNetworkReader	58
#define EVENT_OUT_isNetworkWriter	59
#define EVENT_OUT_isOver	60
#define EVENT_OUT_isPaused	61
#define EVENT_OUT_isPositionAvailable	62
#define EVENT_OUT_isRotationAvailable	63
#define EVENT_OUT_isRtpHeaderHeard	64
#define EVENT_OUT_isSelected	65
#define EVENT_OUT_isStandAlone	66
#define EVENT_OUT_isValid	67
#define EVENT_OUT_keyPress	68
#define EVENT_OUT_keyRelease	69
#define EVENT_OUT_levelChanged	70
#define EVENT_OUT_level_changed	71
#define EVENT_OUT_lineBounds	72
#define EVENT_OUT_loadTime	73
#define EVENT_OUT_modifiedFraction_changed	74
#define EVENT_OUT_motor1Angle	75
#define EVENT_OUT_motor1AngleRate	76
#define EVENT_OUT_motor1Axis	77
#define EVENT_OUT_motor2Angle	78
#define EVENT_OUT_motor2AngleRate	79
#define EVENT_OUT_motor2Axis	80
#define EVENT_OUT_motor3Angle	81
#define EVENT_OUT_motor3AngleRate	82
#define EVENT_OUT_motor3Axis	83
#define EVENT_OUT_normal_changed	84
#define EVENT_OUT_orientation_changed	85
#define EVENT_OUT_origin	86
#define EVENT_OUT_pickedGeometry	87
#define EVENT_OUT_pickedNormal	88
#define EVENT_OUT_pickedPoint	89
#define EVENT_OUT_pickedTextureCoordinate	90
#define EVENT_OUT_position	91
#define EVENT_OUT_position_changed	92
#define EVENT_OUT_progress	93
#define EVENT_OUT_removedEntities	94
#define EVENT_OUT_rotation	95
#define EVENT_OUT_rotation_changed	96
#define EVENT_OUT_separation	97
#define EVENT_OUT_separationRate	98
#define EVENT_OUT_shiftKey	99
#define EVENT_OUT_textBounds	100
#define EVENT_OUT_time	101
#define EVENT_OUT_timestamp	102
#define EVENT_OUT_toggle	103
#define EVENT_OUT_touchTime	104
#define EVENT_OUT_trackPoint_changed	105
#define EVENT_OUT_transitionComplete	106
#define EVENT_OUT_translation_changed	107
#define EVENT_OUT_triggerTime	108
#define EVENT_OUT_triggerTrue	109
#define EVENT_OUT_triggerValue	110
#define EVENT_OUT_valueChanged	111
#define EVENT_OUT_value_changed	112


/* Table of built-in fieldIds */
extern const char *EVENT_IN[];
extern const int EVENT_IN_COUNT;
#define EVENT_IN_activate	0
#define EVENT_IN_addChildren	1
#define EVENT_IN_addGeometry	2
#define EVENT_IN_addTrimmingContour	3
#define EVENT_IN_coordIndex	4
#define EVENT_IN_method	5
#define EVENT_IN_next	6
#define EVENT_IN_previous	7
#define EVENT_IN_removeChildren	8
#define EVENT_IN_removeGeometry	9
#define EVENT_IN_removeTrimmingContour	10
#define EVENT_IN_setValue	11
#define EVENT_IN_set_articulationParameterValue0	12
#define EVENT_IN_set_articulationParameterValue1	13
#define EVENT_IN_set_articulationParameterValue2	14
#define EVENT_IN_set_articulationParameterValue3	15
#define EVENT_IN_set_articulationParameterValue4	16
#define EVENT_IN_set_articulationParameterValue5	17
#define EVENT_IN_set_articulationParameterValue6	18
#define EVENT_IN_set_articulationParameterValue7	19
#define EVENT_IN_set_bind	20
#define EVENT_IN_set_boolean	21
#define EVENT_IN_set_colorIndex	22
#define EVENT_IN_set_contacts	23
#define EVENT_IN_set_coordIndex	24
#define EVENT_IN_set_crossSection	25
#define EVENT_IN_set_destination	26
#define EVENT_IN_set_fraction	27
#define EVENT_IN_set_height	28
#define EVENT_IN_set_index	29
#define EVENT_IN_set_intersectionType	30
#define EVENT_IN_set_normalIndex	31
#define EVENT_IN_set_orientation	32
#define EVENT_IN_set_position	33
#define EVENT_IN_set_scale	34
#define EVENT_IN_set_sortOrder	35
#define EVENT_IN_set_spine	36
#define EVENT_IN_set_texCoordIndex	37
#define EVENT_IN_set_triggerTime	38
#define EVENT_IN_set_value	39
#define EVENT_IN_tickTime	40


/* Table of built-in fieldIds */
extern const char *EXPOSED_FIELD[];
extern const int EXPOSED_FIELD_COUNT;
#define EXPOSED_FIELD_FIFOsize	0
#define EXPOSED_FIELD_activeLayer	1
#define EXPOSED_FIELD_address	2
#define EXPOSED_FIELD_align	3
#define EXPOSED_FIELD_alpha	4
#define EXPOSED_FIELD_ambientIntensity	5
#define EXPOSED_FIELD_anchorPoint	6
#define EXPOSED_FIELD_angle	7
#define EXPOSED_FIELD_angularDampingFactor	8
#define EXPOSED_FIELD_angularVelocity	9
#define EXPOSED_FIELD_anisotropicDegree	10
#define EXPOSED_FIELD_antennaLocation	11
#define EXPOSED_FIELD_antennaPatternLength	12
#define EXPOSED_FIELD_antennaPatternType	13
#define EXPOSED_FIELD_appearance	14
#define EXPOSED_FIELD_applicationID	15
#define EXPOSED_FIELD_applied	16
#define EXPOSED_FIELD_appliedParameters	17
#define EXPOSED_FIELD_articulationParameterArray	18
#define EXPOSED_FIELD_articulationParameterChangeIndicatorArr	19
#define EXPOSED_FIELD_articulationParameterCount	20
#define EXPOSED_FIELD_articulationParameterDesignatorArray	21
#define EXPOSED_FIELD_articulationParameterIdPartAttachedToAr	22
#define EXPOSED_FIELD_articulationParameterTypeArray	23
#define EXPOSED_FIELD_aspectRatio	24
#define EXPOSED_FIELD_attenuation	25
#define EXPOSED_FIELD_attrib	26
#define EXPOSED_FIELD_autoDamp	27
#define EXPOSED_FIELD_autoDisable	28
#define EXPOSED_FIELD_autoOffset	29
#define EXPOSED_FIELD_avatarSize	30
#define EXPOSED_FIELD_axis	31
#define EXPOSED_FIELD_axis1	32
#define EXPOSED_FIELD_axis1Angle	33
#define EXPOSED_FIELD_axis1Torque	34
#define EXPOSED_FIELD_axis2	35
#define EXPOSED_FIELD_axis2Angle	36
#define EXPOSED_FIELD_axis2Torque	37
#define EXPOSED_FIELD_axis3Angle	38
#define EXPOSED_FIELD_axis3Torque	39
#define EXPOSED_FIELD_axisOfRotation	40
#define EXPOSED_FIELD_axisRotation	41
#define EXPOSED_FIELD_back	42
#define EXPOSED_FIELD_backAmbientIntensity	43
#define EXPOSED_FIELD_backDiffuseColor	44
#define EXPOSED_FIELD_backEmissiveColor	45
#define EXPOSED_FIELD_backShininess	46
#define EXPOSED_FIELD_backSpecularColor	47
#define EXPOSED_FIELD_backTexture	48
#define EXPOSED_FIELD_backTransparency	49
#define EXPOSED_FIELD_backUrl	50
#define EXPOSED_FIELD_beamWidth	51
#define EXPOSED_FIELD_bodies	52
#define EXPOSED_FIELD_body1	53
#define EXPOSED_FIELD_body2	54
#define EXPOSED_FIELD_borderColor	55
#define EXPOSED_FIELD_borderWidth	56
#define EXPOSED_FIELD_bottom	57
#define EXPOSED_FIELD_bottomTexture	58
#define EXPOSED_FIELD_bottomUrl	59
#define EXPOSED_FIELD_bounce	60
#define EXPOSED_FIELD_boundaryModeR	61
#define EXPOSED_FIELD_boundaryModeS	62
#define EXPOSED_FIELD_boundaryModeT	63
#define EXPOSED_FIELD_boundaryOpacity	64
#define EXPOSED_FIELD_center	65
#define EXPOSED_FIELD_centerOfMass	66
#define EXPOSED_FIELD_centerOfRotation	67
#define EXPOSED_FIELD_children	68
#define EXPOSED_FIELD_choice	69
#define EXPOSED_FIELD_clipBoundary	70
#define EXPOSED_FIELD_closed	71
#define EXPOSED_FIELD_collidables	72
#define EXPOSED_FIELD_collide	73
#define EXPOSED_FIELD_collider	74
#define EXPOSED_FIELD_collisionType	75
#define EXPOSED_FIELD_color	76
#define EXPOSED_FIELD_colorSteps	77
#define EXPOSED_FIELD_constantForceMix	78
#define EXPOSED_FIELD_contactNormal	79
#define EXPOSED_FIELD_contactSurfaceThickness	80
#define EXPOSED_FIELD_contourStepSize	81
#define EXPOSED_FIELD_controlPoint	82
#define EXPOSED_FIELD_coolColor	83
#define EXPOSED_FIELD_coord	84
#define EXPOSED_FIELD_createParticles	85
#define EXPOSED_FIELD_crossSectionCurve	86
#define EXPOSED_FIELD_cryptoKeyID	87
#define EXPOSED_FIELD_cryptoSystem	88
#define EXPOSED_FIELD_cutOffAngle	89
#define EXPOSED_FIELD_cycleInterval	90
#define EXPOSED_FIELD_data	91
#define EXPOSED_FIELD_dataLength	92
#define EXPOSED_FIELD_deadReckoning	93
#define EXPOSED_FIELD_deletionAllowed	94
#define EXPOSED_FIELD_depth	95
#define EXPOSED_FIELD_description	96
#define EXPOSED_FIELD_desiredAngularVelocity1	97
#define EXPOSED_FIELD_desiredAngularVelocity2	98
#define EXPOSED_FIELD_detonationLocation	99
#define EXPOSED_FIELD_detonationRelativeLocation	100
#define EXPOSED_FIELD_detonationResult	101
#define EXPOSED_FIELD_diffuseColor	102
#define EXPOSED_FIELD_dimensions	103
#define EXPOSED_FIELD_direction	104
#define EXPOSED_FIELD_disableAngularSpeed	105
#define EXPOSED_FIELD_disableLinearSpeed	106
#define EXPOSED_FIELD_disableTime	107
#define EXPOSED_FIELD_diskAngle	108
#define EXPOSED_FIELD_displacements	109
#define EXPOSED_FIELD_displacers	110
#define EXPOSED_FIELD_displayed	111
#define EXPOSED_FIELD_easeInEaseOut	112
#define EXPOSED_FIELD_edgeColor	113
#define EXPOSED_FIELD_effects	114
#define EXPOSED_FIELD_emissiveColor	115
#define EXPOSED_FIELD_enabled	116
#define EXPOSED_FIELD_enabledAxes	117
#define EXPOSED_FIELD_encodingScheme	118
#define EXPOSED_FIELD_entityCategory	119
#define EXPOSED_FIELD_entityCountry	120
#define EXPOSED_FIELD_entityDomain	121
#define EXPOSED_FIELD_entityExtra	122
#define EXPOSED_FIELD_entityID	123
#define EXPOSED_FIELD_entityKind	124
#define EXPOSED_FIELD_entitySpecific	125
#define EXPOSED_FIELD_entitySubCategory	126
#define EXPOSED_FIELD_errorCorrection	127
#define EXPOSED_FIELD_eventApplicationID	128
#define EXPOSED_FIELD_eventEntityID	129
#define EXPOSED_FIELD_eventNumber	130
#define EXPOSED_FIELD_eventSiteID	131
#define EXPOSED_FIELD_fieldOfView	132
#define EXPOSED_FIELD_fillProperties	133
#define EXPOSED_FIELD_filled	134
#define EXPOSED_FIELD_filter	135
#define EXPOSED_FIELD_finiteRotationAxis	136
#define EXPOSED_FIELD_fireMissionIndex	137
#define EXPOSED_FIELD_fired1	138
#define EXPOSED_FIELD_fired2	139
#define EXPOSED_FIELD_firingRange	140
#define EXPOSED_FIELD_firingRate	141
#define EXPOSED_FIELD_fixed	142
#define EXPOSED_FIELD_floatInp	143
#define EXPOSED_FIELD_fogCoord	144
#define EXPOSED_FIELD_fogType	145
#define EXPOSED_FIELD_fontStyle	146
#define EXPOSED_FIELD_force	147
#define EXPOSED_FIELD_forceID	148
#define EXPOSED_FIELD_forceOutput	149
#define EXPOSED_FIELD_forces	150
#define EXPOSED_FIELD_fovMode	151
#define EXPOSED_FIELD_frequency	152
#define EXPOSED_FIELD_frictionCoefficients	153
#define EXPOSED_FIELD_frictionDirection	154
#define EXPOSED_FIELD_front	155
#define EXPOSED_FIELD_frontTexture	156
#define EXPOSED_FIELD_frontUrl	157
#define EXPOSED_FIELD_function	158
#define EXPOSED_FIELD_fuse	159
#define EXPOSED_FIELD_geoCenter	160
#define EXPOSED_FIELD_geoCoords	161
#define EXPOSED_FIELD_geometry	162
#define EXPOSED_FIELD_geometry1	163
#define EXPOSED_FIELD_geometry2	164
#define EXPOSED_FIELD_global	165
#define EXPOSED_FIELD_gotEvents	166
#define EXPOSED_FIELD_gradientThreshold	167
#define EXPOSED_FIELD_gradients	168
#define EXPOSED_FIELD_gravity	169
#define EXPOSED_FIELD_groundAngle	170
#define EXPOSED_FIELD_groundColor	171
#define EXPOSED_FIELD_gustiness	172
#define EXPOSED_FIELD_handler	173
#define EXPOSED_FIELD_hatchColor	174
#define EXPOSED_FIELD_hatchStyle	175
#define EXPOSED_FIELD_hatched	176
#define EXPOSED_FIELD_headlight	177
#define EXPOSED_FIELD_image	178
#define EXPOSED_FIELD_index	179
#define EXPOSED_FIELD_inertia	180
#define EXPOSED_FIELD_inputSource	181
#define EXPOSED_FIELD_int32Inp	182
#define EXPOSED_FIELD_integerKey	183
#define EXPOSED_FIELD_intensity	184
#define EXPOSED_FIELD_intensityThreshold	185
#define EXPOSED_FIELD_internal	186
#define EXPOSED_FIELD_isPickable	187
#define EXPOSED_FIELD_iterations	188
#define EXPOSED_FIELD_joints	189
#define EXPOSED_FIELD_jump	190
#define EXPOSED_FIELD_key	191
#define EXPOSED_FIELD_keyValue	192
#define EXPOSED_FIELD_keyVelocity	193
#define EXPOSED_FIELD_knot	194
#define EXPOSED_FIELD_layers	195
#define EXPOSED_FIELD_layout	196
#define EXPOSED_FIELD_left	197
#define EXPOSED_FIELD_leftTexture	198
#define EXPOSED_FIELD_leftUrl	199
#define EXPOSED_FIELD_length	200
#define EXPOSED_FIELD_lengthOfModulationParameters	201
#define EXPOSED_FIELD_level	202
#define EXPOSED_FIELD_lifetimeVariation	203
#define EXPOSED_FIELD_lighting	204
#define EXPOSED_FIELD_limitOrientation	205
#define EXPOSED_FIELD_lineProperties	206
#define EXPOSED_FIELD_linearAcceleration	207
#define EXPOSED_FIELD_linearDampingFactor	208
#define EXPOSED_FIELD_linearVelocity	209
#define EXPOSED_FIELD_linetype	210
#define EXPOSED_FIELD_linewidthScaleFactor	211
#define EXPOSED_FIELD_listenfor	212
#define EXPOSED_FIELD_llimit	213
#define EXPOSED_FIELD_load	214
#define EXPOSED_FIELD_location	215
#define EXPOSED_FIELD_loop	216
#define EXPOSED_FIELD_magnificationFilter	217
#define EXPOSED_FIELD_mapping	218
#define EXPOSED_FIELD_marking	219
#define EXPOSED_FIELD_mass	220
#define EXPOSED_FIELD_massDensityModel	221
#define EXPOSED_FIELD_matchCriterion	222
#define EXPOSED_FIELD_material	223
#define EXPOSED_FIELD_matrix	224
#define EXPOSED_FIELD_maxAngle	225
#define EXPOSED_FIELD_maxAngle1	226
#define EXPOSED_FIELD_maxBack	227
#define EXPOSED_FIELD_maxCorrectionSpeed	228
#define EXPOSED_FIELD_maxExtent	229
#define EXPOSED_FIELD_maxFront	230
#define EXPOSED_FIELD_maxParticles	231
#define EXPOSED_FIELD_maxPosition	232
#define EXPOSED_FIELD_maxSeparation	233
#define EXPOSED_FIELD_maxTorque1	234
#define EXPOSED_FIELD_maxTorque2	235
#define EXPOSED_FIELD_metadata	236
#define EXPOSED_FIELD_minAngle	237
#define EXPOSED_FIELD_minAngle1	238
#define EXPOSED_FIELD_minBack	239
#define EXPOSED_FIELD_minBounceSpeed	240
#define EXPOSED_FIELD_minFront	241
#define EXPOSED_FIELD_minPosition	242
#define EXPOSED_FIELD_minSeparation	243
#define EXPOSED_FIELD_minificationFilter	244
#define EXPOSED_FIELD_mode	245
#define EXPOSED_FIELD_modulationTypeDetail	246
#define EXPOSED_FIELD_modulationTypeMajor	247
#define EXPOSED_FIELD_modulationTypeSpreadSpectrum	248
#define EXPOSED_FIELD_modulationTypeSystem	249
#define EXPOSED_FIELD_momentsOfInertia	250
#define EXPOSED_FIELD_multicastRelayHost	251
#define EXPOSED_FIELD_multicastRelayPort	252
#define EXPOSED_FIELD_munitionApplicationID	253
#define EXPOSED_FIELD_munitionEndPoint	254
#define EXPOSED_FIELD_munitionEntityID	255
#define EXPOSED_FIELD_munitionQuantity	256
#define EXPOSED_FIELD_munitionSiteID	257
#define EXPOSED_FIELD_munitionStartPoint	258
#define EXPOSED_FIELD_name	259
#define EXPOSED_FIELD_navType	260
#define EXPOSED_FIELD_networkMode	261
#define EXPOSED_FIELD_normal	262
#define EXPOSED_FIELD_normalizeVelocity	263
#define EXPOSED_FIELD_objectType	264
#define EXPOSED_FIELD_offset	265
#define EXPOSED_FIELD_offsetUnits	266
#define EXPOSED_FIELD_on	267
#define EXPOSED_FIELD_opacityFactor	268
#define EXPOSED_FIELD_order	269
#define EXPOSED_FIELD_orientation	270
#define EXPOSED_FIELD_orthogonalColor	271
#define EXPOSED_FIELD_parallelColor	272
#define EXPOSED_FIELD_parameter	273
#define EXPOSED_FIELD_particleLifetime	274
#define EXPOSED_FIELD_particleSize	275
#define EXPOSED_FIELD_parts	276
#define EXPOSED_FIELD_pauseTime	277
#define EXPOSED_FIELD_pickTarget	278
#define EXPOSED_FIELD_pickable	279
#define EXPOSED_FIELD_pickingGeometry	280
#define EXPOSED_FIELD_pitch	281
#define EXPOSED_FIELD_plane	282
#define EXPOSED_FIELD_point	283
#define EXPOSED_FIELD_pointSize	284
#define EXPOSED_FIELD_port	285
#define EXPOSED_FIELD_position	286
#define EXPOSED_FIELD_power	287
#define EXPOSED_FIELD_preferAccuracy	288
#define EXPOSED_FIELD_priority	289
#define EXPOSED_FIELD_profileCurve	290
#define EXPOSED_FIELD_programs	291
#define EXPOSED_FIELD_protocol	292
#define EXPOSED_FIELD_radioEntityTypeCategory	293
#define EXPOSED_FIELD_radioEntityTypeCountry	294
#define EXPOSED_FIELD_radioEntityTypeDomain	295
#define EXPOSED_FIELD_radioEntityTypeKind	296
#define EXPOSED_FIELD_radioEntityTypeNomenclature	297
#define EXPOSED_FIELD_radioEntityTypeNomenclatureVersion	298
#define EXPOSED_FIELD_radioID	299
#define EXPOSED_FIELD_radius	300
#define EXPOSED_FIELD_readInterval	301
#define EXPOSED_FIELD_receivedPower	302
#define EXPOSED_FIELD_receiverState	303
#define EXPOSED_FIELD_relativeAntennaLocation	304
#define EXPOSED_FIELD_renderStyle	305
#define EXPOSED_FIELD_resumeTime	306
#define EXPOSED_FIELD_retainUserOffsets	307
#define EXPOSED_FIELD_retainedOpacity	308
#define EXPOSED_FIELD_right	309
#define EXPOSED_FIELD_rightTexture	310
#define EXPOSED_FIELD_rightUrl	311
#define EXPOSED_FIELD_rotation	312
#define EXPOSED_FIELD_rtpHeaderExpected	313
#define EXPOSED_FIELD_sampleRate	314
#define EXPOSED_FIELD_samples	315
#define EXPOSED_FIELD_scale	316
#define EXPOSED_FIELD_scaleMode	317
#define EXPOSED_FIELD_scaleOrientation	318
#define EXPOSED_FIELD_segmentEnabled	319
#define EXPOSED_FIELD_segmentIdentifiers	320
#define EXPOSED_FIELD_segments	321
#define EXPOSED_FIELD_separateBackColor	322
#define EXPOSED_FIELD_shaders	323
#define EXPOSED_FIELD_shadows	324
#define EXPOSED_FIELD_shape	325
#define EXPOSED_FIELD_shininess	326
#define EXPOSED_FIELD_silhouetteBoundaryOpacity	327
#define EXPOSED_FIELD_silhouetteRetainedOpacity	328
#define EXPOSED_FIELD_silhouetteSharpness	329
#define EXPOSED_FIELD_siteID	330
#define EXPOSED_FIELD_sites	331
#define EXPOSED_FIELD_size	332
#define EXPOSED_FIELD_sizeUnits	333
#define EXPOSED_FIELD_skeleton	334
#define EXPOSED_FIELD_skin	335
#define EXPOSED_FIELD_skinCoord	336
#define EXPOSED_FIELD_skinCoordIndex	337
#define EXPOSED_FIELD_skinCoordWeight	338
#define EXPOSED_FIELD_skinNormal	339
#define EXPOSED_FIELD_skyAngle	340
#define EXPOSED_FIELD_skyColor	341
#define EXPOSED_FIELD_sliderForce	342
#define EXPOSED_FIELD_slipCoefficients	343
#define EXPOSED_FIELD_slipFactors	344
#define EXPOSED_FIELD_softnessConstantForceMix	345
#define EXPOSED_FIELD_softnessErrorCorrection	346
#define EXPOSED_FIELD_source	347
#define EXPOSED_FIELD_specularColor	348
#define EXPOSED_FIELD_speed	349
#define EXPOSED_FIELD_startTime	350
#define EXPOSED_FIELD_stiffness	351
#define EXPOSED_FIELD_stop1Bounce	352
#define EXPOSED_FIELD_stop1ErrorCorrection	353
#define EXPOSED_FIELD_stop2Bounce	354
#define EXPOSED_FIELD_stop2ErrorCorrection	355
#define EXPOSED_FIELD_stop3Bounce	356
#define EXPOSED_FIELD_stop3ErrorCorrection	357
#define EXPOSED_FIELD_stopBounce	358
#define EXPOSED_FIELD_stopBounce1	359
#define EXPOSED_FIELD_stopConstantForceMix1	360
#define EXPOSED_FIELD_stopErrorCorrection	361
#define EXPOSED_FIELD_stopErrorCorrection1	362
#define EXPOSED_FIELD_stopTime	363
#define EXPOSED_FIELD_string	364
#define EXPOSED_FIELD_stringInp	365
#define EXPOSED_FIELD_summary	366
#define EXPOSED_FIELD_surface	367
#define EXPOSED_FIELD_surfaceNormals	368
#define EXPOSED_FIELD_surfaceSpeed	369
#define EXPOSED_FIELD_surfaceTolerance	370
#define EXPOSED_FIELD_surfaceValues	371
#define EXPOSED_FIELD_suspensionErrorCorrection	372
#define EXPOSED_FIELD_suspensionForce	373
#define EXPOSED_FIELD_talksTo	374
#define EXPOSED_FIELD_targetObject	375
#define EXPOSED_FIELD_tau	376
#define EXPOSED_FIELD_tdlType	377
#define EXPOSED_FIELD_tessellation	378
#define EXPOSED_FIELD_tessellationScale	379
#define EXPOSED_FIELD_texCoord	380
#define EXPOSED_FIELD_texture	381
#define EXPOSED_FIELD_textureCompression	382
#define EXPOSED_FIELD_texturePriority	383
#define EXPOSED_FIELD_textureTransform	384
#define EXPOSED_FIELD_timeOut	385
#define EXPOSED_FIELD_tolerance	386
#define EXPOSED_FIELD_top	387
#define EXPOSED_FIELD_topTexture	388
#define EXPOSED_FIELD_topUrl	389
#define EXPOSED_FIELD_torques	390
#define EXPOSED_FIELD_trajectoryCurve	391
#define EXPOSED_FIELD_transferFunction	392
#define EXPOSED_FIELD_transitionTime	393
#define EXPOSED_FIELD_transitionType	394
#define EXPOSED_FIELD_translation	395
#define EXPOSED_FIELD_transmitFrequencyBandwidth	396
#define EXPOSED_FIELD_transmitState	397
#define EXPOSED_FIELD_transmitterApplicationID	398
#define EXPOSED_FIELD_transmitterEntityID	399
#define EXPOSED_FIELD_transmitterRadioID	400
#define EXPOSED_FIELD_transmitterSiteID	401
#define EXPOSED_FIELD_transparency	402
#define EXPOSED_FIELD_trimmingContour	403
#define EXPOSED_FIELD_turbulence	404
#define EXPOSED_FIELD_type	405
#define EXPOSED_FIELD_uDimension	406
#define EXPOSED_FIELD_uOrder	407
#define EXPOSED_FIELD_uTessellation	408
#define EXPOSED_FIELD_ulimit	409
#define EXPOSED_FIELD_update	410
#define EXPOSED_FIELD_url	411
#define EXPOSED_FIELD_useFiniteRotation	412
#define EXPOSED_FIELD_useGeometry	413
#define EXPOSED_FIELD_useGlobalGravity	414
#define EXPOSED_FIELD_vDimension	415
#define EXPOSED_FIELD_vOrder	416
#define EXPOSED_FIELD_vTessellation	417
#define EXPOSED_FIELD_value	418
#define EXPOSED_FIELD_variation	419
#define EXPOSED_FIELD_vector	420
#define EXPOSED_FIELD_version	421
#define EXPOSED_FIELD_vertexCount	422
#define EXPOSED_FIELD_vertices	423
#define EXPOSED_FIELD_viewpoints	424
#define EXPOSED_FIELD_viewport	425
#define EXPOSED_FIELD_visibilityLimit	426
#define EXPOSED_FIELD_visibilityRange	427
#define EXPOSED_FIELD_visible	428
#define EXPOSED_FIELD_voxels	429
#define EXPOSED_FIELD_warhead	430
#define EXPOSED_FIELD_warmColor	431
#define EXPOSED_FIELD_watchList	432
#define EXPOSED_FIELD_weight	433
#define EXPOSED_FIELD_weightConstant1	434
#define EXPOSED_FIELD_weightConstant2	435
#define EXPOSED_FIELD_weightTransferFunction1	436
#define EXPOSED_FIELD_weightTransferFunction2	437
#define EXPOSED_FIELD_whichChoice	438
#define EXPOSED_FIELD_whichGeometry	439
#define EXPOSED_FIELD_writeInterval	440


/* Table of built-in fieldIds */
extern const char *FIELD[];
extern const int FIELD_COUNT;
#define FIELD_autoCalc	0
#define FIELD_bboxCenter	1
#define FIELD_bboxSize	2
#define FIELD_beginCap	3
#define FIELD_bottomRadius	4
#define FIELD_category	5
#define FIELD_ccw	6
#define FIELD_child1Url	7
#define FIELD_child2Url	8
#define FIELD_child3Url	9
#define FIELD_child4Url	10
#define FIELD_closed	11
#define FIELD_closureType	12
#define FIELD_collidable	13
#define FIELD_colorIndex	14
#define FIELD_colorKey	15
#define FIELD_colorPerVertex	16
#define FIELD_colorRamp	17
#define FIELD_convex	18
#define FIELD_coordIndex	19
#define FIELD_country	20
#define FIELD_creaseAngle	21
#define FIELD_crossSection	22
#define FIELD_directOutput	23
#define FIELD_domain	24
#define FIELD_duration	25
#define FIELD_emitter	26
#define FIELD_endAngle	27
#define FIELD_endCap	28
#define FIELD_extra	29
#define FIELD_family	30
#define FIELD_fanCount	31
#define FIELD_forceTransitions	32
#define FIELD_generateMipMaps	33
#define FIELD_geoGridOrigin	34
#define FIELD_geoOrigin	35
#define FIELD_geoSystem	36
#define FIELD_geometryType	37
#define FIELD_height	38
#define FIELD_horizontal	39
#define FIELD_index	40
#define FIELD_info	41
#define FIELD_initialDestination	42
#define FIELD_initialValue	43
#define FIELD_innerRadius	44
#define FIELD_intersectionType	45
#define FIELD_justify	46
#define FIELD_kind	47
#define FIELD_knot	48
#define FIELD_language	49
#define FIELD_leftToRight	50
#define FIELD_lineSegments	51
#define FIELD_mass	52
#define FIELD_mustEvaluate	53
#define FIELD_normalIndex	54
#define FIELD_normalPerVertex	55
#define FIELD_numComponents	56
#define FIELD_order	57
#define FIELD_outerRadius	58
#define FIELD_phaseFunction	59
#define FIELD_physics	60
#define FIELD_proxy	61
#define FIELD_range	62
#define FIELD_reference	63
#define FIELD_repeatR	64
#define FIELD_repeatS	65
#define FIELD_repeatT	66
#define FIELD_rootNode	67
#define FIELD_rootUrl	68
#define FIELD_rotateYUp	69
#define FIELD_rtpHeaderExpected	70
#define FIELD_shape	71
#define FIELD_side	72
#define FIELD_size	73
#define FIELD_solid	74
#define FIELD_sortOrder	75
#define FIELD_spacing	76
#define FIELD_spatialize	77
#define FIELD_specific	78
#define FIELD_speedFactor	79
#define FIELD_spine	80
#define FIELD_startAngle	81
#define FIELD_stripCount	82
#define FIELD_style	83
#define FIELD_subcategory	84
#define FIELD_surfaceArea	85
#define FIELD_texCoordIndex	86
#define FIELD_texCoordKey	87
#define FIELD_texCoordRamp	88
#define FIELD_textureProperties	89
#define FIELD_title	90
#define FIELD_topToBottom	91
#define FIELD_type	92
#define FIELD_uClosed	93
#define FIELD_uKnot	94
#define FIELD_vClosed	95
#define FIELD_vKnot	96
#define FIELD_weightFunction1	97
#define FIELD_weightFunction2	98
#define FIELD_xDimension	99
#define FIELD_xSpacing	100
#define FIELD_yScale	101
#define FIELD_zDimension	102
#define FIELD_zSpacing	103


/* Table of built-in keywords */
extern const char *KEYWORDS[];
extern const int KEYWORDS_COUNT;
#define KW_BROTO	0
#define KW_COMPONENT	1
#define KW_DEF	2
#define KW_EXPORT	3
#define KW_EXTERNBROTO	4
#define KW_EXTERNPROTO	5
#define KW_FALSE	6
#define KW_IMPORT	7
#define KW_IS	8
#define KW_META	9
#define KW_NULL	10
#define KW_PROFILE	11
#define KW_PROTO	12
#define KW_ROUTE	13
#define KW_TO	14
#define KW_TRUE	15
#define KW_UNIT	16
#define KW_USE	17
#define KW_eventIn	18
#define KW_eventOut	19
#define KW_exposedField	20
#define KW_field	21
#define KW_initializeOnly	22
#define KW_inputOnly	23
#define KW_inputOutput	24
#define KW_outputOnly	25

const char *stringKeywordType(int st);

/* Table of built-in profiles */
extern const char *PROFILES[];
extern const int PROFILES_COUNT;
#define PRO_CADInterchange	0
#define PRO_Core	1
#define PRO_Full	2
#define PRO_Immersive	3
#define PRO_Interactive	4
#define PRO_Interchange	5
#define PRO_MPEG4	6

const char *stringProfileType(int st);

/* Table of built-in components */
extern const char *COMPONENTS[];
extern const int COMPONENTS_COUNT;
#define COM_CADGeometry	0
#define COM_Core	1
#define COM_CubeMapTexturing	2
#define COM_DIS	3
#define COM_EnvironmentalEffects	4
#define COM_EnvironmentalSensor	5
#define COM_EventUtilities	6
#define COM_Followers	7
#define COM_Geometry2D	8
#define COM_Geometry3D	9
#define COM_Geospatial	10
#define COM_Grouping	11
#define COM_HAnim	12
#define COM_Interpolation	13
#define COM_KeyDeviceSensor	14
#define COM_Layering	15
#define COM_Layout	16
#define COM_Lighting	17
#define COM_NURBS	18
#define COM_Navigation	19
#define COM_Networking	20
#define COM_ParticleSystems	21
#define COM_Picking	22
#define COM_PointDeviceSensor	23
#define COM_Rendering	24
#define COM_RigidBodyPhysics	25
#define COM_Scripting	26
#define COM_Shaders	27
#define COM_Shape	28
#define COM_Sound	29
#define COM_Text	30
#define COM_Texturing	31
#define COM_Texturing3D	32
#define COM_Time	33
#define COM_VolumeRendering	34

const char *stringComponentType(int st);

/* Table of built-in PROTO keywords */
extern const char *PROTOKEYWORDS[];
extern const int PROTOKEYWORDS_COUNT;
#define PKW_initializeOnly	0
#define PKW_inputOnly	1
#define PKW_outputOnly	2
#define PKW_inputOutput	3
#define PKW_field	4
#define PKW_eventIn	5
#define PKW_eventOut	6
#define PKW_exposedField	7

const char *stringPROTOKeywordType(int st);

/* Table of built-in MULTITEXTUREMODE keywords */
extern const char *MULTITEXTUREMODE[];
extern const int MULTITEXTUREMODE_COUNT;
#define MTMODE_ADD	1
#define MTMODE_ADDSIGNED	2
#define MTMODE_ADDSIGNED2X	3
#define MTMODE_ADDSMOOTH	4
#define MTMODE_BLENDCURRENTALPHA	5
#define MTMODE_BLENDDIFFUSEALPHA	6
#define MTMODE_BLENDFACTORALPHA	7
#define MTMODE_BLENDTEXTUREALPHA	8
#define MTMODE_DOTPRODUCT3	9
#define MTMODE_MODULATE	10
#define MTMODE_MODULATE2X	11
#define MTMODE_MODULATE4X	12
#define MTMODE_MODULATEALPHA_ADDCOLOR	13
#define MTMODE_MODULATEINVALPHA_ADDCOLOR	14
#define MTMODE_MODULATEINVCOLOR_ADDALPHA	15
#define MTMODE_OFF	16
#define MTMODE_REPLACE	17
#define MTMODE_SELECTARG1	18
#define MTMODE_SELECTARG2	19
#define MTMODE_SUBTRACT	20

const char *stringMULTITEXTUREMODEType(int st);
#define MULTITEXTUREDefs " \
#define MTMODE_ADD	1\n \
#define MTMODE_ADDSIGNED	2\n \
#define MTMODE_ADDSIGNED2X	3\n \
#define MTMODE_ADDSMOOTH	4\n \
#define MTMODE_BLENDCURRENTALPHA	5\n \
#define MTMODE_BLENDDIFFUSEALPHA	6\n \
#define MTMODE_BLENDFACTORALPHA	7\n \
#define MTMODE_BLENDTEXTUREALPHA	8\n \
#define MTMODE_DOTPRODUCT3	9\n \
#define MTMODE_MODULATE	10\n \
#define MTMODE_MODULATE2X	11\n \
#define MTMODE_MODULATE4X	12\n \
#define MTMODE_MODULATEALPHA_ADDCOLOR	13\n \
#define MTMODE_MODULATEINVALPHA_ADDCOLOR	14\n \
#define MTMODE_MODULATEINVCOLOR_ADDALPHA	15\n \
#define MTMODE_OFF	16\n \
#define MTMODE_REPLACE	17\n \
#define MTMODE_SELECTARG1	18\n \
#define MTMODE_SELECTARG2	19\n \
#define MTMODE_SUBTRACT	20\n \
";

/* Table of built-in MULTITEXTURESOURCE keywords */
extern const char *MULTITEXTURESOURCE[];
extern const int MULTITEXTURESOURCE_COUNT;
#define MTSRC_DIFFUSE	1
#define MTSRC_FACTOR	2
#define MTSRC_SPECULAR	3


/* Table of built-in TEXTURECOORDINATEGENERATOR keywords */
extern const char *TEXTURECOORDINATEGENERATOR[];
extern const int TEXTURECOORDINATEGENERATOR_COUNT;
#define TCGT_CAMERASPACENORMAL    0
#define TCGT_CAMERASPACEPOSITION    1
#define TCGT_CAMERASPACEREFLECTION    2
#define TCGT_COORD    3
#define TCGT_COORD_EYE    4
#define TCGT_NOISE    5
#define TCGT_NOISE_EYE    6
#define TCGT_SPHERE    7
#define TCGT_SPHERE_LOCAL    8
#define TCGT_SPHERE_REFLECT    9
#define TCGT_SPHERE_REFLECT_LOCAL    10

#define TEXTURECOORDINATEGENERATORDefs " \
#define TCGT_CAMERASPACENORMAL    0\n \
#define TCGT_CAMERASPACEPOSITION    1\n \
#define TCGT_CAMERASPACEREFLECTION    2\n \
#define TCGT_COORD    3\n \
#define TCGT_COORD_EYE    4\n \
#define TCGT_NOISE    5\n \
#define TCGT_NOISE_EYE    6\n \
#define TCGT_SPHERE    7\n \
#define TCGT_SPHERE_LOCAL    8\n \
#define TCGT_SPHERE_REFLECT    9\n \
#define TCGT_SPHERE_REFLECT_LOCAL    10\n \
";
const char *stringMULTITEXTURESOURCEType(int st);

/* Table of built-in MULTITEXTUREFUNCTION keywords */
extern const char *MULTITEXTUREFUNCTION[];
extern const int MULTITEXTUREFUNCTION_COUNT;
#define MTFN_ALPHAREPLICATE	0
#define MTFN_COMPLEMENT	1

const char *stringMULTITEXTUREFUNCTIONType(int st);

/* Table of built-in X3DSPECIAL keywords */
extern const char *X3DSPECIAL[];
extern const int X3DSPECIAL_COUNT;
#define X3DSP_EXPORT	0
#define X3DSP_ExternProtoDeclare	1
#define X3DSP_Header	2
#define X3DSP_IMPORT	3
#define X3DSP_IS	4
#define X3DSP_ProtoBody	5
#define X3DSP_ProtoDeclare	6
#define X3DSP_ProtoInstance	7
#define X3DSP_ProtoInterface	8
#define X3DSP_ROUTE	9
#define X3DSP_Scene	10
#define X3DSP_X3D	11
#define X3DSP_component	12
#define X3DSP_connect	13
#define X3DSP_field	14
#define X3DSP_fieldValue	15
#define X3DSP_head	16
#define X3DSP_meta	17

const char *stringX3DSPECIALType(int st);

/* Table of built-in TEXTUREBOUNDARY keywords */
extern const char *TEXTUREBOUNDARYKEYWORDS[];
extern const int TEXTUREBOUNDARYKEYWORDS_COUNT;
#define TB_CLAMP	0
#define TB_CLAMP_TO_BOUNDARY	1
#define TB_CLAMP_TO_EDGE	2
#define TB_MIRRORED_REPEAT	3
#define TB_REPEAT	4

const char *stringTEXTUREBOUNDARYKeywordType(int st);

/* Table of built-in TEXTUREMAGNIFICATION keywords */
extern const char *TEXTUREMAGNIFICATIONKEYWORDS[];
extern const int TEXTUREMAGNIFICATIONKEYWORDS_COUNT;
#define TMAG_AVG_PIXEL	0
#define TMAG_DEFAULT	1
#define TMAG_FASTEST	2
#define TMAG_NEAREST_PIXEL	3
#define TMAG_NICEST	4

const char *stringTEXTUREMAGNIFICATIONKeywordType(int st);

/* Table of built-in TEXTUREMINIFICATION keywords */
extern const char *TEXTUREMINIFICATIONKEYWORDS[];
extern const int TEXTUREMINIFICATIONKEYWORDS_COUNT;
#define TMIN_AVG_PIXEL	0
#define TMIN_AVG_PIXEL_AVG_MIPMAP	1
#define TMIN_AVG_PIXEL_NEAREST_MIPMAP	2
#define TMIN_DEFAULT	3
#define TMIN_FASTEST	4
#define TMIN_NEAREST_PIXEL	5
#define TMIN_NEAREST_PIXEL_AVG_MIPMAP	6
#define TMIN_NEAREST_PIXEL_NEAREST_MIPMAP	7
#define TMIN_NICEST	8

const char *stringTEXTUREMINIFICATIONKeywordType(int st);

/* Table of built-in TEXTURECOMPRESSION keywords */
extern const char *TEXTURECOMPRESSIONKEYWORDS[];
extern const int TEXTURECOMPRESSIONKEYWORDS_COUNT;
#define TC_DEFAULT	0
#define TC_FASTEST	1
#define TC_HIGH	2
#define TC_LOW	3
#define TC_MEDIUM	4
#define TC_NICEST	5

const char *stringTEXTURECOMPRESSIONKeywordType(int st);

/* Table of built-in GEOSPATIAL keywords */
extern const char *GEOSPATIAL[];
extern const int GEOSPATIAL_COUNT;
#define GEOSP_AA	0
#define GEOSP_AM	1
#define GEOSP_AN	2
#define GEOSP_BN	3
#define GEOSP_BR	4
#define GEOSP_CC	5
#define GEOSP_CD	6
#define GEOSP_EA	7
#define GEOSP_EB	8
#define GEOSP_EC	9
#define GEOSP_ED	10
#define GEOSP_EE	11
#define GEOSP_EF	12
#define GEOSP_FA	13
#define GEOSP_GC	14
#define GEOSP_GCC	15
#define GEOSP_GD	16
#define GEOSP_GDC	17
#define GEOSP_HE	18
#define GEOSP_HO	19
#define GEOSP_ID	20
#define GEOSP_IN	21
#define GEOSP_KA	22
#define GEOSP_RF	23
#define GEOSP_SA	24
#define GEOSP_UTM	25
#define GEOSP_WD	26
#define GEOSP_WE	27
#define GEOSP_WGS84	28
#define GEOSP_coordinateSystem	29
#define GEOSP_copyright	30
#define GEOSP_dataFormat	31
#define GEOSP_dataUrl	32
#define GEOSP_date	33
#define GEOSP_description	34
#define GEOSP_ellipsoid	35
#define GEOSP_extent	36
#define GEOSP_horizontalDatum	37
#define GEOSP_metadataFormat	38
#define GEOSP_originator	39
#define GEOSP_resolution	40
#define GEOSP_title	41
#define GEOSP_verticalDatum	42

const char *stringGEOSPATIALType(int st);
char mapFieldTypeToEAItype (int st);
int mapEAItypeToFieldType (char st);
int convertToSFType (int st);

/* Table of built-in fieldIds */
extern const char *FIELDTYPES[];
extern const int FIELDTYPES_COUNT;
#define FIELDTYPE_SFFloat	0
#define FIELDTYPE_MFFloat	1
#define FIELDTYPE_SFRotation	2
#define FIELDTYPE_MFRotation	3
#define FIELDTYPE_SFVec3f	4
#define FIELDTYPE_MFVec3f	5
#define FIELDTYPE_SFBool	6
#define FIELDTYPE_MFBool	7
#define FIELDTYPE_SFInt32	8
#define FIELDTYPE_MFInt32	9
#define FIELDTYPE_SFNode	10
#define FIELDTYPE_MFNode	11
#define FIELDTYPE_SFColor	12
#define FIELDTYPE_MFColor	13
#define FIELDTYPE_SFColorRGBA	14
#define FIELDTYPE_MFColorRGBA	15
#define FIELDTYPE_SFTime	16
#define FIELDTYPE_MFTime	17
#define FIELDTYPE_SFString	18
#define FIELDTYPE_MFString	19
#define FIELDTYPE_SFVec2f	20
#define FIELDTYPE_MFVec2f	21
#define FIELDTYPE_FreeWRLPTR	22
#define FIELDTYPE_SFImage	23
#define FIELDTYPE_SFVec3d	24
#define FIELDTYPE_MFVec3d	25
#define FIELDTYPE_SFDouble	26
#define FIELDTYPE_MFDouble	27
#define FIELDTYPE_SFMatrix3f	28
#define FIELDTYPE_MFMatrix3f	29
#define FIELDTYPE_SFMatrix3d	30
#define FIELDTYPE_MFMatrix3d	31
#define FIELDTYPE_SFMatrix4f	32
#define FIELDTYPE_MFMatrix4f	33
#define FIELDTYPE_SFMatrix4d	34
#define FIELDTYPE_MFMatrix4d	35
#define FIELDTYPE_SFVec2d	36
#define FIELDTYPE_MFVec2d	37
#define FIELDTYPE_SFVec4f	38
#define FIELDTYPE_MFVec4f	39
#define FIELDTYPE_SFVec4d	40
#define FIELDTYPE_MFVec4d	41
#define FIELDTYPE_FreeWRLThread	42

/*cstruct*/
struct Multi_Float { int n; float  *p; };
struct SFRotation { float c[4]; };
struct Multi_Rotation { int n; struct SFRotation  *p; };
struct SFVec3f { float c[3]; };
struct Multi_Vec3f { int n; struct SFVec3f  *p; };
/*cstruct*/
struct Multi_Bool { int n; int  *p; };
/*cstruct*/
struct Multi_Int32 { int n; int  *p; };

struct Multi_Node { int n; struct X3D_Node * *p; };
struct SFColor { float c[3]; };
struct Multi_Color { int n; struct SFColor  *p; };
struct SFColorRGBA { float c[4]; };
struct Multi_ColorRGBA { int n; struct SFColorRGBA  *p; };
/*cstruct*/
struct Multi_Time { int n; double  *p; };
/*cstruct*/
struct Multi_String { int n; struct Uni_String * *p; };
struct SFVec2f { float c[2]; };
struct Multi_Vec2f { int n; struct SFVec2f  *p; };
/*cstruct*/
/*cstruct*/
struct SFVec3d { double c[3]; };
struct Multi_Vec3d { int n; struct SFVec3d  *p; };
/*cstruct*/
struct Multi_Double { int n; double  *p; };
struct SFMatrix3f { float c[9]; };
struct Multi_Matrix3f { int n; struct SFMatrix3f  *p; };
struct SFMatrix3d { double c[9]; };
struct Multi_Matrix3d { int n; struct SFMatrix3d  *p; };
struct SFMatrix4f { float c[16]; };
struct Multi_Matrix4f { int n; struct SFMatrix4f  *p; };
struct SFMatrix4d { double c[16]; };
struct Multi_Matrix4d { int n; struct SFMatrix4d  *p; };
struct SFVec2d { double c[2]; };
struct Multi_Vec2d { int n; struct SFVec2d  *p; };
struct SFVec4f { float c[4]; };
struct Multi_Vec4f { int n; struct SFVec4f  *p; };
struct SFVec4d { double c[4]; };
struct Multi_Vec4d { int n; struct SFVec4d  *p; };
/*cstruct*/
const char *stringFieldtypeType(int st);

/* Table of built-in nodeIds */
extern const char *NODES[];
extern const int NODES_COUNT;

/* and now the structs for the nodetypes */ 
const char *stringNodeType(int st);

/* First, a generic struct, contains only the common elements - nicknames for convenience */
struct X3D_Node {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
};
#define X3D_LINEPROPERTIES(node) ((struct X3D_LineProperties*)node)
#define X3D_FILLPROPERTIES(node) ((struct X3D_FillProperties*)node)
#define X3D_TEXTURE_TRANSFORM(node) ((struct X3D_TextureTransform*)node)
#define X3D_NODE(node) ((struct X3D_Node*)node)
#define X3D_APPEARANCE(node) ((struct X3D_Appearance*)node)
#define X3D_MATERIAL(node) ((struct X3D_Material*)node)
#define X3D_TWOSIDEDMATERIAL(node) ((struct X3D_TwoSidedMaterial*)node)
#define X3D_GROUP(node) ((struct X3D_Group*)node)
#define X3D_PROTO(node) ((struct X3D_Proto*)node)
#define X3D_PICKABLEGROUP(node) ((struct X3D_PickableGroup*)node)
#define X3D_POINTPICKSENSOR(node) ((struct X3D_PointPickSensor*)node)
#define X3D_STATICGROUP(node) ((struct X3D_StaticGroup*)node)
#define X3D_ANCHOR(node) ((struct X3D_Anchor*)node)
#define X3D_COLLISION(node) ((struct X3D_Collision*)node)
#define X3D_COMPOSEDSHADER(node) ((struct X3D_ComposedShader*)node)
#define X3D_EFFECT(node) ((struct X3D_Effect*)node)
#define X3D_PACKAGEDSHADER(node) ((struct X3D_PackagedShader*)node)
#define X3D_PROGRAMSHADER(node) ((struct X3D_ProgramShader*)node)
#define X3D_SHADERPROGRAM(node) ((struct X3D_ShaderProgram*)node)
#define X3D_SHAPE(node) ((struct X3D_Shape*)node)
#define X3D_VISIBILITYSENSOR(node) ((struct X3D_VisibilitySensor*)node)
#define X3D_BILLBOARD(node) ((struct X3D_Billboard*)node)
#define X3D_NAVIGATIONINFO(node) ((struct X3D_NavigationInfo*)node)
#define X3D_BACKGROUND(node) ((struct X3D_Background*)node)
#define X3D_TEXTUREBACKGROUND(node) ((struct X3D_TextureBackground*)node)
#define X3D_FOG(node) ((struct X3D_Fog*)node)
#define X3D_INLINE(node) ((struct X3D_Inline*)node)
#define X3D_SWITCH(node) ((struct X3D_Switch*)node)
#define X3D_CADASSEMBLY(node) ((struct X3D_CADAssembly*)node)
#define X3D_CADFACE(node) ((struct X3D_CADFace*)node)
#define X3D_CADLAYER(node) ((struct X3D_CADLayer*)node)
#define X3D_CADPART(node) ((struct X3D_CADPart*)node)
#define X3D_SCRIPT(node) ((struct X3D_Script*)node)
#define X3D_VIEWPOINT(node) ((struct X3D_Viewpoint*)node)
#define X3D_ORTHOVIEWPOINT(node) ((struct X3D_OrthoViewpoint*)node)
#define X3D_LODNODE(node) ((struct X3D_LOD*)node)
#define X3D_TRANSFORM(node) ((struct X3D_Transform*)node)
#define X3D_PROXIMITYSENSOR(node) ((struct X3D_ProximitySensor*)node)
#define X3D_POINTLIGHT(node) ((struct X3D_PointLight*)node)
#define X3D_SPOTLIGHT(node) ((struct X3D_SpotLight*)node)
#define X3D_DIRECTIONALLIGHT(node) ((struct X3D_DirectionalLight*)node)
#define X3D_INDEXEDFACESET(node) ((struct X3D_IndexedFaceSet*)node)
#define X3D_INDEXEDLINESET(node) ((struct X3D_IndexedLineSet*)node)
#define X3D_ELEVATIONGRID(node) ((struct X3D_ElevationGrid*)node)
#define X3D_INDEXEDTRIANGLEFANSET(node) ((struct X3D_IndexedTriangleFanSet*)node)
#define X3D_INDEXEDTRIANGLESET(node) ((struct X3D_IndexedTriangleSet*)node)
#define X3D_INDEXEDTRIANGLESTRIPSET(node) ((struct X3D_IndexedTriangleStripSet*)node)
#define X3D_TRIANGLEFANSET(node) ((struct X3D_TriangleFanSet*)node)
#define X3D_TRIANGLESET(node) ((struct X3D_TriangleSet*)node)
#define X3D_TRIANGLESTRIPSET(node) ((struct X3D_TriangleStripSet*)node)
#define X3D_QUADSET(node) ((struct X3D_QuadSet*)node)
#define X3D_INDEXEDQUADSET(node) ((struct X3D_IndexedQuadSet*)node)
#define X3D_VIEWPORT(node) ((struct X3D_Viewport*)node)
#define X3D_LAYOUT(node) ((struct X3D_Layout*)node)
#define X3D_LAYERSET(node) ((struct X3D_LayerSet*)node)
#define X3D_GEOORIGIN(node) ((struct X3D_GeoOrigin*)node)
#define X3D_GEOLOD(node) ((struct X3D_GeoLOD*)node)
#define X3D_GEOCOORD(node) ((struct X3D_GeoCoordinate*)node)
#define X3D_GEOVIEWPOINT(node) ((struct X3D_GeoViewpoint*)node)
#define X3D_GEOELEVATIONGRID(node) ((struct X3D_GeoElevationGrid*)node)
#define X3D_GEOLOCATION(node) ((struct X3D_GeoLocation*)node)
#define X3D_GEOTRANSFORM(node) ((struct X3D_GeoTransform*)node)
#define X3D_GEOPROXIMITYSENSOR(node) ((struct X3D_GeoProximitySensor*)node)
#define X3D_COLOR(node) ((struct X3D_Color*)node)
#define X3D_COORDINATE(node) ((struct X3D_Coordinate*)node)
#define X3D_COORDINATEINTERPOLATOR(node) ((struct X3D_CoordinateInterpolator*)node)
#define X3D_NORMAL(node) ((struct X3D_Normal*)node)
#define X3D_TEXTURECOORDINATE(node) ((struct X3D_TextureCoordinate*)node)
#define X3D_IMAGETEXTURE(node) ((struct X3D_ImageTexture*)node)
#define X3D_TEXTUREPROPERTIES(node) ((struct X3D_TextureProperties*)node)
#define X3D_PIXELTEXTURE(node) ((struct X3D_PixelTexture*)node)
#undef DEBUG_VALIDNODE
#ifdef DEBUG_VALIDNODE	
#define X3D_NODE_CHECK(node) checkNode(node,__FILE__,__LINE__)
#define MARK_EVENT(node,offset) mark_event_check(node,(int) offset,__FILE__,__LINE__)
#else
#define X3D_NODE_CHECK(node)
#define MARK_EVENT(node,offset)	mark_event(node,(int) offset)
#endif
#define COPY_SFVEC3F_TO_POINT_XYZ(too,from) { too.x = from[0]; too.y = from[1]; too.z = from[2];}
#define COPY_POINT_XYZ_TO_SFVEC3F(too,from) { too[0] = (float) from.x; too[1] = (float) from.y; too[2] = (float) from.z;}
#define offsetPointer_deref(t, me, offs) ((t)(((char*)(me))+offs))

/* now, generated structures for each VRML/X3D Node*/
/***********************/
struct X3D_Anchor {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Node addChildren;
	struct Multi_Node removeChildren;
	struct Multi_Node __sibAffectors;
	struct Multi_Node children;
	struct Uni_String *description;
	struct X3D_Node *metadata;
	struct Multi_String parameter;
	struct Multi_String url;
	struct SFVec3f bboxCenter;
	struct SFVec3f bboxSize;
	void * _parentResource;
};
extern struct X3D_Virt virt_Anchor;
/***********************/
struct X3D_Appearance {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *fillProperties;
	struct X3D_Node *lineProperties;
	struct X3D_Node *material;
	struct X3D_Node *metadata;
	struct Multi_Node shaders;
	struct Multi_Node effects;
	struct X3D_Node *texture;
	struct X3D_Node *textureTransform;
};
extern struct X3D_Virt virt_Appearance;
/***********************/
struct X3D_Arc2D {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	float endAngle;
	float radius;
	float startAngle;
	struct Multi_Vec2f __points;
	int __numPoints;
};
extern struct X3D_Virt virt_Arc2D;
/***********************/
struct X3D_ArcClose2D {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct Uni_String *closureType;
	float endAngle;
	float radius;
	int solid;
	float startAngle;
	struct Multi_Vec2f __points;
	int __numPoints;
};
extern struct X3D_Virt virt_ArcClose2D;
/***********************/
struct X3D_AudioClip {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Uni_String *description;
	int loop;
	struct X3D_Node *metadata;
	double pauseTime;
	float pitch;
	double resumeTime;
	double startTime;
	double stopTime;
	struct Multi_String url;
	double duration_changed;
	double elapsedTime;
	int isActive;
	int isPaused;
	void * _parentResource;
	int __loadstatus;
	void * __loadResource;
	int __sourceNumber;
	double __inittime;
	double __lasttime;
};
extern struct X3D_Virt virt_AudioClip;
/***********************/
struct X3D_BackdropBackground {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int set_bind;
	double bindTime;
	int isBound;
	float transparency;
	struct SFColor color;
	struct X3D_Node *metadata;
	int __texture;
	int __VBO;
	struct Multi_String url;
};
extern struct X3D_Virt virt_BackdropBackground;
/***********************/
struct X3D_Background {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int set_bind;
	struct Multi_Float groundAngle;
	struct Multi_Color groundColor;
	struct Multi_Float skyAngle;
	struct Multi_Color skyColor;
	double bindTime;
	int isBound;
	int _layerId;
	void * _parentResource;
	struct Multi_Vec3f __points;
	struct Multi_Color __colours;
	int __quadcount;
	float transparency;
	struct Multi_String frontUrl;
	struct Multi_String backUrl;
	struct Multi_String topUrl;
	struct Multi_String bottomUrl;
	struct Multi_String leftUrl;
	struct Multi_String rightUrl;
	struct X3D_Node *metadata;
	int __textureright;
	struct X3D_Node *__frontTexture;
	struct X3D_Node *__backTexture;
	struct X3D_Node *__topTexture;
	struct X3D_Node *__bottomTexture;
	struct X3D_Node *__leftTexture;
	struct X3D_Node *__rightTexture;
	int __VBO;
};
extern struct X3D_Virt virt_Background;
/***********************/
struct X3D_BallJoint {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct SFVec3f anchorPoint;
	struct X3D_Node *body1;
	struct X3D_Node *body2;
	struct Multi_String forceOutput;
	struct X3D_Node *metadata;
	struct SFVec3f body1AnchorPoint;
	struct SFVec3f body2AnchorPoint;
	void * _joint;
	int _forceout;
	struct SFVec3f __old_anchorPoint;
	struct X3D_Node *__old_body1;
	struct X3D_Node *__old_body2;
};
extern struct X3D_Virt virt_BallJoint;
/***********************/
struct X3D_Billboard {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Node addChildren;
	struct Multi_Node removeChildren;
	struct Multi_Node __sibAffectors;
	struct SFVec3f axisOfRotation;
	struct Multi_Node children;
	struct SFVec3f bboxCenter;
	struct SFVec3f bboxSize;
	struct X3D_Node *metadata;
	double _rotationAngle;
};
extern struct X3D_Virt virt_Billboard;
/***********************/
struct X3D_BlendedVolumeStyle {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int enabled;
	struct X3D_Node *metadata;
	struct X3D_Node *surfaceNormals;
	struct X3D_Node *renderStyle;
	struct X3D_Node *voxels;
	float weightConstant1;
	float weightConstant2;
	struct Uni_String *weightFunction1;
	struct Uni_String *weightFunction2;
	struct X3D_Node *weightTransferFunction1;
	struct X3D_Node *weightTransferFunction2;
	struct Multi_Int32 _fbohandles;
	int _weightFunction1;
	int _weightFunction2;
};
extern struct X3D_Virt virt_BlendedVolumeStyle;
/***********************/
struct X3D_BooleanFilter {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int set_boolean;
	int inputFalse;
	int inputNegate;
	int inputTrue;
	struct X3D_Node *metadata;
};
extern struct X3D_Virt virt_BooleanFilter;
/***********************/
struct X3D_BooleanSequencer {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int next;
	int previous;
	float set_fraction;
	struct Multi_Float key;
	struct Multi_Bool keyValue;
	int value_changed;
	struct X3D_Node *metadata;
};
extern struct X3D_Virt virt_BooleanSequencer;
/***********************/
struct X3D_BooleanToggle {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int set_boolean;
	int toggle;
	struct X3D_Node *metadata;
};
extern struct X3D_Virt virt_BooleanToggle;
/***********************/
struct X3D_BooleanTrigger {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	double set_triggerTime;
	int triggerTrue;
	struct X3D_Node *metadata;
};
extern struct X3D_Virt virt_BooleanTrigger;
/***********************/
struct X3D_BoundaryEnhancementVolumeStyle {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int enabled;
	struct X3D_Node *metadata;
	float boundaryOpacity;
	float opacityFactor;
	float retainedOpacity;
};
extern struct X3D_Virt virt_BoundaryEnhancementVolumeStyle;
/***********************/
struct X3D_BoundedPhysicsModel {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int enabled;
	struct X3D_Node *geometry;
	struct X3D_Node *metadata;
};
extern struct X3D_Virt virt_BoundedPhysicsModel;
/***********************/
struct X3D_Box {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct SFVec3f size;
	int solid;
	struct Multi_Vec3f __points;
};
extern struct X3D_Virt virt_Box;
/***********************/
struct X3D_CADAssembly {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Node addChildren;
	struct Multi_Node removeChildren;
	struct Multi_Node __sibAffectors;
	struct Multi_Node children;
	struct X3D_Node *metadata;
	struct Uni_String *name;
	struct SFVec3f bboxCenter;
	struct SFVec3f bboxSize;
	struct Multi_Node _sortedChildren;
};
extern struct X3D_Virt virt_CADAssembly;
/***********************/
struct X3D_CADFace {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct Uni_String *name;
	struct X3D_Node *shape;
	struct SFVec3f bboxCenter;
	struct SFVec3f bboxSize;
};
extern struct X3D_Virt virt_CADFace;
/***********************/
struct X3D_CADLayer {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Node addChildren;
	struct Multi_Node removeChildren;
	struct Multi_Node __sibAffectors;
	struct Multi_Node children;
	struct X3D_Node *metadata;
	struct Uni_String *name;
	struct Multi_Bool visible;
	struct SFVec3f bboxCenter;
	struct SFVec3f bboxSize;
};
extern struct X3D_Virt virt_CADLayer;
/***********************/
struct X3D_CADPart {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Node addChildren;
	struct Multi_Node removeChildren;
	struct Multi_Node __sibAffectors;
	struct SFVec3f center;
	struct Multi_Node children;
	struct X3D_Node *metadata;
	struct Uni_String *name;
	struct SFRotation rotation;
	struct SFVec3f scale;
	struct SFRotation scaleOrientation;
	struct SFVec3f translation;
	struct SFVec3f bboxCenter;
	struct SFVec3f bboxSize;
	int __do_center;
	int __do_trans;
	int __do_rotation;
	int __do_scaleO;
	int __do_scale;
	int __do_anything;
	struct Multi_Node _sortedChildren;
};
extern struct X3D_Virt virt_CADPart;
/***********************/
struct X3D_CalibratedCameraSensor {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int enabled;
	int isActive;
	struct X3D_Node *metadata;
	struct Uni_String *description;
	struct Multi_Int32 image;
	struct SFVec2f focalPoint;
	float fieldOfView;
	struct Uni_String *fovMode;
	float aspectRatio;
};
extern struct X3D_Virt virt_CalibratedCameraSensor;
/***********************/
struct X3D_CartoonVolumeStyle {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int enabled;
	struct X3D_Node *metadata;
	struct X3D_Node *surfaceNormals;
	struct SFColorRGBA orthogonalColor;
	struct SFColorRGBA parallelColor;
	int colorSteps;
};
extern struct X3D_Virt virt_CartoonVolumeStyle;
/***********************/
struct X3D_Circle2D {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	float radius;
	struct Multi_Vec2f __points;
	int __numPoints;
};
extern struct X3D_Virt virt_Circle2D;
/***********************/
struct X3D_ClipPlane {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int enabled;
	struct X3D_Node *metadata;
	struct SFVec4f plane;
};
extern struct X3D_Virt virt_ClipPlane;
/***********************/
struct X3D_CollidableOffset {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int enabled;
	struct X3D_Node *metadata;
	struct SFRotation rotation;
	struct SFVec3f translation;
	struct SFVec3f bboxCenter;
	struct SFVec3f bboxSize;
	int __do_trans;
	int __do_rotation;
	struct X3D_Node *collidable;
	void * _geom;
	struct SFRotation _initialRotation;
	struct SFVec3f _initialTranslation;
	int _initialized;
	void * _csensor;
};
extern struct X3D_Virt virt_CollidableOffset;
/***********************/
struct X3D_CollidableShape {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int enabled;
	struct X3D_Node *metadata;
	struct SFRotation rotation;
	struct SFVec3f translation;
	struct SFVec3f bboxCenter;
	struct SFVec3f bboxSize;
	int __do_trans;
	int __do_rotation;
	struct X3D_Node *shape;
	void * _geom;
	struct SFRotation _initialRotation;
	struct SFVec3f _initialTranslation;
	int _initialized;
	void * _csensor;
};
extern struct X3D_Virt virt_CollidableShape;
/***********************/
struct X3D_Collision {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Node addChildren;
	struct Multi_Node removeChildren;
	struct Multi_Node __sibAffectors;
	struct Multi_Node children;
	int enabled;
	int collide;
	struct SFVec3f bboxCenter;
	struct SFVec3f bboxSize;
	struct X3D_Node *proxy;
	double collideTime;
	struct X3D_Node *metadata;
	int __hit;
};
extern struct X3D_Virt virt_Collision;
/***********************/
struct X3D_CollisionCollection {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_String appliedParameters;
	float bounce;
	struct Multi_Node collidables;
	int enabled;
	struct SFVec2f frictionCoefficients;
	struct X3D_Node *metadata;
	float minBounceSpeed;
	struct SFVec2f slipFactors;
	float softnessConstantForceMix;
	float softnessErrorCorrection;
	struct SFVec2f surfaceSpeed;
	void * _class;
	void * _csensor;
	int _appliedParametersMask;
};
extern struct X3D_Virt virt_CollisionCollection;
/***********************/
struct X3D_CollisionSensor {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *collider;
	int enabled;
	struct X3D_Node *metadata;
	struct Multi_Node intersections;
	struct Multi_Node contacts;
	int isActive;
};
extern struct X3D_Virt virt_CollisionSensor;
/***********************/
struct X3D_CollisionSpace {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Node collidables;
	int enabled;
	struct X3D_Node *metadata;
	int useGeometry;
	struct SFVec3f bboxCenter;
	struct SFVec3f bboxSize;
	void * _space;
};
extern struct X3D_Virt virt_CollisionSpace;
/***********************/
struct X3D_Color {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Color color;
	struct X3D_Node *metadata;
};
extern struct X3D_Virt virt_Color;
/***********************/
struct X3D_ColorChaser {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	void * _p;
	void * _t;
	int isActive;
	double duration;
	double _bufferendtime;
	double _steptime;
	struct SFColor value_changed;
	struct SFColor initialDestination;
	struct SFColor initialValue;
	struct SFColor set_destination;
	struct SFColor set_value;
	void * _buffer;
	struct SFColor _previousvalue;
	struct SFColor _destination;
};
extern struct X3D_Virt virt_ColorChaser;
/***********************/
struct X3D_ColorDamper {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	void * _p;
	void * _t;
	double tau;
	float tolerance;
	int isActive;
	int order;
	double _tau;
	double _lasttick;
	int _takefirstinput;
	struct SFColor value_changed;
	struct SFColor initialDestination;
	struct SFColor initialValue;
	struct SFColor set_destination;
	struct SFColor set_value;
	void * _values;
	struct SFColor _input;
};
extern struct X3D_Virt virt_ColorDamper;
/***********************/
struct X3D_ColorInterpolator {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	float set_fraction;
	struct Multi_Float key;
	struct Multi_Color keyValue;
	struct X3D_Node *metadata;
	struct SFColor value_changed;
};
extern struct X3D_Virt virt_ColorInterpolator;
/***********************/
struct X3D_ColorRGBA {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_ColorRGBA color;
	struct X3D_Node *metadata;
};
extern struct X3D_Virt virt_ColorRGBA;
/***********************/
struct X3D_ComposedCubeMapTexture {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct X3D_Node *back;
	struct X3D_Node *bottom;
	struct X3D_Node *front;
	struct X3D_Node *left;
	struct X3D_Node *top;
	struct X3D_Node *right;
	void * _parentResource;
};
extern struct X3D_Virt virt_ComposedCubeMapTexture;
/***********************/
struct X3D_ComposedShader {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int activate;
	struct Multi_Node parts;
	int isSelected;
	int isValid;
	struct Uni_String *language;
	struct X3D_Node *metadata;
	int _initialized;
	struct X3D_Node *_shaderUserDefinedFields;
	int _shaderUserNumber;
	pthread_t _shaderLoadThread;
	int _retrievedURLData;
};
extern struct X3D_Virt virt_ComposedShader;
/***********************/
struct X3D_ComposedTexture3D {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct Multi_Node texture;
	struct X3D_Node *textureProperties;
	int repeatS;
	int repeatT;
	int repeatR;
	int __textureTableIndex;
	void * _parentResource;
};
extern struct X3D_Virt virt_ComposedTexture3D;
/***********************/
struct X3D_ComposedVolumeStyle {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int enabled;
	struct X3D_Node *metadata;
	struct Multi_Node renderStyle;
};
extern struct X3D_Virt virt_ComposedVolumeStyle;
/***********************/
struct X3D_CompositeVolumeStyle {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int enabled;
	struct X3D_Node *metadata;
	struct Multi_Node renderStyle;
};
extern struct X3D_Virt virt_CompositeVolumeStyle;
/***********************/
struct X3D_Cone {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	int bottom;
	float bottomRadius;
	float height;
	int side;
	int solid;
	struct Multi_Vec3f __sidepoints;
	struct Multi_Vec3f __botpoints;
	struct Multi_Vec3f __normals;
	int __coneVBO;
	int __coneTriangles;
	void * __wireindices;
};
extern struct X3D_Virt virt_Cone;
/***********************/
struct X3D_ConeEmitter {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	float angle;
	struct SFVec3f direction;
	struct X3D_Node *metadata;
	struct SFVec3f position;
	float speed;
	float variation;
	float mass;
	float surfaceArea;
};
extern struct X3D_Virt virt_ConeEmitter;
/***********************/
struct X3D_Contact {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_String appliedParameters;
	struct X3D_Node *body1;
	struct X3D_Node *body2;
	float bounce;
	struct SFVec3f contactNormal;
	float depth;
	struct SFVec2f frictionCoefficients;
	struct SFVec3f frictionDirection;
	struct X3D_Node *geometry1;
	struct X3D_Node *geometry2;
	struct X3D_Node *metadata;
	float minBounceSpeed;
	struct SFVec3f position;
	struct SFVec2f slipCoefficients;
	float softnessConstantForceMix;
	float softnessErrorCorrection;
	struct SFVec2f surfaceSpeed;
	int _appliedParameters;
};
extern struct X3D_Virt virt_Contact;
/***********************/
struct X3D_Contour2D {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Node addChildren;
	struct Multi_Node removeChildren;
	struct Multi_Node __sibAffectors;
	struct Multi_Node children;
	struct X3D_Node *metadata;
};
extern struct X3D_Virt virt_Contour2D;
/***********************/
struct X3D_ContourPolyline2D {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct Multi_Vec2d controlPoint;
	struct Multi_Vec2f point;
};
extern struct X3D_Virt virt_ContourPolyline2D;
/***********************/
struct X3D_Coordinate {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Vec3f point;
	struct X3D_Node *metadata;
};
extern struct X3D_Virt virt_Coordinate;
/***********************/
struct X3D_CoordinateChaser {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	void * _p;
	void * _t;
	int isActive;
	double duration;
	double _bufferendtime;
	double _steptime;
	struct Multi_Vec3f value_changed;
	struct Multi_Vec3f initialDestination;
	struct Multi_Vec3f initialValue;
	struct Multi_Vec3f set_destination;
	struct Multi_Vec3f set_value;
	void * _buffer;
	struct Multi_Vec3f _previousvalue;
	struct Multi_Vec3f _destination;
};
extern struct X3D_Virt virt_CoordinateChaser;
/***********************/
struct X3D_CoordinateDamper {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	void * _p;
	void * _t;
	double tau;
	float tolerance;
	int isActive;
	int order;
	double _tau;
	double _lasttick;
	int _takefirstinput;
	struct Multi_Vec3f value_changed;
	struct Multi_Vec3f initialDestination;
	struct Multi_Vec3f initialValue;
	struct Multi_Vec3f set_destination;
	struct Multi_Vec3f set_value;
	void * _values;
	struct Multi_Vec3f _input;
};
extern struct X3D_Virt virt_CoordinateDamper;
/***********************/
struct X3D_CoordinateDouble {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct Multi_Vec3d point;
};
extern struct X3D_Virt virt_CoordinateDouble;
/***********************/
struct X3D_CoordinateInterpolator {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	float set_fraction;
	struct Multi_Float key;
	struct Multi_Vec3f keyValue;
	struct X3D_Node *metadata;
	struct Multi_Vec3f value_changed;
	int _GPU_Routes_out;
	int _CPU_Routes_out;
	int _keyVBO;
	int _keyValueVBO;
};
extern struct X3D_Virt virt_CoordinateInterpolator;
/***********************/
struct X3D_CoordinateInterpolator2D {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	float set_fraction;
	struct Multi_Float key;
	struct Multi_Vec2f keyValue;
	struct X3D_Node *metadata;
	struct Multi_Vec2f value_changed;
};
extern struct X3D_Virt virt_CoordinateInterpolator2D;
/***********************/
struct X3D_Cylinder {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	int bottom;
	float height;
	float radius;
	int side;
	int solid;
	int top;
	struct Multi_Vec3f __points;
	struct Multi_Vec3f __normals;
	int __cylinderVBO;
	int __cylinderTriangles;
	void * __wireindices;
};
extern struct X3D_Virt virt_Cylinder;
/***********************/
struct X3D_CylinderSensor {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int autoOffset;
	struct SFRotation axisRotation;
	float diskAngle;
	int enabled;
	float maxAngle;
	float minAngle;
	float offset;
	int isActive;
	int isOver;
	struct Uni_String *description;
	struct SFRotation rotation_changed;
	struct SFVec3f trackPoint_changed;
	struct X3D_Node *metadata;
	struct SFVec3f _oldtrackPoint;
	struct SFRotation _oldrotation;
	struct SFVec3f _origPoint;
	float _radius;
	int _dlchange;
	int __oldEnabled;
};
extern struct X3D_Virt virt_CylinderSensor;
/***********************/
struct X3D_DISEntityManager {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Uni_String *address;
	int applicationID;
	struct Multi_Node mapping;
	struct X3D_Node *metadata;
	int port;
	int siteID;
	struct Multi_Node addedEntities;
	struct Multi_Node removedEntities;
};
extern struct X3D_Virt virt_DISEntityManager;
/***********************/
struct X3D_DISEntityTypeMapping {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct Multi_String url;
	int category;
	int country;
	int domain;
	int extra;
	int kind;
	int specific;
	int subcategory;
};
extern struct X3D_Virt virt_DISEntityTypeMapping;
/***********************/
struct X3D_DirectionalLight {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	float ambientIntensity;
	struct SFColor color;
	struct SFVec3f direction;
	int global;
	float intensity;
	struct X3D_Node *metadata;
	int on;
	struct SFVec4f _dir;
	struct SFVec4f _col;
	struct SFVec4f _amb;
};
extern struct X3D_Virt virt_DirectionalLight;
/***********************/
struct X3D_Disk2D {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	float innerRadius;
	float outerRadius;
	int solid;
	struct Multi_Vec2f __points;
	struct Multi_Vec2f __texCoords;
	int __numPoints;
	int __simpleDisk;
	void * __wireindices;
};
extern struct X3D_Virt virt_Disk2D;
/***********************/
struct X3D_DoubleAxisHingeJoint {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct SFVec3f anchorPoint;
	struct SFVec3f axis1;
	struct SFVec3f axis2;
	struct X3D_Node *body1;
	struct X3D_Node *body2;
	float desiredAngularVelocity1;
	float desiredAngularVelocity2;
	struct Multi_String forceOutput;
	float maxAngle1;
	float maxTorque1;
	float maxTorque2;
	struct X3D_Node *metadata;
	float minAngle1;
	float stopBounce1;
	float stopConstantForceMix1;
	float stopErrorCorrection1;
	float suspensionErrorCorrection;
	float suspensionForce;
	struct SFVec3f body1AnchorPoint;
	struct SFVec3f body1Axis;
	struct SFVec3f body2AnchorPoint;
	struct SFVec3f body2Axis;
	float hinge1Angle;
	float hinge1AngleRate;
	float hinge2Angle;
	float hinge2AngleRate;
	void * _joint;
	int _forceout;
	struct SFVec3f __old_anchorPoint;
	struct SFVec3f __old_axis1;
	struct SFVec3f __old_axis2;
	struct X3D_Node *__old_body1;
	struct X3D_Node *__old_body2;
	void * _motor1;
	void * _motor2;
	float axis1Angle;
};
extern struct X3D_Virt virt_DoubleAxisHingeJoint;
/***********************/
struct X3D_EaseInEaseOut {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	float set_fraction;
	struct Multi_Vec2f easeInEaseOut;
	struct Multi_Float key;
	struct X3D_Node *metadata;
	float modifiedFraction_changed;
};
extern struct X3D_Virt virt_EaseInEaseOut;
/***********************/
struct X3D_EdgeEnhancementVolumeStyle {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int enabled;
	struct X3D_Node *metadata;
	struct X3D_Node *surfaceNormals;
	struct SFColorRGBA edgeColor;
	float gradientThreshold;
};
extern struct X3D_Virt virt_EdgeEnhancementVolumeStyle;
/***********************/
struct X3D_Effect {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int activate;
	struct Multi_Node parts;
	int isSelected;
	int isValid;
	struct Uni_String *language;
	struct X3D_Node *metadata;
	int _initialized;
	struct X3D_Node *_shaderUserDefinedFields;
	int _shaderUserNumber;
	pthread_t _shaderLoadThread;
	int _retrievedURLData;
};
extern struct X3D_Virt virt_Effect;
/***********************/
struct X3D_EffectPart {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct Multi_String url;
	struct Uni_String *type;
	int __loadstatus;
	void * _parentResource;
	void * __loadResource;
	struct X3D_Node *_shaderUserDefinedFields;
};
extern struct X3D_Virt virt_EffectPart;
/***********************/
struct X3D_ElevationGrid {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Float set_height;
	struct Multi_Node attrib;
	struct X3D_Node *color;
	struct X3D_Node *fogCoord;
	struct X3D_Node *metadata;
	struct X3D_Node *normal;
	struct X3D_Node *texCoord;
	int ccw;
	int colorPerVertex;
	float creaseAngle;
	struct Multi_Float height;
	int normalPerVertex;
	int solid;
	int xDimension;
	float xSpacing;
	int zDimension;
	float zSpacing;
	struct Multi_Int32 _coordIndex;
};
extern struct X3D_Virt virt_ElevationGrid;
/***********************/
struct X3D_EspduTransform {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Node addChildren;
	struct Multi_Node removeChildren;
	struct Multi_Node __sibAffectors;
	float set_articulationParameterValue0;
	float set_articulationParameterValue1;
	float set_articulationParameterValue2;
	float set_articulationParameterValue3;
	float set_articulationParameterValue4;
	float set_articulationParameterValue5;
	float set_articulationParameterValue6;
	float set_articulationParameterValue7;
	struct Uni_String *address;
	int applicationID;
	int articulationParameterCount;
	struct Multi_Int32 articulationParameterDesignatorArray;
	struct Multi_Int32 articulationParameterChangeIndicatorArr;
	struct Multi_Int32 articulationParameterIdPartAttachedToAr;
	struct Multi_Int32 articulationParameterTypeArray;
	struct Multi_Float articulationParameterArray;
	struct SFVec3f center;
	struct Multi_Node children;
	int collisionType;
	int deadReckoning;
	struct SFVec3f detonationLocation;
	struct SFVec3f detonationRelativeLocation;
	int detonationResult;
	int enabled;
	int entityCategory;
	int entityCountry;
	int entityDomain;
	int entityExtra;
	int entityID;
	int entityKind;
	int entitySpecific;
	int entitySubCategory;
	int eventApplicationID;
	int eventEntityID;
	int eventNumber;
	int eventSiteID;
	int fired1;
	int fired2;
	int fireMissionIndex;
	float firingRange;
	int firingRate;
	int forceID;
	int fuse;
	struct SFVec3f linearVelocity;
	struct SFVec3f linearAcceleration;
	struct Uni_String *marking;
	struct X3D_Node *metadata;
	struct Uni_String *multicastRelayHost;
	int multicastRelayPort;
	int munitionApplicationID;
	struct SFVec3f munitionEndPoint;
	int munitionEntityID;
	int munitionQuantity;
	int munitionSiteID;
	struct SFVec3f munitionStartPoint;
	struct Uni_String *networkMode;
	int port;
	double readInterval;
	struct SFRotation rotation;
	struct SFVec3f scale;
	struct SFRotation scaleOrientation;
	int siteID;
	struct SFVec3f translation;
	int warhead;
	double writeInterval;
	float articulationParameterValue0_changed;
	float articulationParameterValue1_changed;
	float articulationParameterValue2_changed;
	float articulationParameterValue3_changed;
	float articulationParameterValue4_changed;
	float articulationParameterValue5_changed;
	float articulationParameterValue6_changed;
	float articulationParameterValue7_changed;
	double collideTime;
	double detonateTime;
	double firedTime;
	int isActive;
	int isCollided;
	int isDetonated;
	int isNetworkReader;
	int isNetworkWriter;
	int isRtpHeaderHeard;
	int isStandAlone;
	double timestamp;
	struct SFVec3f bboxCenter;
	struct SFVec3f bboxSize;
	int rtpHeaderExpected;
};
extern struct X3D_Virt virt_EspduTransform;
/***********************/
struct X3D_ExplosionEmitter {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct SFVec3f position;
	float speed;
	float variation;
	float mass;
	float surfaceArea;
};
extern struct X3D_Virt virt_ExplosionEmitter;
/***********************/
struct X3D_Extrusion {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Vec2f set_crossSection;
	struct Multi_Rotation set_orientation;
	struct Multi_Vec2f set_scale;
	struct Multi_Vec3f set_spine;
	struct X3D_Node *metadata;
	int beginCap;
	int ccw;
	int convex;
	float creaseAngle;
	struct Multi_Vec2f crossSection;
	int endCap;
	struct Multi_Rotation orientation;
	struct Multi_Vec2f scale;
	int solid;
	struct Multi_Vec3f spine;
};
extern struct X3D_Virt virt_Extrusion;
/***********************/
struct X3D_FillProperties {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int filled;
	struct SFColor hatchColor;
	int hatched;
	int hatchStyle;
	struct X3D_Node *metadata;
	int _enabled;
	struct SFVec2f _hatchScale;
};
extern struct X3D_Virt virt_FillProperties;
/***********************/
struct X3D_FloatVertexAttribute {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Float value;
	struct Uni_String *name;
	int numComponents;
	struct X3D_Node *metadata;
};
extern struct X3D_Virt virt_FloatVertexAttribute;
/***********************/
struct X3D_Fog {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct SFColor color;
	struct Uni_String *fogType;
	float visibilityRange;
	float __fogScale;
	int __fogType;
	int set_bind;
	double bindTime;
	int isBound;
	int _layerId;
	struct X3D_Node *metadata;
};
extern struct X3D_Virt virt_Fog;
/***********************/
struct X3D_FogCoordinate {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Float depth;
	struct X3D_Node *metadata;
};
extern struct X3D_Virt virt_FogCoordinate;
/***********************/
struct X3D_FontStyle {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct Multi_String family;
	int horizontal;
	struct Multi_String justify;
	struct Uni_String *language;
	int leftToRight;
	float size;
	float spacing;
	struct Uni_String *style;
	int topToBottom;
};
extern struct X3D_Virt virt_FontStyle;
/***********************/
struct X3D_ForcePhysicsModel {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int enabled;
	struct SFVec3f force;
	struct X3D_Node *metadata;
};
extern struct X3D_Virt virt_ForcePhysicsModel;
/***********************/
struct X3D_GeneratedCubeMapTexture {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct X3D_Node *textureProperties;
	int __textureTableIndex;
	void * _parentResource;
	struct Multi_Node __subTextures;
	int __regenSubTextures;
	struct Uni_String *update;
	int size;
};
extern struct X3D_Virt virt_GeneratedCubeMapTexture;
/***********************/
struct X3D_GeoCoordinate {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct Multi_Vec3d point;
	struct X3D_Node *geoOrigin;
	struct Multi_String geoSystem;
	struct Multi_Int32 __geoSystem;
	struct Multi_Vec3f __movedCoords;
};
extern struct X3D_Virt virt_GeoCoordinate;
/***********************/
struct X3D_GeoElevationGrid {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Double set_height;
	struct X3D_Node *color;
	struct X3D_Node *metadata;
	struct X3D_Node *normal;
	struct X3D_Node *texCoord;
	float yScale;
	int ccw;
	int colorPerVertex;
	double creaseAngle;
	struct SFVec3d geoGridOrigin;
	struct X3D_Node *geoOrigin;
	struct Multi_String geoSystem;
	struct Multi_Double height;
	int normalPerVertex;
	int solid;
	int xDimension;
	double xSpacing;
	int zDimension;
	double zSpacing;
	struct Multi_Int32 _coordIndex;
	struct Multi_Int32 __geoSystem;
};
extern struct X3D_Virt virt_GeoElevationGrid;
/***********************/
struct X3D_GeoLOD {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct Multi_Node children;
	int level_changed;
	struct SFVec3d center;
	struct Multi_String child1Url;
	struct Multi_String child2Url;
	struct Multi_String child3Url;
	struct Multi_String child4Url;
	struct X3D_Node *geoOrigin;
	struct Multi_String geoSystem;
	float range;
	struct Multi_String rootUrl;
	struct Multi_Node rootNode;
	struct SFVec3f bboxCenter;
	struct SFVec3f bboxSize;
	struct Multi_Int32 __geoSystem;
	struct SFVec3d __movedCoords;
	int __inRange;
	struct X3D_Node *__child1Node;
	struct X3D_Node *__child2Node;
	struct X3D_Node *__child3Node;
	struct X3D_Node *__child4Node;
	struct X3D_Node *__rootUrl;
	int __childloadstatus;
	int __rooturlloadstatus;
	int __level;
};
extern struct X3D_Virt virt_GeoLOD;
/***********************/
struct X3D_GeoLocation {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Node addChildren;
	struct Multi_Node removeChildren;
	struct Multi_Node __sibAffectors;
	struct Multi_Node children;
	struct SFVec3d geoCoords;
	struct X3D_Node *metadata;
	struct X3D_Node *geoOrigin;
	struct Multi_String geoSystem;
	struct SFVec3f bboxCenter;
	struct SFVec3f bboxSize;
	struct Multi_Int32 __geoSystem;
	struct SFVec3d __movedCoords;
	struct SFVec4d __localOrient;
	struct SFVec3d __oldgeoCoords;
	struct Multi_Node __oldChildren;
	struct Multi_Node _sortedChildren;
};
extern struct X3D_Virt virt_GeoLocation;
/***********************/
struct X3D_GeoMetadata {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Node data;
	struct Multi_String summary;
	struct Multi_String url;
	struct X3D_Node *metadata;
};
extern struct X3D_Virt virt_GeoMetadata;
/***********************/
struct X3D_GeoOrigin {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct SFVec3d geoCoords;
	struct Multi_String geoSystem;
	struct X3D_Node *metadata;
	int rotateYUp;
	struct Multi_Int32 __geoSystem;
	struct SFVec3d __movedCoords;
	struct SFVec3d __oldgeoCoords;
	struct Multi_String __oldMFString;
	struct SFVec4d __rotyup;
};
extern struct X3D_Virt virt_GeoOrigin;
/***********************/
struct X3D_GeoPositionInterpolator {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	float set_fraction;
	struct Multi_Float key;
	struct Multi_Vec3d keyValue;
	struct X3D_Node *metadata;
	struct SFVec3d geovalue_changed;
	struct SFVec3f value_changed;
	struct X3D_Node *geoOrigin;
	struct Multi_String geoSystem;
	struct Multi_Int32 __geoSystem;
	struct Multi_Vec3d __movedValue;
	struct Multi_Float __oldKeyPtr;
	struct Multi_Vec3d __oldKeyValuePtr;
};
extern struct X3D_Virt virt_GeoPositionInterpolator;
/***********************/
struct X3D_GeoProximitySensor {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int enabled;
	struct SFVec3d geoCenter;
	struct X3D_Node *metadata;
	struct SFVec3f size;
	struct SFVec3f centerOfRotation_changed;
	double enterTime;
	double exitTime;
	struct SFVec3d geoCoord_changed;
	int isActive;
	struct SFRotation orientation_changed;
	struct SFVec3f position_changed;
	struct X3D_Node *geoOrigin;
	struct Multi_String geoSystem;
	int __hit;
	struct SFVec3f __t1;
	struct SFRotation __t2;
	struct Multi_Int32 __geoSystem;
	struct SFVec3d __movedCoords;
	struct SFVec4d __localOrient;
	int __oldEnabled;
	struct SFVec3d __oldGeoCenter;
	struct SFVec3f __oldSize;
};
extern struct X3D_Virt virt_GeoProximitySensor;
/***********************/
struct X3D_GeoTouchSensor {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Uni_String *description;
	int enabled;
	struct X3D_Node *metadata;
	struct SFVec3f hitNormal_changed;
	struct SFVec3f hitPoint_changed;
	struct SFVec2f hitTexCoord_changed;
	struct SFVec3d hitGeoCoord_changed;
	int isActive;
	int isOver;
	double touchTime;
	struct X3D_Node *geoOrigin;
	struct Multi_String geoSystem;
	struct Multi_Int32 __geoSystem;
	struct SFVec3f _oldhitNormal;
	struct SFVec3f _oldhitPoint;
	struct SFVec2f _oldhitTexCoord;
	int __oldEnabled;
};
extern struct X3D_Virt virt_GeoTouchSensor;
/***********************/
struct X3D_GeoTransform {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Node addChildren;
	struct Multi_Node removeChildren;
	struct Multi_Node __sibAffectors;
	struct Multi_Node children;
	struct SFVec3d geoCenter;
	struct X3D_Node *metadata;
	struct SFRotation rotation;
	struct SFVec3f scale;
	struct SFRotation scaleOrientation;
	struct SFVec3f translation;
	struct SFVec3f bboxCenter;
	struct SFVec3f bboxSize;
	struct X3D_Node *geoOrigin;
	struct Multi_String geoSystem;
	int __do_center;
	int __do_trans;
	int __do_rotation;
	int __do_scaleO;
	int __do_scale;
	struct Multi_Int32 __geoSystem;
	struct SFVec3d __movedCoords;
	struct SFVec4d __localOrient;
	struct SFVec3d __oldGeoCenter;
	struct Multi_Node __oldChildren;
	struct Multi_Node _sortedChildren;
};
extern struct X3D_Virt virt_GeoTransform;
/***********************/
struct X3D_GeoViewpoint {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int set_bind;
	double bindTime;
	int isBound;
	struct Uni_String *description;
	int jump;
	float fieldOfView;
	struct X3D_Node *metadata;
	struct SFRotation orientation;
	struct SFVec3d position;
	int _layerId;
	int _donethispass;
	struct SFRotation set_orientation;
	struct SFVec3d set_position;
	int headlight;
	struct Multi_String navType;
	struct X3D_Node *geoOrigin;
	struct Multi_String geoSystem;
	float speedFactor;
	struct Multi_Int32 __geoSystem;
	struct SFVec3d __movedPosition;
	struct SFRotation __movedOrientation;
	struct Uni_String *__oldSFString;
	float __oldFieldOfView;
	int __oldHeadlight;
	int __oldJump;
	struct Multi_String __oldMFString;
};
extern struct X3D_Virt virt_GeoViewpoint;
/***********************/
struct X3D_Group {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Node addChildren;
	struct Multi_Node removeChildren;
	struct Multi_Node __sibAffectors;
	struct Multi_Node children;
	struct X3D_Node *metadata;
	struct SFVec3f bboxCenter;
	struct SFVec3f bboxSize;
	struct Multi_Node _sortedChildren;
};
extern struct X3D_Virt virt_Group;
/***********************/
struct X3D_HAnimDisplacer {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Int32 coordIndex;
	struct Multi_Vec3f displacements;
	struct Uni_String *name;
	float weight;
	struct X3D_Node *metadata;
};
extern struct X3D_Virt virt_HAnimDisplacer;
/***********************/
struct X3D_HAnimHumanoid {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct SFVec3f center;
	struct Multi_String info;
	struct Multi_Node joints;
	struct Uni_String *name;
	struct SFRotation rotation;
	struct SFVec3f scale;
	struct SFRotation scaleOrientation;
	struct Multi_Node segments;
	struct Multi_Node sites;
	struct Multi_Node skeleton;
	struct Multi_Node skin;
	struct X3D_Node *skinCoord;
	struct X3D_Node *skinNormal;
	struct Multi_Node __sibAffectors;
	struct SFVec3f translation;
	struct Uni_String *version;
	struct Multi_Node viewpoints;
	struct SFVec3f bboxCenter;
	struct SFVec3f bboxSize;
	struct X3D_Node *metadata;
	void * _JT;
	void * _PVI;
	void * _PVW;
	int _NV;
	void * _origCoords;
	void * _origNorms;
};
extern struct X3D_Virt virt_HAnimHumanoid;
/***********************/
struct X3D_HAnimJoint {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Node addChildren;
	struct Multi_Node removeChildren;
	struct Multi_Node __sibAffectors;
	struct Multi_Node children;
	struct SFVec3f center;
	struct SFRotation rotation;
	struct SFVec3f scale;
	struct SFRotation scaleOrientation;
	struct SFVec3f translation;
	struct Multi_Node displacers;
	struct SFRotation limitOrientation;
	struct Multi_Float llimit;
	struct Uni_String *name;
	struct Multi_Int32 skinCoordIndex;
	struct Multi_Float skinCoordWeight;
	struct Multi_Float stiffness;
	struct Multi_Float ulimit;
	struct SFVec3f bboxCenter;
	struct SFVec3f bboxSize;
	struct X3D_Node *metadata;
	int __do_center;
	int __do_trans;
	int __do_rotation;
	int __do_scaleO;
	int __do_scale;
	int __do_anything;
};
extern struct X3D_Virt virt_HAnimJoint;
/***********************/
struct X3D_HAnimSegment {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Node addChildren;
	struct Multi_Node removeChildren;
	struct Multi_Node __sibAffectors;
	struct Multi_Node children;
	struct Uni_String *name;
	struct SFVec3f bboxCenter;
	struct SFVec3f bboxSize;
	struct SFVec3f centerOfMass;
	struct X3D_Node *coord;
	struct Multi_Node displacers;
	float mass;
	struct Multi_Float momentsOfInertia;
	struct X3D_Node *metadata;
	void * _origCoords;
};
extern struct X3D_Virt virt_HAnimSegment;
/***********************/
struct X3D_HAnimSite {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Node addChildren;
	struct Multi_Node removeChildren;
	struct Multi_Node __sibAffectors;
	struct Multi_Node children;
	struct Uni_String *name;
	struct SFVec3f bboxCenter;
	struct SFVec3f bboxSize;
	struct SFVec3f center;
	struct SFRotation rotation;
	struct SFVec3f scale;
	struct SFRotation scaleOrientation;
	struct SFVec3f translation;
	struct X3D_Node *metadata;
	int __do_center;
	int __do_trans;
	int __do_rotation;
	int __do_scaleO;
	int __do_scale;
	int __do_anything;
};
extern struct X3D_Virt virt_HAnimSite;
/***********************/
struct X3D_ImageBackdropBackground {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int set_bind;
	double bindTime;
	int isBound;
	float transparency;
	struct SFColor color;
	struct X3D_Node *metadata;
	int __texture;
	int __VBO;
	struct Multi_Int32 image;
};
extern struct X3D_Virt virt_ImageBackdropBackground;
/***********************/
struct X3D_ImageCubeMapTexture {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct X3D_Node *textureProperties;
	int __textureTableIndex;
	void * _parentResource;
	struct Multi_Node __subTextures;
	int __regenSubTextures;
	struct Multi_String url;
};
extern struct X3D_Virt virt_ImageCubeMapTexture;
/***********************/
struct X3D_ImageTexture {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct Multi_String url;
	int repeatS;
	int repeatT;
	struct X3D_Node *textureProperties;
	int __textureTableIndex;
	void * _parentResource;
};
extern struct X3D_Virt virt_ImageTexture;
/***********************/
struct X3D_ImageTexture3D {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct Multi_String url;
	int repeatS;
	int repeatT;
	int repeatR;
	struct X3D_Node *textureProperties;
	int __textureTableIndex;
	void * _parentResource;
	int _needs_gradient;
};
extern struct X3D_Virt virt_ImageTexture3D;
/***********************/
struct X3D_IndexedFaceSet {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Int32 set_colorIndex;
	struct Multi_Int32 set_coordIndex;
	struct Multi_Int32 set_normalIndex;
	struct Multi_Int32 set_texCoordIndex;
	struct Multi_Node attrib;
	struct X3D_Node *color;
	struct X3D_Node *coord;
	struct X3D_Node *fogCoord;
	struct X3D_Node *metadata;
	struct X3D_Node *normal;
	struct X3D_Node *texCoord;
	int ccw;
	struct Multi_Int32 colorIndex;
	int colorPerVertex;
	int convex;
	struct Multi_Int32 coordIndex;
	float creaseAngle;
	struct Multi_Int32 normalIndex;
	int normalPerVertex;
	int solid;
	struct Multi_Int32 texCoordIndex;
};
extern struct X3D_Virt virt_IndexedFaceSet;
/***********************/
struct X3D_IndexedLineSet {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Int32 set_colorIndex;
	struct Multi_Int32 set_coordIndex;
	struct Multi_Node attrib;
	struct X3D_Node *color;
	struct X3D_Node *coord;
	struct X3D_Node *fogCoord;
	struct X3D_Node *metadata;
	struct Multi_Int32 colorIndex;
	int colorPerVertex;
	struct Multi_Int32 coordIndex;
	void * __vertArr;
	void * __vertIndx;
	void * __xcolours;
	void * __vertices;
	void * __vertexCount;
	int __segCount;
};
extern struct X3D_Virt virt_IndexedLineSet;
/***********************/
struct X3D_IndexedQuadSet {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Int32 set_index;
	struct Multi_Node attrib;
	struct X3D_Node *color;
	struct X3D_Node *coord;
	struct X3D_Node *fogCoord;
	struct X3D_Node *metadata;
	struct X3D_Node *normal;
	struct X3D_Node *texCoord;
	int ccw;
	struct Multi_Int32 index;
	int colorPerVertex;
	int normalPerVertex;
	int solid;
	struct Multi_Int32 _coordIndex;
};
extern struct X3D_Virt virt_IndexedQuadSet;
/***********************/
struct X3D_IndexedTriangleFanSet {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Int32 set_index;
	struct Multi_Node attrib;
	struct X3D_Node *color;
	struct X3D_Node *coord;
	struct X3D_Node *fogCoord;
	struct X3D_Node *metadata;
	struct X3D_Node *normal;
	struct X3D_Node *texCoord;
	int ccw;
	int colorPerVertex;
	int normalPerVertex;
	int solid;
	struct Multi_Int32 index;
	struct Multi_Int32 _coordIndex;
};
extern struct X3D_Virt virt_IndexedTriangleFanSet;
/***********************/
struct X3D_IndexedTriangleSet {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Int32 set_index;
	struct Multi_Node attrib;
	struct X3D_Node *color;
	struct X3D_Node *coord;
	struct X3D_Node *fogCoord;
	struct X3D_Node *metadata;
	struct X3D_Node *normal;
	struct X3D_Node *texCoord;
	int ccw;
	int colorPerVertex;
	int normalPerVertex;
	int solid;
	struct Multi_Int32 index;
	struct Multi_Int32 _coordIndex;
};
extern struct X3D_Virt virt_IndexedTriangleSet;
/***********************/
struct X3D_IndexedTriangleStripSet {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Int32 set_index;
	struct Multi_Node attrib;
	struct X3D_Node *color;
	struct X3D_Node *coord;
	struct X3D_Node *fogCoord;
	struct X3D_Node *metadata;
	struct X3D_Node *normal;
	struct X3D_Node *texCoord;
	int ccw;
	int colorPerVertex;
	int normalPerVertex;
	int solid;
	struct Multi_Int32 index;
	struct Multi_Int32 _coordIndex;
};
extern struct X3D_Virt virt_IndexedTriangleStripSet;
/***********************/
struct X3D_Inline {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Node __children;
	struct X3D_Node *metadata;
	struct SFVec3f bboxCenter;
	struct SFVec3f bboxSize;
	struct Multi_Node _sortedChildren;
	struct Multi_Node addChildren;
	struct Multi_Node removeChildren;
	struct Multi_Node __sibAffectors;
	void * __protoDeclares;
	void * __externProtoDeclares;
	void * __nodes;
	void * __subcontexts;
	void * __GC;
	void * __protoDef;
	int __protoFlags;
	struct X3D_Node *__prototype;
	struct X3D_Node *__parentProto;
	void * __ROUTES;
	void * __EXPORTS;
	void * __IMPORTS;
	void * __DEFnames;
	void * __IS;
	void * __scripts;
	struct Multi_String url;
	struct Multi_String __oldurl;
	void * __afterPound;
	int __loadstatus;
	void * _parentResource;
	void * __loadResource;
	void * __typename;
	int load;
	int __oldload;
};
extern struct X3D_Virt virt_Inline;
/***********************/
struct X3D_IntegerSequencer {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int next;
	int previous;
	float set_fraction;
	struct Multi_Float key;
	struct Multi_Int32 keyValue;
	int value_changed;
	struct X3D_Node *metadata;
};
extern struct X3D_Virt virt_IntegerSequencer;
/***********************/
struct X3D_IntegerTrigger {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int set_boolean;
	int integerKey;
	int triggerValue;
	struct X3D_Node *metadata;
};
extern struct X3D_Virt virt_IntegerTrigger;
/***********************/
struct X3D_IsoSurfaceVolumeData {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct SFVec3f dimensions;
	struct X3D_Node *metadata;
	struct X3D_Node *voxels;
	struct SFVec3f bboxCenter;
	struct SFVec3f bboxSize;
	void * _boxtris;
	struct Multi_Node renderStyle;
	float contourStepSize;
	struct X3D_Node *gradients;
	float surfaceTolerance;
	struct Multi_Float surfaceValues;
};
extern struct X3D_Virt virt_IsoSurfaceVolumeData;
/***********************/
struct X3D_KeySensor {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int enabled;
	int actionKeyPress;
	int actionKeyRelease;
	int altKey;
	int controlKey;
	int isActive;
	struct Uni_String *keyPress;
	struct Uni_String *keyRelease;
	int shiftKey;
	struct X3D_Node *metadata;
	int __oldEnabled;
};
extern struct X3D_Virt virt_KeySensor;
/***********************/
struct X3D_LOD {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Node addChildren;
	struct Multi_Node removeChildren;
	struct Multi_Node __sibAffectors;
	struct Multi_Node level;
	struct Multi_Node children;
	struct SFVec3f center;
	struct Multi_Float range;
	struct SFVec3f bboxCenter;
	struct SFVec3f bboxSize;
	struct X3D_Node *metadata;
	int levelChanged;
	int forceTransitions;
	int __isX3D;
	void * _selected;
};
extern struct X3D_Virt virt_LOD;
/***********************/
struct X3D_Layer {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Node addChildren;
	struct Multi_Node removeChildren;
	struct Multi_Node __sibAffectors;
	struct Multi_Node children;
	struct X3D_Node *metadata;
	int isPickable;
	struct X3D_Node *viewport;
};
extern struct X3D_Virt virt_Layer;
/***********************/
struct X3D_LayerSet {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int activeLayer;
	struct X3D_Node *metadata;
	struct Multi_Node layers;
	struct Multi_Int32 order;
};
extern struct X3D_Virt virt_LayerSet;
/***********************/
struct X3D_Layout {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_String align;
	struct X3D_Node *metadata;
	struct Multi_Float offset;
	struct Multi_String offsetUnits;
	struct Multi_String scaleMode;
	struct Multi_Float size;
	struct Multi_String sizeUnits;
	struct Multi_Int32 _align;
	struct Multi_Int32 _offsetUnits;
	struct Multi_Int32 _scaleMode;
	struct Multi_Int32 _sizeUnits;
	struct Multi_Float _scale;
};
extern struct X3D_Virt virt_Layout;
/***********************/
struct X3D_LayoutGroup {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Node addChildren;
	struct Multi_Node removeChildren;
	struct Multi_Node __sibAffectors;
	struct Multi_Node children;
	struct X3D_Node *metadata;
	struct SFVec3f bboxCenter;
	struct SFVec3f bboxSize;
	struct X3D_Node *layout;
	struct X3D_Node *viewport;
};
extern struct X3D_Virt virt_LayoutGroup;
/***********************/
struct X3D_LayoutLayer {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Node addChildren;
	struct Multi_Node removeChildren;
	struct Multi_Node __sibAffectors;
	struct Multi_Node children;
	struct X3D_Node *metadata;
	int isPickable;
	struct X3D_Node *viewport;
	struct X3D_Node *layout;
};
extern struct X3D_Virt virt_LayoutLayer;
/***********************/
struct X3D_LinePickSensor {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int enabled;
	struct X3D_Node *metadata;
	struct Multi_String objectType;
	struct X3D_Node *pickingGeometry;
	struct Multi_Node pickTarget;
	int isActive;
	struct Multi_Node pickedGeometry;
	struct Uni_String *intersectionType;
	struct Uni_String *sortOrder;
	struct Uni_String *matchCriterion;
	int __oldEnabled;
	struct Multi_Vec3f pickedPoint;
	struct Multi_Vec3f pickedNormal;
	struct Multi_Vec3f pickedTextureCoordinate;
};
extern struct X3D_Virt virt_LinePickSensor;
/***********************/
struct X3D_LineProperties {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int applied;
	int linetype;
	float linewidthScaleFactor;
	struct X3D_Node *metadata;
};
extern struct X3D_Virt virt_LineProperties;
/***********************/
struct X3D_LineSensor {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int autoOffset;
	struct SFVec3f direction;
	int enabled;
	float maxPosition;
	float minPosition;
	float offset;
	int isActive;
	int isOver;
	struct Uni_String *description;
	struct SFVec3f trackPoint_changed;
	struct SFVec3f translation_changed;
	struct X3D_Node *metadata;
	struct SFVec3f _oldtrackPoint;
	struct SFVec3f _oldtranslation;
	struct SFVec3f _origPoint;
	int __oldEnabled;
};
extern struct X3D_Virt virt_LineSensor;
/***********************/
struct X3D_LineSet {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Node attrib;
	struct X3D_Node *color;
	struct X3D_Node *coord;
	struct X3D_Node *metadata;
	struct X3D_Node *fogCoord;
	struct Multi_Int32 vertexCount;
	void * __vertArr;
	void * __vertIndx;
	int __segCount;
};
extern struct X3D_Virt virt_LineSet;
/***********************/
struct X3D_LoadSensor {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int enabled;
	struct X3D_Node *metadata;
	double timeOut;
	struct Multi_Node watchList;
	int isActive;
	int isLoaded;
	double loadTime;
	float progress;
	int __loading;
	int __finishedloading;
	double __StartLoadTime;
	int __oldEnabled;
};
extern struct X3D_Virt virt_LoadSensor;
/***********************/
struct X3D_LocalFog {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct SFColor color;
	struct Uni_String *fogType;
	float visibilityRange;
	float __fogScale;
	int __fogType;
	int enabled;
	struct X3D_Node *metadata;
};
extern struct X3D_Virt virt_LocalFog;
/***********************/
struct X3D_Material {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	float ambientIntensity;
	struct SFColor diffuseColor;
	struct SFColor emissiveColor;
	struct X3D_Node *metadata;
	float shininess;
	struct SFColor specularColor;
	float transparency;
	struct Multi_Float _verifiedColor;
};
extern struct X3D_Virt virt_Material;
/***********************/
struct X3D_Matrix3VertexAttribute {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Matrix3f value;
	struct Uni_String *name;
	struct X3D_Node *metadata;
};
extern struct X3D_Virt virt_Matrix3VertexAttribute;
/***********************/
struct X3D_Matrix4VertexAttribute {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct Multi_Matrix4f value;
	struct Uni_String *name;
};
extern struct X3D_Virt virt_Matrix4VertexAttribute;
/***********************/
struct X3D_MetadataBoolean {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct Uni_String *name;
	struct Uni_String *reference;
	struct Multi_Bool value;
};
extern struct X3D_Virt virt_MetadataBoolean;
/***********************/
struct X3D_MetadataDouble {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct Uni_String *name;
	struct Uni_String *reference;
	struct Multi_Double value;
};
extern struct X3D_Virt virt_MetadataDouble;
/***********************/
struct X3D_MetadataFloat {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct Uni_String *name;
	struct Uni_String *reference;
	struct Multi_Float value;
};
extern struct X3D_Virt virt_MetadataFloat;
/***********************/
struct X3D_MetadataInteger {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct Uni_String *name;
	struct Uni_String *reference;
	struct Multi_Int32 value;
};
extern struct X3D_Virt virt_MetadataInteger;
/***********************/
struct X3D_MetadataMFBool {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Bool value;
	struct Multi_Bool valueChanged;
	struct Multi_Bool setValue;
	double tickTime;
};
extern struct X3D_Virt virt_MetadataMFBool;
/***********************/
struct X3D_MetadataMFColor {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Color value;
	struct Multi_Color valueChanged;
	struct Multi_Color setValue;
	double tickTime;
};
extern struct X3D_Virt virt_MetadataMFColor;
/***********************/
struct X3D_MetadataMFColorRGBA {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_ColorRGBA value;
	struct Multi_ColorRGBA valueChanged;
	struct Multi_ColorRGBA setValue;
	double tickTime;
};
extern struct X3D_Virt virt_MetadataMFColorRGBA;
/***********************/
struct X3D_MetadataMFDouble {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Double value;
	struct Multi_Double valueChanged;
	struct Multi_Double setValue;
	double tickTime;
};
extern struct X3D_Virt virt_MetadataMFDouble;
/***********************/
struct X3D_MetadataMFFloat {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Float value;
	struct Multi_Float valueChanged;
	struct Multi_Float setValue;
	double tickTime;
};
extern struct X3D_Virt virt_MetadataMFFloat;
/***********************/
struct X3D_MetadataMFInt32 {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Int32 value;
	struct Multi_Int32 valueChanged;
	struct Multi_Int32 setValue;
	double tickTime;
};
extern struct X3D_Virt virt_MetadataMFInt32;
/***********************/
struct X3D_MetadataMFMatrix3d {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Matrix3d value;
	struct Multi_Matrix3d valueChanged;
	struct Multi_Matrix3d setValue;
	double tickTime;
};
extern struct X3D_Virt virt_MetadataMFMatrix3d;
/***********************/
struct X3D_MetadataMFMatrix3f {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Matrix3f value;
	struct Multi_Matrix3f valueChanged;
	struct Multi_Matrix3f setValue;
	double tickTime;
};
extern struct X3D_Virt virt_MetadataMFMatrix3f;
/***********************/
struct X3D_MetadataMFMatrix4d {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Matrix4d value;
	struct Multi_Matrix4d valueChanged;
	struct Multi_Matrix4d setValue;
	double tickTime;
};
extern struct X3D_Virt virt_MetadataMFMatrix4d;
/***********************/
struct X3D_MetadataMFMatrix4f {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Matrix4f value;
	struct Multi_Matrix4f valueChanged;
	struct Multi_Matrix4f setValue;
	double tickTime;
};
extern struct X3D_Virt virt_MetadataMFMatrix4f;
/***********************/
struct X3D_MetadataMFNode {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Node value;
	struct Multi_Node valueChanged;
	struct Multi_Node setValue;
	double tickTime;
};
extern struct X3D_Virt virt_MetadataMFNode;
/***********************/
struct X3D_MetadataMFRotation {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Rotation value;
	struct Multi_Rotation valueChanged;
	struct Multi_Rotation setValue;
	double tickTime;
};
extern struct X3D_Virt virt_MetadataMFRotation;
/***********************/
struct X3D_MetadataMFString {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_String value;
	struct Multi_String valueChanged;
	struct Multi_String setValue;
	double tickTime;
};
extern struct X3D_Virt virt_MetadataMFString;
/***********************/
struct X3D_MetadataMFTime {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Time value;
	struct Multi_Time valueChanged;
	struct Multi_Time setValue;
	double tickTime;
};
extern struct X3D_Virt virt_MetadataMFTime;
/***********************/
struct X3D_MetadataMFVec2d {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Vec2d value;
	struct Multi_Vec2d valueChanged;
	struct Multi_Vec2d setValue;
	double tickTime;
};
extern struct X3D_Virt virt_MetadataMFVec2d;
/***********************/
struct X3D_MetadataMFVec2f {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Vec2f value;
	struct Multi_Vec2f valueChanged;
	struct Multi_Vec2f setValue;
	double tickTime;
};
extern struct X3D_Virt virt_MetadataMFVec2f;
/***********************/
struct X3D_MetadataMFVec3d {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Vec3d value;
	struct Multi_Vec3d valueChanged;
	struct Multi_Vec3d setValue;
	double tickTime;
};
extern struct X3D_Virt virt_MetadataMFVec3d;
/***********************/
struct X3D_MetadataMFVec3f {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Vec3f value;
	struct Multi_Vec3f valueChanged;
	struct Multi_Vec3f setValue;
	double tickTime;
};
extern struct X3D_Virt virt_MetadataMFVec3f;
/***********************/
struct X3D_MetadataMFVec4d {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Vec4d value;
	struct Multi_Vec4d valueChanged;
	struct Multi_Vec4d setValue;
	double tickTime;
};
extern struct X3D_Virt virt_MetadataMFVec4d;
/***********************/
struct X3D_MetadataMFVec4f {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Vec4f value;
	struct Multi_Vec4f valueChanged;
	struct Multi_Vec4f setValue;
	double tickTime;
};
extern struct X3D_Virt virt_MetadataMFVec4f;
/***********************/
struct X3D_MetadataSFBool {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int value;
	int valueChanged;
	int setValue;
	double tickTime;
};
extern struct X3D_Virt virt_MetadataSFBool;
/***********************/
struct X3D_MetadataSFColor {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct SFColor value;
	struct SFColor valueChanged;
	struct SFColor setValue;
	double tickTime;
};
extern struct X3D_Virt virt_MetadataSFColor;
/***********************/
struct X3D_MetadataSFColorRGBA {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct SFColorRGBA value;
	struct SFColorRGBA valueChanged;
	struct SFColorRGBA setValue;
	double tickTime;
};
extern struct X3D_Virt virt_MetadataSFColorRGBA;
/***********************/
struct X3D_MetadataSFDouble {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	double value;
	double valueChanged;
	double setValue;
	double tickTime;
};
extern struct X3D_Virt virt_MetadataSFDouble;
/***********************/
struct X3D_MetadataSFFloat {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	float value;
	float valueChanged;
	float setValue;
	double tickTime;
};
extern struct X3D_Virt virt_MetadataSFFloat;
/***********************/
struct X3D_MetadataSFImage {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Int32 value;
	struct Multi_Int32 valueChanged;
	struct Multi_Int32 setValue;
	double tickTime;
};
extern struct X3D_Virt virt_MetadataSFImage;
/***********************/
struct X3D_MetadataSFInt32 {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int value;
	int valueChanged;
	int setValue;
	double tickTime;
};
extern struct X3D_Virt virt_MetadataSFInt32;
/***********************/
struct X3D_MetadataSFMatrix3d {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct SFMatrix3d value;
	struct SFMatrix3d valueChanged;
	struct SFMatrix3d setValue;
	double tickTime;
};
extern struct X3D_Virt virt_MetadataSFMatrix3d;
/***********************/
struct X3D_MetadataSFMatrix3f {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct SFMatrix3f value;
	struct SFMatrix3f valueChanged;
	struct SFMatrix3f setValue;
	double tickTime;
};
extern struct X3D_Virt virt_MetadataSFMatrix3f;
/***********************/
struct X3D_MetadataSFMatrix4d {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct SFMatrix4d value;
	struct SFMatrix4d valueChanged;
	struct SFMatrix4d setValue;
	double tickTime;
};
extern struct X3D_Virt virt_MetadataSFMatrix4d;
/***********************/
struct X3D_MetadataSFMatrix4f {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct SFMatrix4f value;
	struct SFMatrix4f valueChanged;
	struct SFMatrix4f setValue;
	double tickTime;
};
extern struct X3D_Virt virt_MetadataSFMatrix4f;
/***********************/
struct X3D_MetadataSFNode {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *value;
	struct X3D_Node *valueChanged;
	struct X3D_Node *setValue;
	double tickTime;
};
extern struct X3D_Virt virt_MetadataSFNode;
/***********************/
struct X3D_MetadataSFRotation {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct SFRotation value;
	struct SFRotation valueChanged;
	struct SFRotation setValue;
	double tickTime;
};
extern struct X3D_Virt virt_MetadataSFRotation;
/***********************/
struct X3D_MetadataSFString {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Uni_String *value;
	struct Uni_String *valueChanged;
	struct Uni_String *setValue;
	double tickTime;
};
extern struct X3D_Virt virt_MetadataSFString;
/***********************/
struct X3D_MetadataSFTime {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	double value;
	double valueChanged;
	double setValue;
	double tickTime;
};
extern struct X3D_Virt virt_MetadataSFTime;
/***********************/
struct X3D_MetadataSFVec2d {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct SFVec2d value;
	struct SFVec2d valueChanged;
	struct SFVec2d setValue;
	double tickTime;
};
extern struct X3D_Virt virt_MetadataSFVec2d;
/***********************/
struct X3D_MetadataSFVec2f {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct SFVec2f value;
	struct SFVec2f valueChanged;
	struct SFVec2f setValue;
	double tickTime;
};
extern struct X3D_Virt virt_MetadataSFVec2f;
/***********************/
struct X3D_MetadataSFVec3d {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct SFVec3d value;
	struct SFVec3d valueChanged;
	struct SFVec3d setValue;
	double tickTime;
};
extern struct X3D_Virt virt_MetadataSFVec3d;
/***********************/
struct X3D_MetadataSFVec3f {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct SFVec3f value;
	struct SFVec3f valueChanged;
	struct SFVec3f setValue;
	double tickTime;
};
extern struct X3D_Virt virt_MetadataSFVec3f;
/***********************/
struct X3D_MetadataSFVec4d {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct SFVec4d value;
	struct SFVec4d valueChanged;
	struct SFVec4d setValue;
	double tickTime;
};
extern struct X3D_Virt virt_MetadataSFVec4d;
/***********************/
struct X3D_MetadataSFVec4f {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct SFVec4f value;
	struct SFVec4f valueChanged;
	struct SFVec4f setValue;
	double tickTime;
};
extern struct X3D_Virt virt_MetadataSFVec4f;
/***********************/
struct X3D_MetadataSet {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct Uni_String *name;
	struct Uni_String *reference;
	struct Multi_Node value;
};
extern struct X3D_Virt virt_MetadataSet;
/***********************/
struct X3D_MetadataString {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct Uni_String *name;
	struct Uni_String *reference;
	struct Multi_String value;
};
extern struct X3D_Virt virt_MetadataString;
/***********************/
struct X3D_MotorJoint {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	float axis1Angle;
	float axis1Torque;
	float axis2Angle;
	float axis2Torque;
	float axis3Angle;
	float axis3Torque;
	struct X3D_Node *body1;
	struct X3D_Node *body2;
	int enabledAxes;
	struct Multi_String forceOutput;
	struct X3D_Node *metadata;
	struct SFVec3f motor1Axis;
	struct SFVec3f motor2Axis;
	struct SFVec3f motor3Axis;
	float stop1Bounce;
	float stop1ErrorCorrection;
	float stop2Bounce;
	float stop2ErrorCorrection;
	float stop3Bounce;
	float stop3ErrorCorrection;
	float motor1Angle;
	float motor1AngleRate;
	float motor2Angle;
	float motor2AngleRate;
	float motor3Angle;
	float motor3AngleRate;
	int autoCalc;
	void * _joint;
	int _forceout;
	struct SFVec3f __old_motor1Axis;
	struct SFVec3f __old_motor2Axis;
	struct SFVec3f __old_motor3Axis;
	struct X3D_Node *__old_body1;
	struct X3D_Node *__old_body2;
	float __old_axis1Angle;
	float __old_axis2Angle;
	float __old_axis3Angle;
};
extern struct X3D_Virt virt_MotorJoint;
/***********************/
struct X3D_MovieTexture {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Uni_String *description;
	int loop;
	struct X3D_Node *metadata;
	double pauseTime;
	float pitch;
	double resumeTime;
	double startTime;
	double stopTime;
	struct Multi_String url;
	double duration_changed;
	double elapsedTime;
	int isActive;
	int isPaused;
	void * _parentResource;
	int __loadstatus;
	void * __loadResource;
	int __sourceNumber;
	double __inittime;
	double __lasttime;
	int repeatS;
	int repeatT;
	struct X3D_Node *textureProperties;
	int __textureTableIndex;
	float speed;
	float __frac;
	int __ctex;
	int __lowest;
	int __highest;
	void * __fw_movie;
};
extern struct X3D_Virt virt_MovieTexture;
/***********************/
struct X3D_MultiTexture {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	float alpha;
	struct SFColor color;
	struct Multi_String function;
	struct X3D_Node *metadata;
	struct Multi_String mode;
	struct Multi_String source;
	struct Multi_Node texture;
	void * __xparams;
};
extern struct X3D_Virt virt_MultiTexture;
/***********************/
struct X3D_MultiTextureCoordinate {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct Multi_Node texCoord;
};
extern struct X3D_Virt virt_MultiTextureCoordinate;
/***********************/
struct X3D_MultiTextureTransform {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct Multi_Node textureTransform;
};
extern struct X3D_Virt virt_MultiTextureTransform;
/***********************/
struct X3D_NavigationInfo {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int set_bind;
	struct Multi_Float avatarSize;
	int headlight;
	float speed;
	struct Multi_String type;
	float visibilityLimit;
	int isBound;
	int _layerId;
	struct Multi_String transitionType;
	double bindTime;
	struct X3D_Node *metadata;
	double transitionTime;
	int transitionComplete;
};
extern struct X3D_Virt virt_NavigationInfo;
/***********************/
struct X3D_Normal {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct Multi_Vec3f vector;
};
extern struct X3D_Virt virt_Normal;
/***********************/
struct X3D_NormalInterpolator {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	float set_fraction;
	struct Multi_Float key;
	struct Multi_Vec3f keyValue;
	struct X3D_Node *metadata;
	struct Multi_Vec3f value_changed;
};
extern struct X3D_Virt virt_NormalInterpolator;
/***********************/
struct X3D_NurbsCurve {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct X3D_Node *controlPoint;
	struct Multi_Double weight;
	struct Multi_Double knot;
	int order;
	int tessellation;
	int closed;
	float _tscale;
	struct Multi_Vec3f __points;
	int __numPoints;
};
extern struct X3D_Virt virt_NurbsCurve;
/***********************/
struct X3D_NurbsCurve2D {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct Multi_Vec2d controlPoint;
	struct Multi_Double weight;
	struct Multi_Double knot;
	int order;
	int tessellation;
	int closed;
	float _tscale;
};
extern struct X3D_Virt virt_NurbsCurve2D;
/***********************/
struct X3D_NurbsOrientationInterpolator {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct X3D_Node *controlPoint;
	struct Multi_Double weight;
	struct Multi_Double knot;
	int order;
	float set_fraction;
	struct SFRotation value_changed;
	struct Multi_Float _knot;
	struct Multi_Vec4f _xyzw;
	int _OK;
	struct SFVec2f _knotrange;
};
extern struct X3D_Virt virt_NurbsOrientationInterpolator;
/***********************/
struct X3D_NurbsPatchSurface {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct X3D_Node *controlPoint;
	struct Multi_Double weight;
	struct Multi_Double uKnot;
	int uOrder;
	int uDimension;
	int uTessellation;
	int uClosed;
	struct Multi_Double vKnot;
	int vOrder;
	int vDimension;
	int vTessellation;
	int vClosed;
	struct X3D_Node *texCoord;
	int solid;
	float _tscale;
};
extern struct X3D_Virt virt_NurbsPatchSurface;
/***********************/
struct X3D_NurbsPositionInterpolator {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct X3D_Node *controlPoint;
	struct Multi_Double weight;
	struct Multi_Double knot;
	int order;
	float set_fraction;
	struct SFVec3f value_changed;
	struct Multi_Float _knot;
	struct Multi_Vec4f _xyzw;
	int _OK;
	struct SFVec2f _knotrange;
};
extern struct X3D_Virt virt_NurbsPositionInterpolator;
/***********************/
struct X3D_NurbsSet {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Node addGeometry;
	struct Multi_Node removeGeometry;
	struct Multi_Node geometry;
	struct X3D_Node *metadata;
	float tessellationScale;
	struct SFVec3f bboxCenter;
	struct SFVec3f bboxSize;
};
extern struct X3D_Virt virt_NurbsSet;
/***********************/
struct X3D_NurbsSurfaceInterpolator {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct X3D_Node *controlPoint;
	struct Multi_Double weight;
	struct Multi_Double uKnot;
	int uOrder;
	int uDimension;
	struct Multi_Double vKnot;
	int vOrder;
	int vDimension;
	struct SFVec2f set_fraction;
	struct SFVec3f position_changed;
	struct SFVec3f normal_changed;
	struct Multi_Float _uKnot;
	struct Multi_Float _vKnot;
	struct Multi_Vec4f _controlPoint;
	int _OK;
};
extern struct X3D_Virt virt_NurbsSurfaceInterpolator;
/***********************/
struct X3D_NurbsSweptSurface {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *crossSectionCurve;
	struct X3D_Node *metadata;
	struct X3D_Node *trajectoryCurve;
	int ccw;
	int solid;
	struct Uni_String *method;
	struct X3D_Node *_patch;
	int _method;
};
extern struct X3D_Virt virt_NurbsSweptSurface;
/***********************/
struct X3D_NurbsSwungSurface {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct X3D_Node *profileCurve;
	struct X3D_Node *trajectoryCurve;
	int ccw;
	int solid;
	struct X3D_Node *_patch;
};
extern struct X3D_Virt virt_NurbsSwungSurface;
/***********************/
struct X3D_NurbsTextureCoordinate {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct Multi_Vec2f controlPoint;
	struct Multi_Float weight;
	struct Multi_Double uKnot;
	int uOrder;
	int uDimension;
	struct Multi_Double vKnot;
	int vOrder;
	int vDimension;
	struct Multi_Float _uKnot;
	struct Multi_Float _vKnot;
	struct Multi_Vec4f _controlPoint;
};
extern struct X3D_Virt virt_NurbsTextureCoordinate;
/***********************/
struct X3D_NurbsTrimmedSurface {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct X3D_Node *controlPoint;
	struct Multi_Double weight;
	struct Multi_Double uKnot;
	int uOrder;
	int uDimension;
	int uTessellation;
	int uClosed;
	struct Multi_Double vKnot;
	int vOrder;
	int vDimension;
	int vTessellation;
	int vClosed;
	struct X3D_Node *texCoord;
	int solid;
	struct Multi_Node addTrimmingContour;
	struct Multi_Node removeTrimmingContour;
	struct Multi_Node trimmingContour;
	float _tscale;
};
extern struct X3D_Virt virt_NurbsTrimmedSurface;
/***********************/
struct X3D_OSC_Sensor {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int enabled;
	struct Uni_String *description;
	struct Uni_String *protocol;
	struct Uni_String *listenfor;
	int port;
	struct Uni_String *filter;
	struct Uni_String *handler;
	struct Multi_String talksTo;
	int FIFOsize;
	int int32Inp;
	float floatInp;
	struct Uni_String *stringInp;
	int gotEvents;
	struct X3D_Node *metadata;
	struct Multi_Node _talkToNodes;
	int _status;
	void * _int32InpFIFO;
	void * _floatInpFIFO;
	void * _stringInpFIFO;
	void * _int32OutFIFO;
	void * _floatOutFIFO;
	void * _stringOutFIFO;
	struct X3D_Node *__oldmetadata;
};
extern struct X3D_Virt virt_OSC_Sensor;
/***********************/
struct X3D_OpacityMapVolumeStyle {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int enabled;
	struct X3D_Node *metadata;
	struct X3D_Node *transferFunction;
};
extern struct X3D_Virt virt_OpacityMapVolumeStyle;
/***********************/
struct X3D_OrientationChaser {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	void * _p;
	void * _t;
	int isActive;
	double duration;
	double _bufferendtime;
	double _steptime;
	struct SFRotation value_changed;
	struct SFRotation initialDestination;
	struct SFRotation initialValue;
	struct SFRotation set_destination;
	struct SFRotation set_value;
	void * _buffer;
	struct SFRotation _previousvalue;
	struct SFRotation _destination;
};
extern struct X3D_Virt virt_OrientationChaser;
/***********************/
struct X3D_OrientationDamper {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	void * _p;
	void * _t;
	double tau;
	float tolerance;
	int isActive;
	int order;
	double _tau;
	double _lasttick;
	int _takefirstinput;
	struct SFRotation value_changed;
	struct SFRotation initialDestination;
	struct SFRotation initialValue;
	struct SFRotation set_destination;
	struct SFRotation set_value;
	void * _values;
	struct SFRotation _input;
};
extern struct X3D_Virt virt_OrientationDamper;
/***********************/
struct X3D_OrientationInterpolator {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	float set_fraction;
	struct Multi_Float key;
	struct Multi_Rotation keyValue;
	struct X3D_Node *metadata;
	struct SFRotation value_changed;
};
extern struct X3D_Virt virt_OrientationInterpolator;
/***********************/
struct X3D_OrthoViewpoint {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int set_bind;
	double bindTime;
	int isBound;
	struct Uni_String *description;
	int jump;
	struct Multi_Float fieldOfView;
	struct X3D_Node *metadata;
	struct SFRotation orientation;
	struct SFVec3f position;
	int _layerId;
	int _donethispass;
	struct SFVec3f centerOfRotation;
	int retainUserOffsets;
};
extern struct X3D_Virt virt_OrthoViewpoint;
/***********************/
struct X3D_PackagedShader {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int activate;
	struct X3D_Node *metadata;
	struct Multi_String url;
	int isSelected;
	int isValid;
	struct Uni_String *language;
	int _initialized;
	int _shaderUserNumber;
	struct X3D_Node *_shaderUserDefinedFields;
	pthread_t _shaderLoadThread;
	int _retrievedURLData;
};
extern struct X3D_Virt virt_PackagedShader;
/***********************/
struct X3D_ParticleSystem {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *appearance;
	struct X3D_Node *geometry;
	struct X3D_Node *metadata;
	struct SFVec3f bboxCenter;
	struct SFVec3f bboxSize;
	int _shaderflags_base;
	int _shaderflags_effects;
	int _shaderflags_usershaders;
	int createParticles;
	int enabled;
	float lifetimeVariation;
	int maxParticles;
	float particleLifetime;
	struct SFVec2f particleSize;
	int isActive;
	struct X3D_Node *colorRamp;
	struct Multi_Float colorKey;
	struct X3D_Node *emitter;
	struct Uni_String *geometryType;
	struct Multi_Node physics;
	struct X3D_Node *texCoordRamp;
	struct Multi_Float texCoordKey;
	void * _tris;
	void * _ttex;
	void * _ltex;
	void * _particles;
	double _lasttime;
	int _geometryType;
	float _remainder;
};
extern struct X3D_Virt virt_ParticleSystem;
/***********************/
struct X3D_PickableGroup {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Node addChildren;
	struct Multi_Node removeChildren;
	struct Multi_Node __sibAffectors;
	struct Multi_Node children;
	struct X3D_Node *metadata;
	struct Multi_String objectType;
	int pickable;
	struct SFVec3f bboxCenter;
	struct SFVec3f bboxSize;
};
extern struct X3D_Virt virt_PickableGroup;
/***********************/
struct X3D_PixelTexture {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Int32 image;
	struct X3D_Node *metadata;
	int repeatS;
	int repeatT;
	struct X3D_Node *textureProperties;
	void * _parentResource;
	int __textureTableIndex;
};
extern struct X3D_Virt virt_PixelTexture;
/***********************/
struct X3D_PixelTexture3D {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Int32 image;
	struct X3D_Node *metadata;
	int repeatS;
	int repeatT;
	int repeatR;
	struct X3D_Node *textureProperties;
	int __textureTableIndex;
	void * _parentResource;
	int _needs_gradient;
};
extern struct X3D_Virt virt_PixelTexture3D;
/***********************/
struct X3D_PlaneSensor {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int autoOffset;
	struct SFRotation axisRotation;
	int enabled;
	struct SFVec2f maxPosition;
	struct SFVec2f minPosition;
	struct SFVec3f offset;
	int isActive;
	int isOver;
	struct Uni_String *description;
	struct SFVec3f trackPoint_changed;
	struct SFVec3f translation_changed;
	struct X3D_Node *metadata;
	struct SFVec3f _oldtrackPoint;
	struct SFVec3f _oldtranslation;
	struct SFVec3f _origPoint;
	int __oldEnabled;
};
extern struct X3D_Virt virt_PlaneSensor;
/***********************/
struct X3D_PointEmitter {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct SFVec3f direction;
	struct X3D_Node *metadata;
	struct SFVec3f position;
	float speed;
	float variation;
	float mass;
	float surfaceArea;
};
extern struct X3D_Virt virt_PointEmitter;
/***********************/
struct X3D_PointLight {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	float ambientIntensity;
	struct SFVec3f attenuation;
	struct SFColor color;
	int global;
	float intensity;
	struct SFVec3f location;
	struct X3D_Node *metadata;
	int on;
	float radius;
	struct SFVec4f _loc;
	struct SFVec4f _col;
	struct SFVec4f _amb;
};
extern struct X3D_Virt virt_PointLight;
/***********************/
struct X3D_PointPickSensor {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int enabled;
	struct X3D_Node *metadata;
	struct Multi_String objectType;
	struct X3D_Node *pickingGeometry;
	struct Multi_Node pickTarget;
	int isActive;
	struct Multi_Node pickedGeometry;
	struct Uni_String *intersectionType;
	struct Uni_String *sortOrder;
	struct Uni_String *matchCriterion;
	int __oldEnabled;
	struct Multi_Vec3f pickedPoint;
	int _oldisActive;
	struct Multi_Node _oldpickTarget;
	struct Multi_Node _oldpickedGeometry;
	struct Multi_Vec3f _oldpickedPoint;
	struct SFVec3f _bboxCenter;
	struct SFVec3f _bboxSize;
	struct Uni_String *set_intersectionType;
	struct Uni_String *set_sortOrder;
};
extern struct X3D_Virt virt_PointPickSensor;
/***********************/
struct X3D_PointSet {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Node attrib;
	struct X3D_Node *color;
	struct X3D_Node *coord;
	struct X3D_Node *fogCoord;
	struct X3D_Node *metadata;
	int _pointsVBO;
	int _coloursVBO;
	int _npoints;
	int _colourSize;
};
extern struct X3D_Virt virt_PointSet;
/***********************/
struct X3D_Polyline2D {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct Multi_Vec2f lineSegments;
};
extern struct X3D_Virt virt_Polyline2D;
/***********************/
struct X3D_PolylineEmitter {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Int32 set_coordIndex;
	struct X3D_Node *coord;
	struct SFVec3f direction;
	struct X3D_Node *metadata;
	float speed;
	float variation;
	struct Multi_Int32 coordIndex;
	float mass;
	float surfaceArea;
	int _method;
	int _nseg;
	void * _segs;
	void * _portions;
};
extern struct X3D_Virt virt_PolylineEmitter;
/***********************/
struct X3D_Polypoint2D {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct Multi_Vec2f point;
};
extern struct X3D_Virt virt_Polypoint2D;
/***********************/
struct X3D_PositionChaser {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	void * _p;
	void * _t;
	int isActive;
	double duration;
	double _bufferendtime;
	double _steptime;
	struct SFVec3f value_changed;
	struct SFVec3f initialDestination;
	struct SFVec3f initialValue;
	struct SFVec3f set_destination;
	struct SFVec3f set_value;
	void * _buffer;
	struct SFVec3f _previousvalue;
	struct SFVec3f _destination;
};
extern struct X3D_Virt virt_PositionChaser;
/***********************/
struct X3D_PositionChaser2D {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	void * _p;
	void * _t;
	int isActive;
	double duration;
	double _bufferendtime;
	double _steptime;
	struct SFVec2f value_changed;
	struct SFVec2f initialDestination;
	struct SFVec2f initialValue;
	struct SFVec2f set_destination;
	struct SFVec2f set_value;
	void * _buffer;
	struct SFVec2f _previousvalue;
	struct SFVec2f _destination;
};
extern struct X3D_Virt virt_PositionChaser2D;
/***********************/
struct X3D_PositionDamper {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	void * _p;
	void * _t;
	double tau;
	float tolerance;
	int isActive;
	int order;
	double _tau;
	double _lasttick;
	int _takefirstinput;
	struct SFVec3f value_changed;
	struct SFVec3f initialDestination;
	struct SFVec3f initialValue;
	struct SFVec3f set_destination;
	struct SFVec3f set_value;
	void * _values;
	struct SFVec3f _input;
};
extern struct X3D_Virt virt_PositionDamper;
/***********************/
struct X3D_PositionDamper2D {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	void * _p;
	void * _t;
	double tau;
	float tolerance;
	int isActive;
	int order;
	double _tau;
	double _lasttick;
	int _takefirstinput;
	struct SFVec2f value_changed;
	struct SFVec2f initialDestination;
	struct SFVec2f initialValue;
	struct SFVec2f set_destination;
	struct SFVec2f set_value;
	void * _values;
	struct SFVec2f _input;
};
extern struct X3D_Virt virt_PositionDamper2D;
/***********************/
struct X3D_PositionInterpolator {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	float set_fraction;
	struct Multi_Float key;
	struct Multi_Vec3f keyValue;
	struct X3D_Node *metadata;
	struct SFVec3f value_changed;
};
extern struct X3D_Virt virt_PositionInterpolator;
/***********************/
struct X3D_PositionInterpolator2D {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	float set_fraction;
	struct Multi_Float key;
	struct Multi_Vec2f keyValue;
	struct X3D_Node *metadata;
	struct SFVec2f value_changed;
};
extern struct X3D_Virt virt_PositionInterpolator2D;
/***********************/
struct X3D_PrimitivePickSensor {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int enabled;
	struct X3D_Node *metadata;
	struct Multi_String objectType;
	struct X3D_Node *pickingGeometry;
	struct Multi_Node pickTarget;
	int isActive;
	struct Multi_Node pickedGeometry;
	struct Uni_String *intersectionType;
	struct Uni_String *sortOrder;
	struct Uni_String *matchCriterion;
	int __oldEnabled;
};
extern struct X3D_Virt virt_PrimitivePickSensor;
/***********************/
struct X3D_ProgramShader {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int activate;
	struct X3D_Node *metadata;
	struct Multi_Node programs;
	int isSelected;
	int isValid;
	struct Uni_String *language;
	int _initialized;
	int _shaderUserNumber;
	pthread_t _shaderLoadThread;
	int _retrievedURLData;
};
extern struct X3D_Virt virt_ProgramShader;
/***********************/
struct X3D_ProjectionVolumeStyle {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int enabled;
	struct X3D_Node *metadata;
	float intensityThreshold;
	struct Uni_String *type;
	int _type;
};
extern struct X3D_Virt virt_ProjectionVolumeStyle;
/***********************/
struct X3D_Proto {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Node __children;
	struct X3D_Node *metadata;
	struct SFVec3f bboxCenter;
	struct SFVec3f bboxSize;
	struct Multi_Node _sortedChildren;
	struct Multi_Node addChildren;
	struct Multi_Node removeChildren;
	struct Multi_Node __sibAffectors;
	void * __protoDeclares;
	void * __externProtoDeclares;
	void * __nodes;
	void * __subcontexts;
	void * __GC;
	void * __protoDef;
	int __protoFlags;
	struct X3D_Node *__prototype;
	struct X3D_Node *__parentProto;
	void * __ROUTES;
	void * __EXPORTS;
	void * __IMPORTS;
	void * __DEFnames;
	void * __IS;
	void * __scripts;
	struct Multi_String url;
	struct Multi_String __oldurl;
	void * __afterPound;
	int __loadstatus;
	void * _parentResource;
	void * __loadResource;
	void * __typename;
	int load;
	int __oldload;
};
extern struct X3D_Virt virt_Proto;
/***********************/
struct X3D_ProximitySensor {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct SFVec3f center;
	struct SFVec3f size;
	int enabled;
	int isActive;
	struct SFVec3f position_changed;
	struct SFRotation orientation_changed;
	double enterTime;
	double exitTime;
	struct SFVec3f centerOfRotation_changed;
	struct X3D_Node *metadata;
	int __hit;
	struct SFVec3f __t1;
	struct SFRotation __t2;
	int __oldEnabled;
};
extern struct X3D_Virt virt_ProximitySensor;
/***********************/
struct X3D_QuadSet {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Node attrib;
	struct X3D_Node *color;
	struct X3D_Node *coord;
	struct X3D_Node *fogCoord;
	struct X3D_Node *metadata;
	struct X3D_Node *normal;
	struct X3D_Node *texCoord;
	int ccw;
	int colorPerVertex;
	int normalPerVertex;
	int solid;
	struct Multi_Int32 _coordIndex;
};
extern struct X3D_Virt virt_QuadSet;
/***********************/
struct X3D_ReceiverPdu {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Uni_String *address;
	int applicationID;
	int enabled;
	int entityID;
	struct X3D_Node *metadata;
	struct Uni_String *multicastRelayHost;
	int multicastRelayPort;
	struct Uni_String *networkMode;
	int port;
	int radioID;
	float readInterval;
	float receivedPower;
	int receiverState;
	int rtpHeaderExpected;
	int siteID;
	int transmitterApplicationID;
	int transmitterEntityID;
	int transmitterRadioID;
	int transmitterSiteID;
	int whichGeometry;
	float writeInterval;
	int isActive;
	int isNetworkReader;
	int isNetworkWriter;
	int isRtpHeaderHeard;
	int isStandAlone;
	double timestamp;
	struct SFVec3f bboxCenter;
	struct SFVec3f bboxSize;
};
extern struct X3D_Virt virt_ReceiverPdu;
/***********************/
struct X3D_Rectangle2D {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct SFVec2f size;
	int solid;
	struct Multi_Vec3f __points;
	int __numPoints;
};
extern struct X3D_Virt virt_Rectangle2D;
/***********************/
struct X3D_RigidBody {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	float angularDampingFactor;
	struct SFVec3f angularVelocity;
	int autoDamp;
	int autoDisable;
	struct SFVec3f centerOfMass;
	float disableAngularSpeed;
	float disableLinearSpeed;
	float disableTime;
	int enabled;
	struct SFVec3f finiteRotationAxis;
	int fixed;
	struct Multi_Vec3f forces;
	struct Multi_Node geometry;
	struct SFMatrix3f inertia;
	float linearDampingFactor;
	struct SFVec3f linearVelocity;
	float mass;
	struct X3D_Node *massDensityModel;
	struct X3D_Node *metadata;
	struct SFRotation orientation;
	struct SFVec3f position;
	struct Multi_Vec3f torques;
	int useFiniteRotation;
	int useGlobalGravity;
	void * _body;
	struct SFVec3f __old_angularVelocity;
	struct SFVec3f __old_centerOfMass;
	struct SFVec3f __old_finiteRotationAxis;
	struct SFVec3f __old_linearVelocity;
	struct SFRotation __old_orientation;
	struct SFVec3f __old_position;
	void * _geomIdentityTransform;
};
extern struct X3D_Virt virt_RigidBody;
/***********************/
struct X3D_RigidBodyCollection {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Node set_contacts;
	int autoDisable;
	struct Multi_Node bodies;
	float constantForceMix;
	float contactSurfaceThickness;
	float disableAngularSpeed;
	float disableLinearSpeed;
	float disableTime;
	int enabled;
	float errorCorrection;
	struct SFVec3f gravity;
	int iterations;
	struct Multi_Node joints;
	float maxCorrectionSpeed;
	struct X3D_Node *metadata;
	int preferAccuracy;
	struct X3D_Node *collider;
	void * _world;
	void * _group;
};
extern struct X3D_Virt virt_RigidBodyCollection;
/***********************/
struct X3D_ScalarChaser {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	void * _p;
	void * _t;
	int isActive;
	double duration;
	double _bufferendtime;
	double _steptime;
	float value_changed;
	float initialDestination;
	float initialValue;
	float set_destination;
	float set_value;
	void * _buffer;
	float _previousvalue;
	float _destination;
};
extern struct X3D_Virt virt_ScalarChaser;
/***********************/
struct X3D_ScalarDamper {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	void * _p;
	void * _t;
	double tau;
	float tolerance;
	int isActive;
	int order;
	double _tau;
	double _lasttick;
	int _takefirstinput;
	float value_changed;
	float initialDestination;
	float initialValue;
	float set_destination;
	float set_value;
	void * _values;
	float _input;
};
extern struct X3D_Virt virt_ScalarDamper;
/***********************/
struct X3D_ScalarInterpolator {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	float set_fraction;
	struct Multi_Float key;
	struct Multi_Float keyValue;
	struct X3D_Node *metadata;
	float value_changed;
};
extern struct X3D_Virt virt_ScalarInterpolator;
/***********************/
struct X3D_ScreenFontStyle {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct Multi_String family;
	int horizontal;
	struct Multi_String justify;
	struct Uni_String *language;
	int leftToRight;
	float pointSize;
	float spacing;
	struct Uni_String *style;
	int topToBottom;
};
extern struct X3D_Virt virt_ScreenFontStyle;
/***********************/
struct X3D_ScreenGroup {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Node addChildren;
	struct Multi_Node removeChildren;
	struct Multi_Node __sibAffectors;
	struct Multi_Node children;
	struct X3D_Node *metadata;
	struct SFVec3f bboxCenter;
	struct SFVec3f bboxSize;
};
extern struct X3D_Virt virt_ScreenGroup;
/***********************/
struct X3D_Script {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_String url;
	int directOutput;
	int mustEvaluate;
	struct X3D_Node *metadata;
	void * __scriptObj;
	void * _parentResource;
};
extern struct X3D_Virt virt_Script;
/***********************/
struct X3D_SegmentedVolumeData {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct SFVec3f dimensions;
	struct X3D_Node *metadata;
	struct X3D_Node *voxels;
	struct SFVec3f bboxCenter;
	struct SFVec3f bboxSize;
	void * _boxtris;
	struct Multi_Node renderStyle;
	struct Multi_Bool segmentEnabled;
	struct X3D_Node *segmentIdentifiers;
};
extern struct X3D_Virt virt_SegmentedVolumeData;
/***********************/
struct X3D_ShadedVolumeStyle {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int enabled;
	struct X3D_Node *metadata;
	struct X3D_Node *surfaceNormals;
	int lighting;
	int shadows;
	struct X3D_Node *material;
	struct Uni_String *phaseFunction;
	int _phaseFunction;
};
extern struct X3D_Virt virt_ShadedVolumeStyle;
/***********************/
struct X3D_ShaderPart {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct Multi_String url;
	struct Uni_String *type;
	int __loadstatus;
	void * _parentResource;
	void * __loadResource;
	struct X3D_Node *_shaderUserDefinedFields;
};
extern struct X3D_Virt virt_ShaderPart;
/***********************/
struct X3D_ShaderProgram {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct Multi_String url;
	struct Uni_String *type;
	int __loadstatus;
	void * _parentResource;
	void * __loadResource;
	struct X3D_Node *_shaderUserDefinedFields;
};
extern struct X3D_Virt virt_ShaderProgram;
/***********************/
struct X3D_Shape {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *appearance;
	struct X3D_Node *geometry;
	struct X3D_Node *metadata;
	struct SFVec3f bboxCenter;
	struct SFVec3f bboxSize;
	int _shaderflags_base;
	int _shaderflags_effects;
	int _shaderflags_usershaders;
	int __visible;
	int __occludeCheckCount;
	int __Samples;
};
extern struct X3D_Virt virt_Shape;
/***********************/
struct X3D_SignalPdu {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Uni_String *address;
	int applicationID;
	struct Multi_Int32 data;
	int dataLength;
	int enabled;
	int encodingScheme;
	int entityID;
	struct X3D_Node *metadata;
	struct Uni_String *multicastRelayHost;
	int multicastRelayPort;
	struct Uni_String *networkMode;
	int port;
	int radioID;
	float readInterval;
	int rtpHeaderExpected;
	int sampleRate;
	int samples;
	int siteID;
	int tdlType;
	int whichGeometry;
	float writeInterval;
	int isActive;
	int isNetworkReader;
	int isNetworkWriter;
	int isRtpHeaderHeard;
	int isStandAlone;
	double timestamp;
	struct SFVec3f bboxCenter;
	struct SFVec3f bboxSize;
};
extern struct X3D_Virt virt_SignalPdu;
/***********************/
struct X3D_SilhouetteEnhancementVolumeStyle {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int enabled;
	struct X3D_Node *metadata;
	struct X3D_Node *surfaceNormals;
	float silhouetteBoundaryOpacity;
	float silhouetteRetainedOpacity;
	float silhouetteSharpness;
};
extern struct X3D_Virt virt_SilhouetteEnhancementVolumeStyle;
/***********************/
struct X3D_SingleAxisHingeJoint {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct SFVec3f anchorPoint;
	struct SFVec3f axis;
	struct X3D_Node *body1;
	struct X3D_Node *body2;
	struct Multi_String forceOutput;
	float maxAngle;
	struct X3D_Node *metadata;
	float minAngle;
	float stopBounce;
	float stopErrorCorrection;
	float angle;
	float angleRate;
	struct SFVec3f body1AnchorPoint;
	struct SFVec3f body2AnchorPoint;
	void * _joint;
	int _forceout;
	struct SFVec3f __old_anchorPoint;
	struct SFVec3f __old_axis;
	struct X3D_Node *__old_body1;
	struct X3D_Node *__old_body2;
};
extern struct X3D_Virt virt_SingleAxisHingeJoint;
/***********************/
struct X3D_SliderJoint {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct SFVec3f axis;
	struct X3D_Node *body1;
	struct X3D_Node *body2;
	struct Multi_String forceOutput;
	float maxSeparation;
	struct X3D_Node *metadata;
	float minSeparation;
	float sliderForce;
	float stopBounce;
	float stopErrorCorrection;
	float separation;
	float separationRate;
	void * _joint;
	int _forceout;
	struct SFVec3f __old_axis;
	struct X3D_Node *__old_body1;
	struct X3D_Node *__old_body2;
};
extern struct X3D_Virt virt_SliderJoint;
/***********************/
struct X3D_Sound {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct SFVec3f direction;
	float intensity;
	struct SFVec3f location;
	float maxBack;
	float maxFront;
	struct X3D_Node *metadata;
	float minBack;
	float minFront;
	float priority;
	struct X3D_Node *source;
	int spatialize;
	int __sourceNumber;
	struct SFVec3f __lastlocation;
	double __lasttime;
};
extern struct X3D_Virt virt_Sound;
/***********************/
struct X3D_Sphere {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	float radius;
	int solid;
	struct Multi_Vec3f __points;
	int _sideVBO;
	int __SphereIndxVBO;
	void * __pindices;
	int __wireindicesVBO;
};
extern struct X3D_Virt virt_Sphere;
/***********************/
struct X3D_SphereSensor {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int autoOffset;
	int enabled;
	struct SFRotation offset;
	int isActive;
	struct SFRotation rotation_changed;
	struct SFVec3f trackPoint_changed;
	struct SFVec3f _oldtrackPoint;
	struct SFRotation _oldrotation;
	int isOver;
	struct Uni_String *description;
	struct X3D_Node *metadata;
	struct SFVec3f _origPoint;
	struct SFVec3f _origNormalizedPoint;
	float _radius;
	int __oldEnabled;
};
extern struct X3D_Virt virt_SphereSensor;
/***********************/
struct X3D_SplinePositionInterpolator {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	float set_fraction;
	int closed;
	struct Multi_Float key;
	struct Multi_Vec3f keyValue;
	struct Multi_Vec3f keyVelocity;
	struct X3D_Node *metadata;
	int normalizeVelocity;
	struct SFVec3f value_changed;
	struct Multi_Vec3f _T0;
	struct Multi_Vec3f _T1;
};
extern struct X3D_Virt virt_SplinePositionInterpolator;
/***********************/
struct X3D_SplinePositionInterpolator2D {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	float set_fraction;
	int closed;
	struct Multi_Float key;
	struct Multi_Vec2f keyValue;
	struct Multi_Vec2f keyVelocity;
	struct X3D_Node *metadata;
	int normalizeVelocity;
	struct SFVec2f value_changed;
	struct Multi_Vec2f _T0;
	struct Multi_Vec2f _T1;
};
extern struct X3D_Virt virt_SplinePositionInterpolator2D;
/***********************/
struct X3D_SplineScalarInterpolator {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	float set_fraction;
	int closed;
	struct Multi_Float key;
	struct Multi_Float keyValue;
	struct Multi_Float keyVelocity;
	struct X3D_Node *metadata;
	int normalizeVelocity;
	float value_changed;
	struct Multi_Float _T0;
	struct Multi_Float _T1;
};
extern struct X3D_Virt virt_SplineScalarInterpolator;
/***********************/
struct X3D_SpotLight {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	float ambientIntensity;
	struct SFVec3f attenuation;
	float beamWidth;
	struct SFColor color;
	float cutOffAngle;
	struct SFVec3f direction;
	int global;
	float intensity;
	struct SFVec3f location;
	struct X3D_Node *metadata;
	int on;
	float radius;
	struct SFVec4f _dir;
	struct SFVec4f _loc;
	struct SFVec4f _col;
	struct SFVec4f _amb;
};
extern struct X3D_Virt virt_SpotLight;
/***********************/
struct X3D_SquadOrientationInterpolator {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	float set_fraction;
	struct Multi_Float key;
	struct Multi_Rotation keyValue;
	struct X3D_Node *metadata;
	int normalizeVelocity;
	int closed;
	struct SFRotation value_changed;
	struct Multi_Float _normkey;
	struct Multi_Rotation _normkeyValue;
};
extern struct X3D_Virt virt_SquadOrientationInterpolator;
/***********************/
struct X3D_StaticGroup {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct Multi_Node children;
	struct SFVec3f bboxCenter;
	struct SFVec3f bboxSize;
	struct Multi_Node __sibAffectors;
	int __transparency;
	int __solid;
	struct Multi_Node _sortedChildren;
};
extern struct X3D_Virt virt_StaticGroup;
/***********************/
struct X3D_StringSensor {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int deletionAllowed;
	int enabled;
	struct Uni_String *enteredText;
	struct Uni_String *finalText;
	int isActive;
	struct X3D_Node *metadata;
	int _initialized;
	int __oldEnabled;
};
extern struct X3D_Virt virt_StringSensor;
/***********************/
struct X3D_SurfaceEmitter {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Int32 set_coordIndex;
	struct X3D_Node *metadata;
	float speed;
	float variation;
	struct Multi_Int32 coordIndex;
	float mass;
	struct X3D_Node *surface;
	float surfaceArea;
	struct X3D_Node *geometry;
	void * _ifs;
};
extern struct X3D_Virt virt_SurfaceEmitter;
/***********************/
struct X3D_Switch {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Node addChildren;
	struct Multi_Node removeChildren;
	struct Multi_Node __sibAffectors;
	struct Multi_Node choice;
	struct Multi_Node children;
	struct X3D_Node *metadata;
	int whichChoice;
	struct SFVec3f bboxCenter;
	struct SFVec3f bboxSize;
	int __isX3D;
};
extern struct X3D_Virt virt_Switch;
/***********************/
struct X3D_Teapot {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	int solid;
	void * __ifsnode;
};
extern struct X3D_Virt virt_Teapot;
/***********************/
struct X3D_TexCoordChaser2D {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	void * _p;
	void * _t;
	int isActive;
	double duration;
	double _bufferendtime;
	double _steptime;
	struct Multi_Vec2f value_changed;
	struct Multi_Vec2f initialDestination;
	struct Multi_Vec2f initialValue;
	struct Multi_Vec2f set_destination;
	struct Multi_Vec2f set_value;
	void * _buffer;
	struct Multi_Vec2f _previousvalue;
	struct Multi_Vec2f _destination;
};
extern struct X3D_Virt virt_TexCoordChaser2D;
/***********************/
struct X3D_TexCoordDamper2D {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	void * _p;
	void * _t;
	double tau;
	float tolerance;
	int isActive;
	int order;
	double _tau;
	double _lasttick;
	int _takefirstinput;
	struct Multi_Vec2f value_changed;
	struct Multi_Vec2f initialDestination;
	struct Multi_Vec2f initialValue;
	struct Multi_Vec2f set_destination;
	struct Multi_Vec2f set_value;
	void * _values;
	struct Multi_Vec2f _input;
};
extern struct X3D_Virt virt_TexCoordDamper2D;
/***********************/
struct X3D_Text {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *fontStyle;
	struct Multi_Float length;
	float maxExtent;
	struct X3D_Node *metadata;
	struct Multi_String string;
	struct Multi_Vec2f lineBounds;
	struct SFVec3f origin;
	int solid;
	struct SFVec2f textBounds;
	int _isScreen;
	void * _screendata;
};
extern struct X3D_Virt virt_Text;
/***********************/
struct X3D_TextureBackground {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int set_bind;
	struct Multi_Float groundAngle;
	struct Multi_Color groundColor;
	struct Multi_Float skyAngle;
	struct Multi_Color skyColor;
	double bindTime;
	int isBound;
	int _layerId;
	struct X3D_Node *metadata;
	void * _parentResource;
	struct Multi_Vec3f __points;
	struct Multi_Vec3f __colours;
	int __quadcount;
	int __VBO;
	struct X3D_Node *frontTexture;
	struct X3D_Node *backTexture;
	struct X3D_Node *topTexture;
	struct X3D_Node *bottomTexture;
	struct X3D_Node *leftTexture;
	struct X3D_Node *rightTexture;
	struct Multi_Float transparency;
};
extern struct X3D_Virt virt_TextureBackground;
/***********************/
struct X3D_TextureCoordinate {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct Multi_Vec2f point;
};
extern struct X3D_Virt virt_TextureCoordinate;
/***********************/
struct X3D_TextureCoordinate3D {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct Multi_Vec3f point;
};
extern struct X3D_Virt virt_TextureCoordinate3D;
/***********************/
struct X3D_TextureCoordinate4D {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct Multi_Vec4f point;
};
extern struct X3D_Virt virt_TextureCoordinate4D;
/***********************/
struct X3D_TextureCoordinateGenerator {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct Uni_String *mode;
	struct Multi_Float parameter;
};
extern struct X3D_Virt virt_TextureCoordinateGenerator;
/***********************/
struct X3D_TextureProperties {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	float anisotropicDegree;
	struct SFColorRGBA borderColor;
	int borderWidth;
	struct Uni_String *boundaryModeS;
	struct Uni_String *boundaryModeT;
	struct Uni_String *boundaryModeR;
	struct Uni_String *magnificationFilter;
	struct X3D_Node *metadata;
	struct Uni_String *minificationFilter;
	struct Uni_String *textureCompression;
	float texturePriority;
	int generateMipMaps;
};
extern struct X3D_Virt virt_TextureProperties;
/***********************/
struct X3D_TextureTransform {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct SFVec2f center;
	struct X3D_Node *metadata;
	float rotation;
	struct SFVec2f scale;
	struct SFVec2f translation;
};
extern struct X3D_Virt virt_TextureTransform;
/***********************/
struct X3D_TextureTransform3D {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct SFVec3f center;
	struct X3D_Node *metadata;
	struct SFRotation rotation;
	struct SFVec3f scale;
	struct SFVec3f translation;
};
extern struct X3D_Virt virt_TextureTransform3D;
/***********************/
struct X3D_TextureTransformMatrix3D {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct SFMatrix4f matrix;
};
extern struct X3D_Virt virt_TextureTransformMatrix3D;
/***********************/
struct X3D_TimeSensor {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	double cycleInterval;
	int enabled;
	int loop;
	struct X3D_Node *metadata;
	double pauseTime;
	double resumeTime;
	double startTime;
	double stopTime;
	double cycleTime;
	double elapsedTime;
	float fraction_changed;
	int isActive;
	double isPaused;
	double time;
	double __inittime;
	double __ctflag;
	int __oldEnabled;
	double __lasttime;
};
extern struct X3D_Virt virt_TimeSensor;
/***********************/
struct X3D_TimeTrigger {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int set_boolean;
	double triggerTime;
	struct X3D_Node *metadata;
};
extern struct X3D_Virt virt_TimeTrigger;
/***********************/
struct X3D_ToneMappedVolumeStyle {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int enabled;
	struct X3D_Node *metadata;
	struct X3D_Node *surfaceNormals;
	struct SFColorRGBA coolColor;
	struct SFColorRGBA warmColor;
};
extern struct X3D_Virt virt_ToneMappedVolumeStyle;
/***********************/
struct X3D_TouchSensor {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int enabled;
	struct SFVec3f hitNormal_changed;
	struct SFVec3f hitPoint_changed;
	struct SFVec2f hitTexCoord_changed;
	struct SFVec3f _oldhitNormal;
	struct SFVec3f _oldhitPoint;
	struct SFVec2f _oldhitTexCoord;
	int isActive;
	int isOver;
	struct Uni_String *description;
	double touchTime;
	struct X3D_Node *metadata;
	int __oldEnabled;
};
extern struct X3D_Virt virt_TouchSensor;
/***********************/
struct X3D_TrackingSensor {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int enabled;
	struct SFVec3f position;
	struct SFRotation rotation;
	int isActive;
	struct Uni_String *description;
	struct X3D_Node *metadata;
	int isPositionAvailable;
	int isRotationAvailable;
};
extern struct X3D_Virt virt_TrackingSensor;
/***********************/
struct X3D_Transform {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Node addChildren;
	struct Multi_Node removeChildren;
	struct Multi_Node __sibAffectors;
	struct SFVec3f center;
	struct Multi_Node children;
	struct X3D_Node *metadata;
	struct SFRotation rotation;
	struct SFVec3f scale;
	struct SFRotation scaleOrientation;
	struct SFVec3f translation;
	struct SFVec3f bboxCenter;
	struct SFVec3f bboxSize;
	int __do_center;
	int __do_trans;
	int __do_rotation;
	int __do_scaleO;
	int __do_scale;
	int __do_anything;
	struct Multi_Node _sortedChildren;
};
extern struct X3D_Virt virt_Transform;
/***********************/
struct X3D_TransformSensor {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct SFVec3f center;
	struct SFVec3f size;
	int enabled;
	int isActive;
	struct SFVec3f position_changed;
	struct SFRotation orientation_changed;
	double enterTime;
	double exitTime;
	struct X3D_Node *targetObject;
	struct X3D_Node *metadata;
	int __hit;
	struct SFVec3f __t1;
	struct SFRotation __t2;
	int __oldEnabled;
};
extern struct X3D_Virt virt_TransformSensor;
/***********************/
struct X3D_TransmitterPdu {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Uni_String *address;
	struct SFVec3f antennaLocation;
	int antennaPatternLength;
	int antennaPatternType;
	int applicationID;
	int cryptoKeyID;
	int cryptoSystem;
	int enabled;
	int entityID;
	int frequency;
	int inputSource;
	int lengthOfModulationParameters;
	struct X3D_Node *metadata;
	int modulationTypeDetail;
	int modulationTypeMajor;
	int modulationTypeSpreadSpectrum;
	int modulationTypeSystem;
	struct Uni_String *multicastRelayHost;
	int multicastRelayPort;
	struct Uni_String *networkMode;
	int port;
	float power;
	int radioEntityTypeCategory;
	int radioEntityTypeCountry;
	int radioEntityTypeDomain;
	int radioEntityTypeKind;
	int radioEntityTypeNomenclature;
	int radioEntityTypeNomenclatureVersion;
	int radioID;
	float readInterval;
	struct SFVec3f relativeAntennaLocation;
	int rtpHeaderExpected;
	int siteID;
	float transmitFrequencyBandwidth;
	int transmitState;
	int whichGeometry;
	float writeInterval;
	int isActive;
	int isNetworkReader;
	int isNetworkWriter;
	int isRtpHeaderHeard;
	int isStandAlone;
	double timestamp;
	struct SFVec3f bboxCenter;
	struct SFVec3f bboxSize;
};
extern struct X3D_Virt virt_TransmitterPdu;
/***********************/
struct X3D_TriangleFanSet {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Node attrib;
	struct X3D_Node *color;
	struct X3D_Node *coord;
	struct Multi_Int32 fanCount;
	struct X3D_Node *fogCoord;
	struct X3D_Node *metadata;
	struct X3D_Node *normal;
	struct X3D_Node *texCoord;
	int ccw;
	int colorPerVertex;
	int normalPerVertex;
	int solid;
	struct Multi_Int32 _coordIndex;
};
extern struct X3D_Virt virt_TriangleFanSet;
/***********************/
struct X3D_TriangleSet {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Node attrib;
	struct X3D_Node *color;
	struct X3D_Node *coord;
	struct X3D_Node *fogCoord;
	struct X3D_Node *metadata;
	struct X3D_Node *normal;
	struct X3D_Node *texCoord;
	int ccw;
	int colorPerVertex;
	int normalPerVertex;
	int solid;
	struct Multi_Int32 _coordIndex;
};
extern struct X3D_Virt virt_TriangleSet;
/***********************/
struct X3D_TriangleSet2D {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct X3D_Node *metadata;
	struct Multi_Vec2f vertices;
	int solid;
	struct Multi_Vec2f __texCoords;
	void * __wireindices;
};
extern struct X3D_Virt virt_TriangleSet2D;
/***********************/
struct X3D_TriangleStripSet {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Node attrib;
	struct X3D_Node *color;
	struct X3D_Node *coord;
	struct X3D_Node *fogCoord;
	struct X3D_Node *metadata;
	struct X3D_Node *normal;
	struct Multi_Int32 stripCount;
	struct X3D_Node *texCoord;
	int ccw;
	int colorPerVertex;
	int normalPerVertex;
	int solid;
	struct Multi_Int32 _coordIndex;
};
extern struct X3D_Virt virt_TriangleStripSet;
/***********************/
struct X3D_TwoSidedMaterial {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	float ambientIntensity;
	float backAmbientIntensity;
	struct SFColor backDiffuseColor;
	struct SFColor backEmissiveColor;
	float backShininess;
	struct SFColor backSpecularColor;
	float backTransparency;
	struct SFColor diffuseColor;
	struct SFColor emissiveColor;
	struct X3D_Node *metadata;
	float shininess;
	int separateBackColor;
	struct SFColor specularColor;
	float transparency;
	struct Multi_Float _verifiedFrontColor;
	struct Multi_Float _verifiedBackColor;
};
extern struct X3D_Virt virt_TwoSidedMaterial;
/***********************/
struct X3D_UniversalJoint {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct SFVec3f anchorPoint;
	struct SFVec3f axis1;
	struct SFVec3f axis2;
	struct X3D_Node *body1;
	struct X3D_Node *body2;
	struct X3D_Node *metadata;
	struct Multi_String forceOutput;
	float stop1Bounce;
	float stop1ErrorCorrection;
	float stop2Bounce;
	float stop2ErrorCorrection;
	struct SFVec3f body1AnchorPoint;
	struct SFVec3f body1Axis;
	struct SFVec3f body2AnchorPoint;
	struct SFVec3f body2Axis;
	void * _joint;
	int _forceout;
	struct SFVec3f __old_anchorPoint;
	struct SFVec3f __old_axis1;
	struct SFVec3f __old_axis2;
	struct X3D_Node *__old_body1;
	struct X3D_Node *__old_body2;
};
extern struct X3D_Virt virt_UniversalJoint;
/***********************/
struct X3D_Viewpoint {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int set_bind;
	double bindTime;
	int isBound;
	struct Uni_String *description;
	int jump;
	float fieldOfView;
	struct X3D_Node *metadata;
	struct SFRotation orientation;
	struct SFVec3f position;
	int _layerId;
	int _donethispass;
	struct SFVec3f centerOfRotation;
	int retainUserOffsets;
	struct Uni_String *fovMode;
	float aspectRatio;
};
extern struct X3D_Virt virt_Viewpoint;
/***********************/
struct X3D_ViewpointGroup {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct SFVec3f center;
	struct Multi_Node children;
	struct Uni_String *description;
	int displayed;
	struct X3D_Node *metadata;
	int retainUserOffsets;
	struct SFVec3f size;
	struct X3D_Node *__proxNode;
};
extern struct X3D_Virt virt_ViewpointGroup;
/***********************/
struct X3D_Viewport {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Node addChildren;
	struct Multi_Node removeChildren;
	struct Multi_Node __sibAffectors;
	struct Multi_Node children;
	struct X3D_Node *metadata;
	struct Multi_Float clipBoundary;
	struct SFVec3f bboxCenter;
	struct SFVec3f bboxSize;
};
extern struct X3D_Virt virt_Viewport;
/***********************/
struct X3D_VisibilitySensor {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct SFVec3f center;
	int enabled;
	struct SFVec3f size;
	double enterTime;
	double exitTime;
	int isActive;
	struct X3D_Node *metadata;
	int __visible;
	int __occludeCheckCount;
	struct Multi_Vec3f __points;
	int __Samples;
	int __oldEnabled;
};
extern struct X3D_Virt virt_VisibilitySensor;
/***********************/
struct X3D_VolumeData {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct SFVec3f dimensions;
	struct X3D_Node *metadata;
	struct X3D_Node *voxels;
	struct SFVec3f bboxCenter;
	struct SFVec3f bboxSize;
	void * _boxtris;
	struct X3D_Node *renderStyle;
};
extern struct X3D_Virt virt_VolumeData;
/***********************/
struct X3D_VolumeEmitter {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_Int32 set_coordIndex;
	struct X3D_Node *coord;
	struct SFVec3f direction;
	struct X3D_Node *metadata;
	float speed;
	float variation;
	struct Multi_Int32 coordIndex;
	int internal;
	float mass;
	float surfaceArea;
	void * _ifs;
};
extern struct X3D_Virt virt_VolumeEmitter;
/***********************/
struct X3D_VolumePickSensor {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	int enabled;
	struct X3D_Node *metadata;
	struct Multi_String objectType;
	struct X3D_Node *pickingGeometry;
	struct Multi_Node pickTarget;
	int isActive;
	struct Multi_Node pickedGeometry;
	struct Uni_String *intersectionType;
	struct Uni_String *sortOrder;
	struct Uni_String *matchCriterion;
	int __oldEnabled;
};
extern struct X3D_Virt virt_VolumePickSensor;
/***********************/
struct X3D_WindPhysicsModel {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct SFVec3f direction;
	int enabled;
	float gustiness;
	struct X3D_Node *metadata;
	float speed;
	float turbulence;
	float _frameSpeed;
};
extern struct X3D_Virt virt_WindPhysicsModel;
/***********************/
struct X3D_WorldInfo {
       int _nodeType; /* unique integer for each type */ 
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       int _ichange; 
       struct Vector* _parentVector; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       struct X3D_PolyRep *_intern; 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
       void* _gc; /* ptr to vector of ptrs to free */
       struct X3D_Node* _executionContext; /* scene or protoInstance */
 	/*** node specific data: *****/
	struct Multi_String info;
	struct Uni_String *title;
	struct X3D_Node *metadata;
};
extern struct X3D_Virt virt_WorldInfo;
extern struct X3D_Virt* virtTable[];

extern const int *NODE_OFFSETS[];

int getSAI_X3DNodeType (int FreeWRLNodeType);

#endif /* __FREEWRL_STRUCTS_H__ */
